<!-- Bug Comments (28012008) -->
<% 

const ORDER_BY_NEWEST_FIRST = "1"
const ORDER_BY_OLDEST_FIRST = "2"

Dim g_strBugCommentOrderBy
Dim g_bBugCommentsExist

BugCommentsPageStartUp()

'--------------------------------------------------------------------------------------------------------
Function BugCommentsPageStartUp()

	g_strBugCommentOrderBy = GetBugCommentOrderBy()
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetBugCommentOrderBy()

	Dim strRtnValue
	
	strRtnValue = GetCookie("bug_comment_order_by")
	
	if (strRtnValue = "") then
		strRtnValue = ORDER_BY_NEWEST_FIRST 'set default
	end if
	
	GetBugCommentOrderBy = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetBugCommentQuote(strInputBugCommentID)

	const IMG_DOTTED_LINE = "<img src=""images_layout/dotted_line.gif"" width=""288"" height=""1"" alt="""" border=""0"">"

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	if (IsNull(strInputBugCommentID) = false) then

		strSqlQuery = "SELECT comment " & _
									"FROM tbl_bug_comments " & _
									"WHERE id_bug_comment = " & strInputBugCommentID
		
		Set objRecordSet = GetRecordSet(strSqlQuery)
		
		if (NOT objRecordSet.EOF) then
			strRtnValue = "<span class=""bug_comment_quote_text"">" & IMG_DOTTED_LINE & "<br/><b>RE:</b>&nbsp;" & Trim(objRecordSet("comment")) & IMG_DOTTED_LINE & "</span>" 
		end if
			
		objRecordSet.Close
		Set objRecordSet = Nothing
	
	end if
	
	GetBugCommentQuote = strRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------
Function RenderBugCommentLine(ByRef rsInputComment, iInputBugCommentNumber, iInputTotalNumberOfComments)

	Dim strAccountTypeIcon
	Dim strTimeIcon
	Dim strBugCommentQuote
	
	Dim strLastCommentBorderAdjustment
	Dim strCommentBy
		
	strBugCommentQuote = GetBugCommentQuote( rsInputComment("quote_bug_id") )
	
	'adjust the border of the last bug comment so it looks good within the containing div.
	if (iInputBugCommentNumber = iInputTotalNumberOfComments) then
		strLastCommentBorderAdjustment = " style=""border-bottom: none;"" "
	end if
	
	if (g_iAccessPrivShowFullNames = INT_TRUE) then
		strCommentBy = "<span title=""" & rsInputComment("user_full_name") & """ class=""tool_tip"">" & rsInputComment("first_name") & "</span>"
	else
		strCommentBy = rsInputComment("initials")
	end if
	
	
	%>
	<div <%= strLastCommentBorderAdjustment %> class="bug_comments_container">
	
	
	<div class="bug_comment_number"><%= iInputBugCommentNumber %></div>
	<div class="comment_metadata_container">
	On <span class="tool_tip" title="<%= rsInputComment("time_of_comment") %>"><%= Replace(DBDate( rsInputComment("date_of_comment")), " ", "/") %></span>, <%= strCommentBy %><%= GetAccuntTypeMiniIcon() %> said...

	<div class="comment_icons_container">
	
	<% 'admin level can edit/delete any comment. developers and clients can only affect comments they have added.
	if ( g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_ADMIN) then	%>
	
		<a href="<%= g_strPageName %>?page_mode=<%= EDIT_COMMENT %>&bug_id=<%= g_strBugID %>&comment_id=<%= rsInputComment("id_bug_comment") %>" class="image_button"><%= ICON_EDIT_COMMENT %></a>
		<a onclick="ConfirmCommentDelete(<%= rsInputComment("id_bug_comment") %>); return false;" href="<%= g_strPageName %>" class="image_button"><%= ICON_DELETE_COMMENT %></a>
		
	<% elseif ( CStr(g_iUserID) = CStr(rsInputComment("comment_by_user_id")) ) then %>
	
		<a href="<%= g_strPageName %>?page_mode=<%= EDIT_COMMENT %>&bug_id=<%= g_strBugID %>&comment_id=<%= rsInputComment("id_bug_comment") %>" class="image_button">
		<%= ICON_EDIT_COMMENT %></a><a onclick="ConfirmCommentDelete(<%= rsInputComment("id_bug_comment") %>); return false;" href="<%= g_strPageName %>" class="image_button"><%= ICON_DELETE_COMMENT %></a>
		
	<% else %>
	
		<%= ICON_EDIT_COMMENT_DISABLED %><%= ICON_DELETE_COMMENT_DISABLED %>
		
	<% end if %>
	</div>	
		
	</div><!-- comment_metadata_container -->
			
	<% if ( rsInputComment("visible_to_client") = INT_FALSE) then	%>
		<%= ICON_INVISIBLE_TO_CLIENT %>
	<% end if %>
	
	<%= strBugCommentQuote %>
	
	<span class="bug_comment_text"><%= Trim(rsInputComment("comment")) %></span>
	</div>
	<%  				
								
End Function
'--------------------------------------------------------------------------------------------------------
Function GetAccountTypeIcon(iInputAccountTypeID)

	Dim strRtnValue

	Select Case iInputAccountTypeID
	
		Case ACCOUNT_TYPE_ID_ADMIN
			strRtnValue = "<span class=""account_type_mock_icon"" title=""Account Type: Administrator"">A</span>"
			'"<img border=""0"" src=""images/icon_account_type_admin.gif"" alt=""(Administrator)"" title=""(Administrator)"" width=""8"" height=""9"" class=""icon_comments"">"
		
		Case ACCOUNT_TYPE_ID_DEVELOPER
			strRtnValue = "<span class=""account_type_mock_icon"" title=""Account Type: Developer"">D</span>"
			'"<img border=""0"" src=""images/icon_account_type_dev.gif"" alt=""(Developer)"" title=""(Developer)"" width=""8"" height=""9"" class=""icon_comments"">"
		
		Case ACCOUNT_TYPE_ID_CLIENT
			strRtnValue = "<span class=""account_type_mock_icon"" title=""Account Type: Client"">C</span>"
			'"<img border=""0"" src=""images/icon_account_type_client.gif"" alt=""(Client)"" title=""(Client)"" width=""8"" height=""9"" class=""icon_comments"">"
			
		Case Else
			strRtnValue = "<span class=""account_type_mock_icon"" title=""Error: unknown account type"">Er</span>"
			'"<img border=""0"" src=""images/icon_account_type_error.gif"" alt=""(Error: account type unknown)"" title=""(Error: account type unknown)"" width=""8"" height=""9"" class=""icon_comments"">"
	
	End Select
	
	GetAccountTypeIcon = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawBugCommentsHTML()

	Dim strSqlQuery
	Dim objRecordSet
	Dim iBugCommentNumber
	
	Dim strOrderBySql
	Dim iTotalNumberOfComments
	Dim strCommentMajorContainerHeight
	
	Dim strExtrClientOnlySql
			
	if (g_strBugCommentOrderBy = ORDER_BY_NEWEST_FIRST) then
		strOrderBySql = "DESC"
	else
		strOrderBySql = "ASC"
	end if
			
	if (g_strPageMode = EDIT_COMMENT) OR (g_rsUserAccountDetails("use_add_comment_safe_mode") = INT_TRUE) then
		strCommentMajorContainerHeight = "385px"
	else
		strCommentMajorContainerHeight = "525px"
	end if
	
	if (g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_CLIENT) then
		strExtrClientOnlySql = " AND (tbl_bug_comments.visible_to_client = 1) "
	end if

	'the comments system should only be displayed if a bug is being edited (no point adding comments to a bug just being entered).
	if (NOT g_strPageMode = LOG_BUG_MODE_NEW_ENTRY) then
	
		strSqlQuery = "SELECT tbl_users.first_name + ' ' + tbl_users.last_name AS user_full_name, tbl_users.first_name, tbl_users.initials, tbl_bug_comments.*, tbl_users.id_user_account_type " & _
									"FROM tbl_users INNER JOIN tbl_bug_comments ON tbl_users.id_user = tbl_bug_comments.comment_by_user_id " & _
									"WHERE (tbl_bug_comments.has_been_deleted = 0) AND (((tbl_bug_comments.belongs_to_bug_id)=" & g_strBugID & ")) " & _
									strExtrClientOnlySql & _
									"ORDER BY tbl_bug_comments.id_bug_comment " & strOrderBySql
									
		Set objRecordSet = GetRecordSet(strSqlQuery)
		iBugCommentNumber = 1
				
		if (objRecordSet.EOF) then
			g_bBugCommentsExist = false
		else
			g_bBugCommentsExist = true
			iTotalNumberOfComments = objRecordSet.RecordCount
		end if
		
		%>
		<table class="tbl_standard" cellspacing="0" cellpadding="0" style="width: 362px;">
		<tr>
			<td class="table_sub_headling">Comments</td>
			<td><div style="float: right; margin: 0 0 6px 0;"><% DrawBugCommentsOrderByDroplist() %></div></td>
		</tr>
		</table>
		<div class="bug_comments_major_container" id="major_bug_comment_container" style="height: <%= strCommentMajorContainerHeight %>;">
		<%
		
		Do Until objRecordSet.EOF
			Call RenderBugCommentLine(objRecordSet, iBugCommentNumber, iTotalNumberOfComments)
			objRecordSet.MoveNext
			iBugCommentNumber = iBugCommentNumber + 1
		Loop
		
		objRecordSet.Close
		Set objRecordSet = Nothing
		
		%>
		</div>
		<table class="tbl_standard" cellspacing="0" cellpadding="0" style="width: 362px;">
		<tr>
			<td colspan="2"><% DrawAddCommentHTML() %></td>
		</tr>
		</table>
		<%  

	end if

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawAddCommentHTML() 

	Dim strQueryString
	Dim strAddCommentBoxInitialState
	Dim strAddCommentButtonInitialState
	
	if (g_strPageMode = EDIT_COMMENT) then
		strAddCommentBoxInitialState = "inline-block"
		strAddCommentButtonInitialState = "none"
	else
		strAddCommentBoxInitialState = "none"
		strAddCommentButtonInitialState = "inline-block"
	end if
	
	'check if the user is using 'add comment' safe mode setting
	if (g_rsUserAccountDetails("use_add_comment_safe_mode") = INT_TRUE) then
		strAddCommentBoxInitialState = "inline-block"
		strAddCommentButtonInitialState = "none"
	end if 
			
	%>
	<script type="text/javascript">
	 
	function ToggleAddCommentVisibility()	
	{
	
		if (document.getElementById("add_bug_comment").style.display == "none")
		{
			document.getElementById("add_bug_comment").style.display = "block";
			document.getElementById("add_comment_button").style.display = "none";
			document.getElementById("major_bug_comment_container").style.height = "380px";
		}
		else
		{	
			document.getElementById("add_bug_comment").style.display = "none";
			document.getElementById("add_comment_button").style.display = "block";
			document.getElementById("major_bug_comment_container").style.height = "525px";		
		}

	}
	
	function ValidateBugComment(iInputPageMode)
	{

		var iErrorFree;
		var bVisibleToClient
		iErrorFree = 1;
		
		
		
		if (document.getElementById("bug_comment_textarea").value == '')
		{

			document.getElementById("bug_comment_textarea").style.backgroundColor = '#FFB7B7';
			document.getElementById('bug_comment_textarea').style.backgroundRepeat = 'no-repeat';
			document.getElementById('bug_comment_textarea').style.backgroundImage = 'url(images_layout/text_required_field_white_wide.gif)';
			document.getElementById("bug_comment_textarea").focus();
			iErrorFree = 0;
			return false;	
		}
		
		//alert(document.getElementById('quote_comment_drop_list').selectedIndex);
		if (iErrorFree == 1) //there are no more errors, submit the form.
		{
			
			<% 
			strQueryString = strQueryString & "&txt_bug_comment=' + QueryStringSafe(document.getElementById('bug_comment_textarea').value) + '" & _
																				"&drp_quote_comment_id=' + document.getElementById('quote_comment_drop_list').value + '" & _
																				"&chk_comment_visible_to_client=' + document.getElementById('comment_visible_to_client').checked + '"
			
			'if we are editing a comment, we need to send the comment id via querystring too
			if (g_strPageMode = EDIT_COMMENT) then
				strQueryString = strQueryString & "&comment_id=' + document.getElementById('comment_id').value + '"
			end if																				
			%>
			
			document.getElementById("log_bug_form").action = '<%= g_strPageName %>?save_operation=1&page_mode=' + iInputPageMode + '&bug_id=<%= g_strBugID %><%= strQueryString %>';
			document.getElementById("log_bug_form").submit();
		}

	
	}
	
	function ResetAddCommentBkg()	
	{	
		if (document.getElementById("bug_comment_textarea").style.backgroundColor == 'rgb(255, 183, 183)') 
	 		document.getElementById("bug_comment_textarea").style.backgroundColor = '#ffffff';
	}
	
	
	function ConfirmCommentDelete(iInputCommentID)
	{
	
		var bAnswer = confirm('Delete comment?')
		
		if (bAnswer == true) 
		{
			document.getElementById("log_bug_form").action = '<%= g_strPageName %>?save_operation=1&page_mode=<%= DELETE_COMMENT %>&bug_id=<%= g_strBugID %>&comment_id=' + iInputCommentID;
			document.getElementById("log_bug_form").submit();
		}
		
	}
	
	</script>	
	
	<% if (g_rsUserAccountDetails("use_add_comment_safe_mode") = INT_TRUE) then %>

	<% else %>
		<div id="add_comment_button" class="ctrl_button_small ctrl_float button_spacer" style="margin: 7px 0 0 0; display: <%= strAddCommentButtonInitialState %>"><a href="javascript:void();" onclick="ToggleAddCommentVisibility(); return false;">Add Comment</a></div>
	<% end if %>
		
	<div id="add_bug_comment" class="bug_add_comments_container" style="width: 338px; display: <%= strAddCommentBoxInitialState %>;">
	<span class="table_sub_headling" style="padding-bottom: 1px;">Add Comment</span>
	<textarea id="bug_comment_textarea" rows="5" name="txt_bug_comment" class="ctrl_textarea" style="width: 326px; margin: 0 0 5px 0;" onkeydown="ResetAddCommentBkg();"><%= Replace(g_strComment, "<br/>", vbCrLf) %></textarea>
	
	<%= GetQuoteCommentDroplist(g_strQuoteCommentID) %>
	<%= GetCommentVisibleToClientCheckbox(g_iCommentIsVisibleToClient) %>
	
	<% if (g_strPageMode = EDIT_COMMENT) then %>
	
		<div class="small_spacer"></div>
		<div class="ctrl_button_small ctrl_float button_spacer" style="margin-left: 0px;"><a href="javascript:void();" onclick="ValidateBugComment(<%= UPDATE_COMMENT %>); return false;">Update</a></div>
		<a href="<%= g_strPageName %>?save_operation=0&bug_id=<%= g_strBugID %>" class="image_button cancel_link">Cancel</a>
		
		<input type="hidden" id="comment_id" value="<%= Request.QueryString("comment_id") %>"  name="hid_comment_id">
		
	<% else %>
	
		<div class="medium_spacer"></div>
		<div class="ctrl_button_small ctrl_float button_spacer" style="margin-left: 0px;"><a href="javascript:void();" onclick="ValidateBugComment(<%= ADD_COMMENT %>); return false;">Save</a></div>
		<a href="javascript:void(0);" onclick="document.getElementById('bug_comment_textarea').value=''; ToggleAddCommentVisibility(); return false;" class="image_button cancel_link">Cancel</a>
		
	<% end if %>
	
	</div>
	<%  

End Function
'--------------------------------------------------------------------------------------------------------
Function GetCommentVisibleToClientCheckbox(iInputIsChecked)

	Dim strRtnValue
	Dim strCheckedStatus
	
	'default status is checked, client sees comment by default
	if (Trim(iInputIsChecked) = "") then
		strCheckedStatus = " checked"
	else
	
		if (iInputIsChecked = INT_TRUE) then
			strCheckedStatus = " checked"
		elseif (iInputIsChecked = INT_FALSE) then
			strCheckedStatus = ""
		end if
		
	end if

	'this option is only available to admin and developer level users.
	if ( (g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_ADMIN) OR (g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_DEVELOPER) ) then
		strRtnValue = "<img src=""images_icons/icon_dotted_arrow.png"" alt="""" style=""margin: 0 0 0 3px;"" /><input type=""checkbox"" id=""comment_visible_to_client"" name=""chk_comment_visible_to_client"" value=""1"" " & strCheckedStatus & " style=""margin: 0 2px 0 0;""><span title=""Visible to client"" class=""tool_tip"">VtC</span>"
	else
		strRtnValue = "<br/><input type=""checkbox"" id=""comment_visible_to_client"" name=""chk_comment_visible_to_client"" value=""1"" checked style=""visibility: hidden;"">" 'needs to be here for getelementbyid JS validation to work.
	end if	
	
	GetCommentVisibleToClientCheckbox = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetQuoteCommentDroplist(iInputPreSelectedID)

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	Dim strListOptions
	Dim strDroplistHeader
	Dim strDroplistFooter
	
	Dim strFirstDroplistItem
	
	'only get comments related to this bug (it would become unwieldy after a time if all bug comments were made available).
	strSqlQuery = "SELECT id_bug_comment, comment " & _
								"FROM tbl_bug_comments " & _
								"WHERE (has_been_deleted = 0) AND (belongs_to_bug_id = " & g_strBugID & ") " & _
								"ORDER BY date_of_comment DESC;"

	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (objRecordSet.EOF) then
	
		strRtnValue =	"" & _
									"<select disabled=""true"" id=""quote_comment_drop_list"" name=""drp_quote_comment_id"" class=""ctrl_drop_list"" style=""width: 275px;"">" & vbCrLf & _
									"<option value="""">(No comments available)</option>" & vbCrLf & _
									"</select>"
									
	else

		if (iInputPreSelectedID = 0 OR IsNull(iInputPreSelectedID) = true ) then
			strFirstDroplistItem = "(Refer to existing comment...)"
		else
			strFirstDroplistItem = "(Remove quote reference)"	
		end if
	
		strDroplistHeader = "" & _
												"<select  id=""quote_comment_drop_list"" name=""drp_quote_comment_id"" class=""ctrl_drop_list"" style=""width: 275px;"">" & vbCrLf & _
												"<option value="""">" & strFirstDroplistItem & "</option>" & vbCrLf
		strDroplistFooter = "</select>"

		Do Until objRecordSet.EOF
			'we cannot allow a comment to reference itself.
			if (NOT CStr(objRecordSet("id_bug_comment")) = Request.QueryString("comment_id") ) then
				strListOptions = strListOptions & "<option " & IsSelected(objRecordSet("id_bug_comment"), iInputPreSelectedID) & " value=""" & objRecordSet("id_bug_comment") & """>" & TruncateString(objRecordSet("comment"), 38) & "</option>" & vbCrLf
			end if
			objRecordSet.MoveNext
		Loop

		strRtnValue = strDroplistHeader & strListOptions & strDroplistFooter
	end if
	
	objRecordSet.Close
	Set objRecordSet = Nothing
	
	GetQuoteCommentDroplist = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawBugCommentsOrderByDroplist()

	Dim strDropListState
	Dim strSortByLableCss
	
	if (g_bBugCommentsExist = false) then
		strDropListState = "disabled"
		strSortByLableCss = "bug_comment_sort_by_disabled"
	else
		strSortByLableCss = "bug_comment_sort_by"
	end if

	%>
	<script type="text/javascript">
	
	function SetCommentOrderBy()	
	{	
		createCookie('bug_comment_order_by', document.getElementById("order_by_drop_list").value, 2000);
		document.getElementById("log_bug_form").action = '<%= g_strPageName %>?bug_id=<%= g_strBugID %>';
		document.getElementById('log_bug_form').submit();
	}
	</script>	
	
	
	<select <%= strDropListState %> id="order_by_drop_list" name="drp_order_comments_by" class="ctrl_drop_list ctrl_drop_list_small ctrl_float" onchange="SetCommentOrderBy();">
		<option <%= IsSelected(g_strBugCommentOrderBy, ORDER_BY_NEWEST_FIRST) %> value="<%= ORDER_BY_NEWEST_FIRST %>">Newest First</option>
		<option <%= IsSelected(g_strBugCommentOrderBy, ORDER_BY_OLDEST_FIRST) %>value="<%= ORDER_BY_OLDEST_FIRST %>">Oldest First</option>
	</select>
	<%  

End Function
'--------------------------------------------------------------------------------------------------------
%>