<!-- Email Engine v2 (27062008) -->
<%
const METHOD_CDOSYS = "93"
const METHOD_JMAIL = "94"
const METHOD_CDONTS = "95"

'--------------------------------------------------------------------------------------------------------
Function SendEmail(strInputTo, strInputFrom, strInputSubject, strInputMessageBody, strInputDebugModeEnabled, strInputSettingSendEmailsVia, strInputArrSettingsSmtpServer)
	
	if (strInputDebugModeEnabled = "1") then
	
		Call DrawEmailDebugIframeHTML(strInputTo, strInputFrom, strInputSubject, strInputMessageBody)
		
	else

		Select Case strInputSettingSendEmailsVia
	
			Case METHOD_CDOSYS
				Call SendEmailMethodThreeCDOSYS(strInputTo, strInputFrom, strInputSubject, strInputMessageBody, strInputArrSettingsSmtpServer)
		
			Case METHOD_CDONTS
				Call SendEmailCDONTS(strInputTo, strInputFrom, strInputSubject, strInputMessageBody)
	
			Case METHOD_JMAIL
				Call SendEmailJMail(strInputTo, strInputFrom, strInputSubject, strInputMessageBody, 3)
		
		End Select
		
	end if
	
End Function 
'--------------------------------------------------------------------------------------------------------
Function SendEmailMethodOneCDOSYS(strInputTo, strInputFrom, strInputSubject, strInputMessageBody)

	'Method 1 - Local Pickup Directory where server is running SMTP Virtual Server. involves sending email using a 
	'local pickup directory. Meaning you have the IIS SMTP Virtual Server Running. If you are on a local development 
	'machine this is probably for you. Under this scenario any emails you send from your scripts put a ".eml" file in 
	'the local pickup directory. Then hopefully the SMTP Virtual Server grabs the file and sends it off. 
	'The Virtual SMTP server is however known to hiccup and not send out the emails right away.

	Dim ObjSendMail
	Dim iConf
	Dim Flds
	    
	Set ObjSendMail = Server.CreateObject("CDO.Message")
	Set iConf = CreateObject("CDO.Configuration")
	Set Flds = iConf.Fields
	    
	Flds("http://schemas.microsoft.com/cdo/configuration/sendusing") = 1
	    
	'Path below may need to be changed if it is not correct
	Flds("http://schemas.microsoft.com/cdo/configuration/smtpserverpickupdirectory") = "c:\inetpub\mailroot\pickup"
	Flds.Update
	    
	Set ObjSendMail.Configuration = iConf
	
	ObjSendMail.To = strInputTo
	ObjSendMail.Subject = strInputSubject
	ObjSendMail.From = strInputFrom
	    
	ObjSendMail.HTMLBody = strInputMessageBody
	ObjSendMail.Send
	    
	Set ObjSendMail = Nothing

End Function
'--------------------------------------------------------------------------------------------------------
Function SendEmailMethodTwoCDOSYS(strInputTo, strInputFrom, strInputSubject, strInputMessageBody)

	'Method 2 ( Using mail forwarding on port 25 ). involves port forwarding. I am not exactly sure how you set that up on the 
	'server but the code I wrote for it works under that scenario. The hosting company known as Verio actually implements this with 
	'CDOSYS on their servers. 

	%>
	<!--METADATA TYPE="typelib" UUID="CD000000-8B95-11D1-82DB-00C04FB1625D" NAME="CDO for Windows Library" -->
	<!--METADATA TYPE="typelib" UUID="00000205-0000-0010-8000-00AA006D2EA4" NAME="ADODB Type Library" --> 
	<%  
	
	Dim ObjSendMail
	Dim iConf
	Dim Flds
	    
	Set ObjSendMail = Server.CreateObject("CDO.Message")
	Set iConf = Server.CreateObject("CDO.Configuration")
	    
	Set Flds = iConf.Fields
	With Flds
		.Item(cdoSendUsingMethod) = 2
		.Item(cdoSMTPServer) = "localhost"
		.Item(cdoSMTPServerPort) = 25
		.Item(cdoSMTPconnectiontimeout) = 10
		.Update
	End With
	    
	Set ObjSendMail.Configuration = iConf
	    
	Set ObjSendMail.Configuration = iConf
	ObjSendMail.To = strInputTo
	ObjSendMail.Subject = strInputSubject
	ObjSendMail.From = strInputFrom
	    
	ObjSendMail.HTMLBody = strInputMessageBody
	ObjSendMail.Send
	    
	Set ObjSendMail = Nothing
	Set iConf = Nothing
	Set Flds = Nothing
	
End Function
'--------------------------------------------------------------------------------------------------------
Function SendEmailMethodThreeCDOSYS(strInputTo, strInputFrom, strInputSubject, strInputMessageBody, strInputArrSettingsSmtpServer)

	'Method 3 ( Using remote mail server). Method 3 involves sending the email using a remote mail server. 
	'This supports outgoing SMTP authentication should your server require that for outgoing emails. Many do these days. 
	'This method is also the best method to use because you are using a real email server with valid MX records. 
	'Many modern email systems block emails that do not have valid MX records and you want your emails to reach the recipients.

	Dim strSmtpServer
	Dim strServerPort
	Dim strUsername

	Dim strPassword
	Dim bUseSSL
	Dim ObjSendMail
	
	strSmtpServer = strInputArrSettingsSmtpServer(0)
	strServerPort = strInputArrSettingsSmtpServer(1)
	strUsername = strInputArrSettingsSmtpServer(2)
	strPassword = strInputArrSettingsSmtpServer(3)
	bUseSSL = CBool(strInputArrSettingsSmtpServer(4))
	
	Set ObjSendMail = CreateObject("CDO.Message")
	    
	'This section provides the configuration information for the remote SMTP server.
	ObjSendMail.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendusing") = 2 'Send the message using the network (SMTP over the network).
	ObjSendMail.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserver") = strSmtpServer
	ObjSendMail.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserverport") = strServerPort
	ObjSendMail.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpusessl") = bUseSSL 'Use SSL for the connection (True or False)
	ObjSendMail.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout") = 60
	    
	' If your server requires outgoing authentication uncomment the lines bleow and use a valid email address and password.
	ObjSendMail.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = 1 'basic (clear-text) authentication
	ObjSendMail.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendusername") = strUsername
	ObjSendMail.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendpassword") = strPassword
	    
	ObjSendMail.Configuration.Fields.Update
	    
	ObjSendMail.To = strInputTo
	ObjSendMail.Subject = strInputSubject
	ObjSendMail.From = strInputFrom
	    
	' we are sending a text email.. simply switch the comments around to send an html email instead
	ObjSendMail.HTMLBody = strInputMessageBody
	    
	ObjSendMail.Send
	Set ObjSendMail = Nothing 
	
End Function
'--------------------------------------------------------------------------------------------------------
Function SendEmailMethodFourCDOSYS(strInputTo, strInputFrom, strInputSubject, strInputMessageBody, strInputArrSettingsSmtpServer)

	%>
	<!--
	  METADATA
	  TYPE="typelib"
	  UUID="CD000000-8B95-11D1-82DB-00C04FB1625D" 
	  NAME="CDO for Windows 2000 Library"
	--> 
	<%  
	
	Dim strSmtpServer
	Dim strServerPort
	Dim bUseSSL

	Dim strUsername
	Dim strPassword
	
	Dim cdoConfig
	Dim cdoMessage
	
	strSmtpServer = strInputArrSettingsSmtpServer(0)
	strServerPort = strInputArrSettingsSmtpServer(1)
	strUsername = strInputArrSettingsSmtpServer(2)
	strPassword = strInputArrSettingsSmtpServer(3)
	bUseSSL = CBool(strInputArrSettingsSmtpServer(4))
	
  Set cdoConfig = CreateObject("CDO.Configuration") 

  With cdoConfig.Fields 
      .Item(cdoSendUsingMethod) = cdoSendUsingPort 
      .Item(cdoSMTPServer) = strSmtpServer 
      .Update 
  End With

  Set cdoMessage = CreateObject("CDO.Message") 

  With cdoMessage
      Set .Configuration = cdoConfig
      .From = strInputFrom
      .To = strInputTo
      .Subject = strInputSubject
      .TextBody = strInputMessageBody
      .Send
  End With

  Set cdoMessage = Nothing 
  Set cdoConfig = Nothing
	
End Function
'--------------------------------------------------------------------------------------------------------
Function IsDevServer()

	Dim bRtnValue

	if (  (InStr(Request.ServerVariables("SERVER_NAME"), "192.") <> 0) OR _
		  	(InStr(Request.ServerVariables("SERVER_NAME"), "localhost") <> 0) ) then
		bRtnValue = true
	end if

	IsDevServer = bRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawEmailDebugIframeHTML(strInputTo, strInputFrom, strInputSubject, strInputMessageBody)

	'put the message body into a session variable (its just easier for debugging purposes)
	Session("message_body") = "<b>To (Email): </b>" & strInputTo & "<br/>" & _
													 	"<b>From (Email): </b>" & strInputFrom & "<br/>" & _
														"<b>Email Subject: </b>" & strInputSubject & "<br/><br/>" & _
														strInputMessageBody
														
	response.write "<br/><iframe frameborder=""1"" scrolling=""yes"" width=""550"" height=""225"" src=""debug_email.asp"" name=""debug_email""></iframe>"
			
End Function			
'--------------------------------------------------------------------------------------------------------
Function SendEmailCDONTS(strInputTo, strInputFrom, strInputSubject, strInputMessageBody)

	Dim objEmail

	Set objEmail = server.CreateObject("CDONTS.NewMail")

	objEmail.mailFormat = 0
	objEmail.bodyFormat = 0
	
	objEmail.From = strInputFrom 				'This is the address that the email is coming from.
	objEmail.To = strInputTo 						'This is the email address that you are sending to.
	objEmail.Subject = strInputSubject 	'The subject as it will appear in the email.
	objEmail.body = Replace(strInputMessageBody, vbCrLf, "<br>")

	objEmail.Send 'Send the message out.
	Set objEmail = nothing 'Clean up after yourself.

End Function
'--------------------------------------------------------------------------------------------------------
Function SendEmailJMail(strInputTo, strInputFrom, strInputSubject, strInputMsg, iInputImportance)

	Dim JMail
	Set JMail = Server.CreateObject("JMail.SMTPMail")

	JMail.ServerAddress = "smtp-au.server-mail.com"
	JMail.AddHeader "X-Originating-IP", Request.ServerVariables("REMOTE_ADDR")
	JMail.AddHeader "X-Originating-URL", Request.ServerVariables("URL")
	JMail.Priority = iInputImportance
	JMail.Sender = strInputFrom
	JMail.AddRecipient strInputTo
	JMail.Subject = strInputSubject
	JMail.ContentType = "text/html"
	JMail.Body = strInputMsg
	
	JMail.Execute
	
	'release resources
	JMail.Close      
	set JMail = nothing

End Function
'--------------------------------------------------------------------------------------------------------
Function GetHtmlHeader(strInputTitleTag)

	Dim strRtnValue
	
	strRtnValue = "<html>" & _
								"<head><meta http-equiv=""Content-Type"" content=""text/html; charset=windows-1252"">" & _
								"<title>" & strInputTitleTag & "</title>" & _
								"<style type=""text/css"">"  & _ 
								"body, td { font-family: Verdana; font-size: 11px; } " & _
								".major_heading	{font-size: 18px; font-weight: bold; padding-bottom: 5px; display: block;	} " & _
								".general_table_header { padding-top: 1px; padding-bottom: 1px;	padding-right: 2px;	padding-left: 2px;background-color: #E6E6E6;font-weight: bold;border: 1px solid #CCCCCC; color: #4A4A4A; line-height: normal; }" & _
								".general_table_cells {padding-top: 1px;	padding-bottom: 2px; padding-right: 2px; padding-left: 2px;	border-collapse: collapse;	border: 1px solid #CCCCCC;	color: #4A4A4A;	line-height: normal;}" & _
								".col_number_01 { width: 100px; text-align: right;} " & _
								".col_number_02 { width: 400px; text-align: left; } " & _
								".tbl_general_100_percent_width {border-collapse: collapse; 	width: 100%; }" & _
								".small_note {	display: block; font-family: Verdana;	font-size: 8px;	color: #8e8e8e; }" & _
								"</style>" & _
								"</head><body>" & _
							  "<table cellpadding=""0"" cellspacing=""0"" style=""border-collapse: collapse;"" width=""500"">"
									
	GetHtmlHeader = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetHtmlFooter()
	
	Dim strRtnValue

	strRtnValue = "</table></body></html>"
		 
	GetHtmlFooter = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function CreateEmailSection(strInputSectionTitle, strInputSectionBody, strInputBkgColour)

	Dim strRtnValue
	
	if (strInputSectionTitle = "") then
		strRtnValue = "<tr>" & _
									"<td colspan=""2"" style=""padding-top: 5px;"">" & _
									strInputSectionBody & _
									"</td>" & _
									"</tr>"
	else
		strRtnValue = "<tr>" & _
									"<td class=""col_number_01"" style=""padding: 2px; padding-right: 5px; border: 1px solid #808080; background: " & strInputBkgColour & """><b>" & strInputSectionTitle & "</b></td>" & _
									"<td class=""col_number_02"" style=""padding: 2px; padding-left: 5px; border: 1px solid #808080;"">" & strInputSectionBody & "</td>" & _
									"</tr>"
	end if								
	
	CreateEmailSection = strRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------

%>