<!-- Global Functions (30012007) -->
<% 
Dim g_strContentPageName

'--------------------------------------------------------------------------------------------------------
Function GetHtmlControlType(iInputSysConfigID, strInputSettingName, strInputSettingValue, strInputExpectedValueSize)

	Dim strRtnValue

	Select Case strInputExpectedValueSize
	
		Case "S"
			strRtnValue = "<input type=""text"" name=""" & iInputSysConfigID & """  maxlength=""" & SMALL_VALUE_MAX_LENGTH & """ value=""" & strInputSettingValue & """  class=""ctrl_textbox ctrl_textbox_small"">" & vbCrLf
			
		Case "M"
			strRtnValue = "<input type=""text"" name=""" & iInputSysConfigID & """  maxlength=""" & MEDIUM_VALUE_MAX_LENGTH & """ value=""" & strInputSettingValue & """ class=""ctrl_textbox ctrl_textbox_medium"">" & vbCrLf
	
		Case "L"
			strRtnValue = "<textarea rows=""5"" name=""" & iInputSysConfigID & """ cols=""20"" class=""ctrl_textarea ctrl_textarea_medium"">" & strInputSettingValue & "</textarea>" & vbCrLf
	
		Case "C"
			strRtnValue = "<input type=""hidden"" name=""" & iInputSysConfigID & """ name=""" & iInputSysConfigID & """ value=""0"">" & _ 
										"<input type=""checkbox"" name=""" & iInputSysConfigID & """ class=""control_checkbox_alt_02"" " & SetCheckboxState(strInputSettingValue) & " value=""1"">" & vbCrLf
		Case "D"
			strRtnValue = GetSettingDropListHTML(iInputSysConfigID, strInputSettingValue)										
										
	End Select 
	
	GetHtmlControlType = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function ThrowTerminatingErrorMessage(strInputMessage)

	response.write "<br/><span style=""font-size: 12px; font-family: Verdana; color: red;""><b>Error:</b> <i>" & strInputMessage & "</i></span>" & vbCrLf
	response.end
	
End Function
'--------------------------------------------------------------------------------------------------------
Function SetCheckBox(iInputValue)

	Dim strRtnValue
	
	if (iInputValue = INT_TRUE) then
		strRtnValue = " checked "
	else
		strRtnValue = ""	
	end if
		
	SetCheckBox = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function AdjustForPlural(strInputValue, iInputVar)

	Dim strRtnValue
	
	if (iInputVar > 1) then
		strRtnValue = strInputValue	& "s"
	else
		strRtnValue = strInputValue
	end if
	
	AdjustForPlural = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetApproxTime(strInputTime)

	Dim strRtnValue
	Dim strHour
	Dim strMinute
	Dim strMeridian
	
	strHour = Hour(strInputTime)
	strMinute = Minute(strInputTime)
				
	'round the hour up if need be.
	if (strMinute > 30) then 
		strHour = strHour + 1
	end if
	
	if (strHour >= 12) then 
		strMeridian = " pm" 
	else 
		strMeridian = " am"
	end if
	
	if (Len(strMinute) < 2) then 
		strMinute = ("0" & strMinute)
	end if

	if (strHour > 12) then 
		strHour = (strHour - 12) 
	end if

	strRtnValue = strHour & strMeridian

	GetApproxTime = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetShortTime(strInputTime)

	Dim strRtnValue
	Dim strHour
	Dim strMinute
	Dim strMeridian
	
	strHour = Hour(strInputTime)
	strMinute = Minute(strInputTime)

	if (strHour >= 12) then 
		strMeridian = " PM" 
	else 
		strMeridian = " AM"
	end if
	
	if (Len(strMinute) < 2) then 
		strMinute = ("0" & strMinute)
	end if
	
	if (strHour > 12) then 
		strHour = (strHour - 12) 
	end if

	strRtnValue = strHour & ":" & strMinute & " " & strMeridian

	GetShortTime = strRtnValue

End Function
'---------------------------------------------------------------------------------------------------
Function IsChecked(varInputID_01, varInputID_02)

	'this function can handle both strings and ints

	Dim stRtnValue
	
	if (NOT (IsNull(varInputID_01)) OR (NOT IsNull(varInputID_02)) ) then
	
		if (IsNumeric(varInputID_01) AND IsNumeric(varInputID_02)) then
		
	 		if ( Int(varInputID_01) = Int(varInputID_02) ) then
				stRtnValue = " checked "
			else
				stRtnValue = ""
			end if
			
		else
		
	 		if (varInputID_01 = varInputID_02) then
				stRtnValue = " checked "
			else
				stRtnValue = ""
			end if
								
		end if
	
	end if
	
	IsChecked = stRtnValue 

End Function
'---------------------------------------------------------------------------------------------------
Function IsSelected(varInputID_01, varInputID_02)

	'this function can handle both strings and ints

	Dim stRtnValue
	
	if (NOT (IsNull(varInputID_01)) OR (NOT IsNull(varInputID_02)) ) then
	
		if (IsNumeric(varInputID_01) AND IsNumeric(varInputID_02)) then
		
	 		if ( Int(varInputID_01) = Int(varInputID_02) ) then
				stRtnValue = " Selected "
			else
				stRtnValue = ""
			end if
			
		else
		
	 		if (varInputID_01 = varInputID_02) then
				stRtnValue = " Selected "
			else
				stRtnValue = ""
			end if
								
		end if
	
	end if
	
	IsSelected = stRtnValue 

End Function
'----------------------------------------------------------------------------------------------------------------
Function GetFriendlyFileSize(strInputFileName)
	
	Dim strRtnValue
	Dim strPathTranslated
	Dim strDownloadFolderLocation

	strPathTranslated = Request.ServerVariables("PATH_TRANSLATED")
	strDownloadFolderLocation = Left(strPathTranslated, (Len(strPathTranslated) - Len( GetPageName() ))) & DOWNLOAD_DIRECTORY & "\"
			
	if (DoesFileExist(strDownloadFolderLocation, Replace(strInputFileName, vbCrLf, "")) = 1) then
		strRtnValue = GetFileSizeGeneric(strDownloadFolderLocation & Replace(strInputFileName, vbCrLf, ""))
		strRtnValue = TreatFileSize(strRtnValue)
	else
		strRtnValue = "<i>(File Not Found)</i>"
	end if
				
	GetFriendlyFileSize	= strRtnValue

End Function
'----------------------------------------------------------------------------------------------------------------
Function TruncateString(strInputString, iInputMaxStringLength)

	Dim strRtnValue
	
	if (Len(strInputString) > iInputMaxStringLength) then
		strRtnValue = Left(strInputString, (iInputMaxStringLength - 3)) & "..."
	else																																								
		strRtnValue = strInputString
	end if
		
	TruncateString = strRtnValue

End Function
'----------------------------------------------------------------------------------------------------------------
Function GetPopupHelp(strInputTitle, strInputMsg)

	Dim strRtnValue

	'strInputMsg = Replace(strInputMsg, vbCrLf, "")
	
	strRtnValue = "<img align=""absmiddle"" src=""" & ICON_POP_UP_HELP & """ OnMouseOver=""overlib('" & Trim(strInputMsg)  & "', CAPTION, '" & strInputTitle & "');" & """ OnMouseOut=""nd();"">" & vbCrLf
	
	GetPopupHelp = strRtnValue
	
End Function
'----------------------------------------------------------------------------------------------------------------
Function GetPopupHelpDB(iInputHelpID, iInputOverlibXPos)

	Dim strRtnValue
	Dim objRecordSet
	Dim strSqlQuery
	
	Dim strHelpTitle
	Dim strHelpDescription
	
	if (g_iUserPopUpHelpStyle = POP_UP_HELP_NONE) then
		'dont show any popup help, the user has turned it off.
		Exit Function
	end if
	
	strSqlQuery = "SELECT * FROM tbl_help WHERE id_help = " & iInputHelpID
	Set objRecordSet = GetRecordSet(strSqlQuery)

	if (g_iUserPopUpHelpStyle = POP_UP_HELP_ADVANCED_ONLY) then

		'the user only wants to see pop-up help classed as advanced.
		if (objRecordSet("complexity_level") = 0) then
			Exit Function
		end if
	end if
		
	if (objRecordSet.EOF) then
		strHelpDescription = "<i>(Unknown or not specified)</i>"
	else
		strHelpDescription = "<b>" & Trim(objRecordSet("help_title")) & "</b><br/>" & Trim(objRecordSet("help_description"))
	end if 
	
	strRtnValue = GetvTipBalloon(strHelpDescription, NO_TRIGGER_TEXT, SHOW_VTIP_ICON, NO_EXTRA_CSS)
		
	'strRtnValue = "<img align=""absmiddle"" src=""" & ICON_POP_UP_HELP & """ OnMouseOver=""overlib('" & strHelpDescription & "', CAPTION, '" & TruncateString(strHelpTitle, 32) & "');" & """ OnMouseOut=""nd();"">" & vbCrLf
		
			
	objRecordSet.Close : Set objRecordSet = Nothing	
	
	GetPopupHelpDb = strRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetvTipBalloon(strpHelpText, strTriggerText, bShowIcon, strExtraCss)

	Dim strRtnValue : Dim strTipAlignCssClass : Dim strStyleWidth : Dim strBalloonTrigger
	
	if (IsEmptyString(strpHelpText) = false) then
	
		strpHelpText = Replace(strpHelpText, "->", " &rarr; ")
		
		if (bShowIcon = true) then
			strBalloonTrigger = "<img src=""images_icons/icon_help.png"" alt="""" style=""" & strExtraCss & """ class=""icon_help""/>"
		elseif (NOT strTriggerText = "") then
			strBalloonTrigger = strTriggerText
		end if
		
		if (Len(strpHelpText) > 200) then strStyleWidth = "width: 350px !important;" end if

		strRtnValue = "<span class=""tool_tip_container"">" & _
									"<span class=""vtip"" title=""" & strpHelpText & """>" & _
									strBalloonTrigger & _
									"</span></span>"
									
	end if
		
	GetvTipBalloon = strRtnValue

End Function
'----------------------------------------------------------------------------------------------------------------
Function GetHelpPopupIcon(strInputTitle, strInputMsg, strInputIconToUse, strInputExtraMouseOver, strInputExtraMouseOut)

	Dim strRtnValue
	
	strInputIconToUse = OVERLIB_HELP_ICON_DIRECTORY & strInputIconToUse

	'uses the overlib library to draw a pop-up help ion
	strRtnValue = "<img align=""absmiddle"" src=""" & strInputIconToUse & """ OnMouseOver=""overlib('" & Trim(strInputMsg)  & "', CAPTION, '" & strInputTitle & "');" & strInputExtraMouseOver & """ OnMouseOut=""nd();" & strInputExtraMouseOut & """>"
	
	GetHelpPopupIcon = strRtnValue
	
End Function
'----------------------------------------------------------------------------------------------------------------
Function DrawHelpPopupIcon(strInputTitle, strInputMsg, strInputIconToUse, strInputExtraMouseOver, strInputExtraMouseOut)

	strInputIconToUse = OVERLIB_HELP_ICON_DIRECTORY & strInputIconToUse

	'insert escape sequence for apostrophes otherwise javascript will have a conniption fit.
	strInputMsg = Replace(strInputMsg, "'", "\'")
	
	'uses the overlib library to draw a pop-up help ion
	Response.Write "<img align=""absmiddle"" src=""" & strInputIconToUse & """ OnMouseOver=""overlib('" & Trim(strInputMsg)  & "', CAPTION, '" & strInputTitle & "');" & strInputExtraMouseOver & """ OnMouseOut=""nd();" & strInputExtraMouseOut & """>"
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetRecordSet(byval strSQL)

	'given a valid SQL statement, returns a recordset with values
	const adUseClient = 3
	const adOpenForwardOnly = 0
	const adLockBatchOptimistic = 4

	'Create instance of connection object and then open the connection.
	Dim objConn
	Dim objRS

	'Create instance of recordset object and open the recordset object against a table.
	Set objRS = Server.CreateObject("ADODB.Recordset")
	
	'Setting the cursor location to client side is important to get a disconnected recordset.
	objRS.CursorLocation = adUseClient
	
	Call objRS.Open(strSQL, g_objDbConn, adOpenForwardOnly, adLockBatchOptimistic)

	'Disconnect the recordset.
	Set objRS.ActiveConnection = Nothing
	
	'return the recordset
	Set GetRecordSet = objRS

End Function
'--------------------------------------------------------------------------------------------------------
Function ConvertPageNameToHyperlink(strInputPageName)

	Dim strRtnValue
	
	strRtnValue = LCase(strInputPageName)
	strRtnValue = Replace(strRtnValue, " ", "-")
	strRtnValue = Replace(strRtnValue, "/", "-")
	strRtnValue = strRtnValue & ".asp"
	
	'handle the special case of home/index pages
	if (LCase(strInputPageName) = "home") then
		strRtnValue = "index.asp"
	end if
	
	ConvertPageNameToHyperlink = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DBDate(strInputDate)

	Dim strRtnValue
	Dim strDay
	Dim strMonth
	
	Dim strYear
	Dim strShortMonthName
	Dim strMonthName
	
	if ( IsNull(strInputDate) ) then 
		strRtnValue = ""
	elseif ( NOT IsDate(strInputDate) ) then
		strRtnValue = ""
	else
		strDay = Day(strInputDate)
		strMonth = Month(strInputDate)
		strYear = Year(strInputDate)	
		strMonthName = MonthName(strMonth)
		strShortMonthName = Left(strMonthName, 3)

	  strRtnValue = strDay & " " & strShortMonthName & " " & strYear
	end if

	DBDate = strRtnValue

End Function

'--------------------------------------------------------------------------------------------------------
Function CompactDate(strInputDate)

	Dim strRtnValue
	Dim strDay
	Dim strMonth
	
	Dim strYear
	Dim strShortMonthName
	Dim strMonthName
	
	if ( IsNull(strInputDate) ) then 
		strRtnValue = ""
	elseif ( NOT IsDate(strInputDate) ) then
		strRtnValue = ""
	else
		strDay = Day(strInputDate)
		strMonth = Month(strInputDate)
		strYear = Year(strInputDate)
		strMonthName = MonthName(strMonth)
		strShortMonthName = Left(strMonthName, 3)

	  strRtnValue = strDay & "/" & strShortMonthName & "/" & strYear
	end if

	CompactDate = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function ShortDate(strInputDate)

	Dim strRtnValue
	Dim strDay
	Dim strMonth
	
	Dim strYear
	Dim strShortMonthName
	Dim strMonthName
	
	if ( IsNull(strInputDate) ) then 
		strRtnValue = ""
	elseif ( NOT IsDate(strInputDate) ) then
		strRtnValue = ""
	else
		strDay = Day(strInputDate)
		strMonth = Month(strInputDate)
		strYear = Right(Year(strInputDate), 2)
		strMonthName = MonthName(strMonth)
		strShortMonthName = Left(strMonthName, 3)

	  strRtnValue = strDay & "-" & strShortMonthName & "-" & strYear
	end if

	ShortDate = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function Debug(strInputValue)
	
	response.write "<font color=""red"">*" & strInputValue & "*</font><br>" & vbCrLf

End Function
'--------------------------------------------------------------------------------------------------------
Function DebugX(strInputValue)
	
	response.write "<font color=""red"">*" & strInputValue & "*</font><br>" & vbCrLf
	response.end

End Function
'--------------------------------------------------------------------------------------------------------
Function GetHelpPopupIcon(strInputTitle, strInputMsg, strInputIconToUse, strInputExtraMouseOver, strInputExtraMouseOut)

	Dim strRtnValue
	
	strInputIconToUse = OVERLIB_HELP_ICON_DIRECTORY & strInputIconToUse

	'uses the overlib library to draw a pop-up help ion
	strRtnValue = "<img align=""absmiddle"" src=""" & strInputIconToUse & """ OnMouseOver=""overlib('" & Trim(strInputMsg)  & "', CAPTION, '" & strInputTitle & "');" & strInputExtraMouseOver & """ OnMouseOut=""nd();" & strInputExtraMouseOut & """>"
	
	GetHelpPopupIcon = strRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawHelpPopupIcon(strInputTitle, strInputMsg, strInputIconToUse, strInputExtraMouseOver, strInputExtraMouseOut)

	strInputIconToUse = OVERLIB_HELP_ICON_DIRECTORY & strInputIconToUse

	'insert escape sequence for apostrophes otherwise javascript will have a conniption fit.
	strInputMsg = Replace(strInputMsg, "'", "\'")
	
	'uses the overlib library to draw a pop-up help ion
	Response.Write "<img align=""absmiddle"" src=""" & strInputIconToUse & """ OnMouseOver=""overlib('" & Trim(strInputMsg)  & "', CAPTION, '" & strInputTitle & "');" & strInputExtraMouseOver & """ OnMouseOut=""nd();" & strInputExtraMouseOut & """>"
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetFileSizeGeneric(strInputFilePathAndName)
	
	Dim iRtnValue
	Dim objFileSys
	Dim objFile
	
	Set objFileSys = Server.CreateObject("Scripting.FileSystemObject")
	
	set objFile = objFileSys.GetFile(strInputFilePathAndName)
	iRtnValue = objFile.Size

	Set objFileSys = Nothing
	Set objFile = Nothing

	GetFileSizeGeneric = iRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function TreatFileSize(strInputFileSize)

	Dim strRtnValue
	
	if (Len(strInputFileSize) > 6) then
		strRtnValue = Left(strInputFileSize, Len(strInputFileSize) - 6 ) & "." & _
						 		  Mid(strInputFileSize, 2, 1) & " MB"
	else
		strRtnValue = Left(strInputFileSize, Len(strInputFileSize) - 3 ) & " KB"
	end if 

	TreatFileSize = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DoesFileExist(strInputFilePath, strInputFileName)

	Dim iRtnValue, objFileExistCheck
	
	'first check that the file really exists (trying to delete something that isnt there causes an error).
	Set objFileExistCheck=Server.CreateObject("Scripting.FileSystemObject")

	If (objFileExistCheck.FileExists(strInputFilePath & strInputFileName)) = true Then
  	iRtnValue = 1
	Else
  	iRtnValue = 0
	End If

	Set objFileExistCheck = Nothing
	
	DoesFileExist = iRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetPageName()

	'get the name of the current page
	Dim strCurrentPageName

	strCurrentPageName = Split(Request.ServerVariables("SCRIPT_NAME"),"/")
	
	GetPageName = strCurrentPageName(UBound(strCurrentPageName))
			
End Function
'--------------------------------------------------------------------------------------------------------
Function FriendlyFileName(strInputFileName)

	Dim strFriendlyFileName
	Dim strTemp
	
	if (strInputFileName = "" OR IsNull(strInputFileName) ) then
		strFriendlyFileName = ""
	else
	
		strTemp = Replace(strInputFileName,"_", " ")
		strTemp = Replace(strTemp,"-", " ")
		
		strTemp = Left(strTemp, (Len(strTemp) - 4) )
		
		strFriendlyFileName = ConvertToTitleCase(strTemp)
		
		if (strFriendlyFileName = "Index") then
			strFriendlyFileName = "Home"
		end if
	
	end if
	
	'return the friendly file name (eg.' about_us.inc' has become 'About Us')
	FriendlyFileName = Trim(strFriendlyFileName)

End Function
'--------------------------------------------------------------------------------------------------------
Function GetDropListItems(strInputItemsString)

	Dim strRtnValue
	Dim strArrSplitItems
	Dim iCounter
	Dim strPresetSubject
	Dim strSelectionMarker
	
	strArrSplitItems = Split(strInputItemsString, ",")
	strPresetSubject = Request.QueryString("preset_subject")
	
	For iCounter = 0 To UBound(strArrSplitItems)
	
		'check for a pre-set subject
		if ( Trim(Replace(strPresetSubject,"_", " ")) = Trim(LCase(strArrSplitItems(iCounter))) ) then
			strSelectionMarker = "selected"
		else
			strSelectionMarker = ""
		end if
	
		strRtnValue = strRtnValue & "<option " & strSelectionMarker & " value=""" & Trim(strArrSplitItems(iCounter)) & """>" & Trim(strArrSplitItems(iCounter)) & "</option>" & vbCrLf
	Next
	
	GetDropListItems = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function ShowCurrentPageState(strInputPageName)
	
	Dim strRtnValue

	if (strInputPageName = g_strContentPageName) then
		strRtnValue = "<b>" & strInputPageName & "</b>"
	else
		strRtnValue = strInputPageName			
	end if

	if (strInputPageName = "Home" AND GetPageName() = "index.asp") then
		strRtnValue = "<b>" & strInputPageName & "</b>"
	end if
	
	if ( (strInputPageName = "Contact") AND (GetPageName() = "contact.asp") ) then
		strRtnValue = "<b>" & strInputPageName & "</b>"
	end if

	if ( (NOT InStr(strInputPageName, "Request") = 0)  AND (GetPageName() = "contact.asp") ) then
		strRtnValue = "<b>" & strInputPageName & "</b>"
	end if
	
	ShowCurrentPageState = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetRollOverButton(strInputBtnImageNormal, strInputBtnImageHighlight, strBtnName, strInputAltTag, _
													 strInputStyle, strImagePath, strInputOnClick)

	Dim strRtnValue
	Dim strButtonImageToShow
	Dim strInactivePageOnMoustOut

	'prepare javascript code. *important* - i have intentionally left out the vbCrLfs, they stuff up the roll-overs
	Response.Write "<script type=""text/javascript"">"

	Response.Write "	img_" & strBtnName & "_normal = new Image(); "
	Response.Write "	img_" & strBtnName & "_normal.src = """ & strImagePath & strInputBtnImageNormal & """; "

	Response.Write "	img_" & strBtnName & "_highlight = new Image(); " 
	Response.Write "	img_" & strBtnName & "_highlight.src = """ & strImagePath & strInputBtnImageHighlight & """; "
		
	Response.Write "</script>"

	'a style for the button image may not have been provided.
	if strInputStyle = "" then
		strInputStyle = ""
	else
		strInputStyle = "style=""" & strInputStyle & """"
	end if
	
	'there may not be any onclick event.
	if strInputOnClick = "" then
		strInputOnClick = ""
	else
		strInputOnClick = "OnClick=""" & strInputOnClick & """"
	end if
	
	'decide which button image to use, considering this could be the active tab.
	if (InStr(strInputOnClick, GetPageName()) = 0) then
		strButtonImageToShow = strInputBtnImageNormal
		strInactivePageOnMoustOut = " OnMouseOut=""document." & strBtnName & ".src = img_" & strBtnName & "_normal.src;"""
	else
		'its the active page tab (should stay highlighted).
		strButtonImageToShow = strInputBtnImageHighlight
		strInactivePageOnMoustOut =  " "
	end if

	strRtnValue = "<img OnMouseOver=""document." & strBtnName & ".src = img_" & strBtnName & "_highlight.src;""" & strInactivePageOnMoustOut & " " & strInputStyle & " type=""image"" border=""0"" value=""" & strBtnName & """ name=""" & strBtnName & """ src=""" & strImagePath & strButtonImageToShow & """ " & strInputOnClick & ">"
	
	GetRollOverButton = strRtnValue

End Function
'------------------------------------------------------------------------------------------------------------------------
%>