<!-- Global System Logic (07072007) -->
<%
Dim g_rsUserAccountDetails
Dim g_rsAccountAccessNavigation
Dim g_strAccountTypeEnabledFor

Dim g_strOpenBugIcon
Dim g_strOnHoldBugIcon
Dim g_strClosedBugIcon

Dim g_strPriorityHighIcon
Dim g_strPriorityNormalIcon
Dim g_strPriorityLowUIIcon

Dim g_strTypeBugIcon
Dim g_strTypeFeatureRequestIcon
Dim g_strTypeGeneralIcon

Dim g_strPageName
Dim g_iActiveProjectID
Dim g_rsActiveProject

Dim g_strSystemVersion
Dim g_iRecordsToShowPerPage

Dim g_iAccessPrivSearchBox
Dim	g_iAccessPrivSummaryPanel
Dim	g_iAccessPrivLoggedInAsLabel

Dim	g_iAccessPrviSystemVersionLabel
Dim	g_iAccessPrivLogBugsButton
Dim	g_iAccessPrivNavHome

Dim	g_iAccessPrivNavOnlineHelp
Dim	g_iAccessPrivNavProjects
Dim	g_iAccessPrivNavSettings

Dim	g_iAccessPrivNavUsers
Dim	g_iAccessPrivNavMyProfile
Dim	g_iAccessPrivNavLogout

Dim	g_iAccessPrivCanApproveCosts
Dim	g_iAccessPrivShowFilterToggles
Dim	g_iAccessPrivShowAssignedToProject

Dim	g_iAccessPrivUploadFiles
Dim g_bIsClientAccount
Dim g_iUserPopUpHelpStyle

Dim g_strUploadDirectory
Dim g_iAccessPrivShowFullNames
Dim g_strActiveProjectName

Dim g_strSettingBkgWatermark
Dim g_strSettingVideoDownloadURL
Dim g_strSettingVideoStreamingURL

Dim g_strSettingBugWebFromAddress
Dim g_strSettingAdditionalMessageBody
Dim g_strSettingBugWebUrlOverRide

Dim g_strSettingTechSupporEmail
Dim g_strSettingEmailSendingIsEnabled
Dim g_strSettingDebugModeEnabled

Dim g_strSettingSendEmailsVia
Dim g_strArrSettingsSmtpServer(4)

SystemStartUp()

'--------------------------------------------------------------------------------------------------------
Function SystemStartUp()

	g_strActiveProjectName = "Project Unknown"
	
	g_strPageName = GetPageName()
			
	GetUserAccountDetails(g_iUserID)
	
	g_iActiveProjectID = GetActiveProjectID()
	
	GetSystemGlobalSettings()

	GetActiveProjectDetails(g_iActiveProjectID)
	
	g_strOpenBugIcon = ICON_BUG_OPEN_FILE
	g_strOnHoldBugIcon = ICON_BUG_ON_HOLD_FILE 
	g_strClosedBugIcon = ICON_BUG_CLOSED_FILE 
	
	g_strPriorityHighIcon = ICON_PRIORITY_HIGH_FILE
	g_strPriorityNormalIcon = ICON_PRIORITY_NORMAL_FILE
	g_strPriorityLowUIIcon = ICON_PRIORITY_LOW_FILE

	g_strTypeBugIcon = ICON_TYPE_BUG_FILE
	g_strTypeFeatureRequestIcon = ICON_TYPE_FEATURE_REQUEST_FILE
	g_strTypeGeneralIcon = ICON_TYPE_GENERAL_FILE
	
	g_iUserPopUpHelpStyle = g_rsUserAccountDetails("popup_help") 
	
	GetAccessPrivileges()
	
	g_strSystemVersion = SYSTEM_VERSION

	g_iRecordsToShowPerPage = GetSystemSetting(32)
	
	'some settings are different on the local dev version of the software vs a live hosting location (you can never know the directory structure for sure).
	if (Request.ServerVariables("SERVER_NAME") = DEV_SERVER) then
		g_strUploadDirectory = UPLOAD_DIRECTORY_DEV
	else
		g_strUploadDirectory = UPLOAD_DIRECTORY_LIVE
	end if

End Function
'--------------------------------------------------------------------------------------------------------
Function GetSettingGroupName(iInputGroupID)

	Dim strRtnValue
	Dim objRecordSet
	Dim strSqlQuery
		
	strSqlQuery = "SELECT tbl_one_to_one_mapping_items.item_name AS Group_Name FROM " & _
								"tbl_one_to_one_mapping_items INNER JOIN tbl_system_configuration ON " & _
								"tbl_one_to_one_mapping_items.id_item = tbl_system_configuration.id_belongs_to_group " & _
								"WHERE id_item = " & iInputGroupID

	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (objRecordSet.EOF) then
		strRtnValue = "Error: group name not found based on supplied ID."
	else
		strRtnValue = objRecordSet("Group_Name")
	end if
		
	objRecordSet.Close
	Set objRecordSet = Nothing	
	
	GetSettingGroupName = strRtnValue


End Function
'--------------------------------------------------------------------------------------------------------
Function GetSystemGlobalSettings()

	Dim objRecordSet
	Dim strSqlQuery
	Dim iCounter
	
	Dim trArrGlobalSystemSettings

	strSqlQuery = "SELECT setting_value FROM tbl_system_configuration ORDER BY id_system_configuration;"
	Set objRecordSet = GetRecordSet(strSqlQuery)
		
	ReDim strArrGlobalSystemSettings(objRecordSet.RecordCount)

	For iCounter = 1 To UBound(strArrGlobalSystemSettings)
		strArrGlobalSystemSettings(iCounter) = objRecordSet("setting_value")
		objRecordSet.MoveNext
	Next
	
	g_strSettingBkgWatermark = strArrGlobalSystemSettings(9)
	g_strSettingVideoDownloadURL = strArrGlobalSystemSettings(10)
	g_strSettingVideoStreamingURL = strArrGlobalSystemSettings(11)
	g_strSettingBugWebFromAddress = strArrGlobalSystemSettings(4)
	g_strSettingAdditionalMessageBody = strArrGlobalSystemSettings(6)	
	g_strSettingBugWebUrlOverRide = strArrGlobalSystemSettings(8)	
	g_strSettingTechSupporEmail = strArrGlobalSystemSettings(14)	
	g_strSettingEmailSendingIsEnabled = strArrGlobalSystemSettings(15)	
	g_strSettingDebugModeEnabled = strArrGlobalSystemSettings(16)
	
	'email related settings
	g_strSettingSendEmailsVia = Split(strArrGlobalSystemSettings(22),",")(1)
	g_strArrSettingsSmtpServer(SMTP_SERVER) = strArrGlobalSystemSettings(17)
	g_strArrSettingsSmtpServer(SMTP_PORT) = strArrGlobalSystemSettings(18)
	g_strArrSettingsSmtpServer(SMTP_USE_SSL) = strArrGlobalSystemSettings(19)
	g_strArrSettingsSmtpServer(SMTP_USERNAME) = strArrGlobalSystemSettings(20)
	g_strArrSettingsSmtpServer(SMTP_PASSWORD) = strArrGlobalSystemSettings(21)
	
	if (trim(g_strSettingTechSupporEmail) = "") then
		g_strSettingTechSupporEmail = "{Unknown or not set}"
	end if
	
	objRecordSet.Close
	Set objRecordSet = Nothing

End Function
'-------------------------------------------------------------------------------------------------------
Function IsEmptyString(strInputValue)
	
	Dim bRtnValue
	
	if (Trim(strInputValue) = "") then
		bRtnValue = true
	elseif (IsNull(strInputValue)) then
		bRtnValue = true
	else
		bRtnValue = false
	end if
	
	IsEmptyString = bRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function URLDecode(sURL)
	
	 On Error Resume Next
	
	 'Nothing passed
	 If Len(sURL) = 0 Then
	    URLDecode = ""
	    Exit Function
	 End If
	
	 'Pluses become spaces
	 Dim sOutput
	 sOutput = Replace(sURL, "+", " ")
	
	 'Convert %hexdigits to the character
	 Dim aSplit
	 aSplit = Split(sOutput, "%")
	
	 Dim i
	 If IsArray(aSplit) Then
	   sOutput = aSplit(0)
	   For I = 0 to UBound(aSplit) - 1
	     sOutput = sOutput & _
	                 Chr("&H" & Left(aSplit(i + 1), 2)) & _
	                 Right(aSplit(i + 1), Len(aSplit(i + 1)) - 2)
	   Next
	 End If
	
	 'Pass back the decoded URL
	 URLDecode = sOutput
		
End Function
'--------------------------------------------------------------------------------------------------------
Function ShowEmailSendingStatusMsg()
	
	Dim strTurnEmailSendingOnMsg

		if (g_strSettingEmailSendingIsEnabled = STR_FALSE) then
		
		if (g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_ADMIN) then
			strTurnEmailSendingOnMsg = " (<a href=""email_settings.asp"" style=""font-size: 10px;"">go to settings</a>)."
		end if
		
		%><span class="alert_message">Email sending is currently switched off <%= strTurnEmailSendingOnMsg %></span><% 
		
	end if

End Function
'--------------------------------------------------------------------------------------------------------
Function SetCheckboxState(varInputValue)

	Dim strRtnValue
	
	if (IsNumeric(varInputValue)) then
	
		if (varInputValue = 1) then
			strRtnValue = " checked "
		else
			strRtnValue = ""	
		end if
		
	else
	
		if (varInputValue = "1") then
			strRtnValue = " checked "
		else
			strRtnValue = ""	
		end if
	
	end if
		
	SetCheckboxState = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetBugWebSystemURL()

	Dim strRtnValue
	Dim iCounter
	Dim strSystemPath
	Dim strArrPath
	
	if (Trim(g_strSettingBugWebUrlOverRide) = "") then
	
	 	strArrPath = Split(Request.ServerVariables("PATH_INFO"), "/")

		For iCounter = 1 To UBound(strArrPath)-1
			strSystemPath = strSystemPath & "/" & strArrPath(iCounter)
		Next
		
		strRtnValue = "Go to <a href=""http://" & Request.ServerVariables("SERVER_NAME") & strSystemPath & "/"">BugWeb</a>."
	else
		strRtnValue = g_strSettingBugWebUrlOverRide
	end if
	
	GetBugWebSystemURL = strRtnValue
	
End Function	
'--------------------------------------------------------------------------------------------------------
Function GetAssociatedProjectIDs()

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	strSqlQuery = "SELECT tbl_projects.id_project " & _
								"FROM tbl_user_to_project_mapping INNER JOIN tbl_projects ON tbl_user_to_project_mapping.id_project = tbl_projects.id_project " & _
								"WHERE id_user = " & g_iUserID & " ORDER BY project_name;"

	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	Do Until objRecordSet.EOF
		strRtnValue = strRtnValue & objRecordSet("id_project")
		objRecordSet.MoveNext
		
		if (NOT objRecordSet.EOF) then
			strRtnValue = strRtnValue & ", "
		end if
		
	Loop
	
	objRecordSet.Close
	Set objRecordSet = Nothing
	
	GetAssociatedProjectIDs = strRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetAssignedToName(strFirstName, strSurname, strInitials)

	Dim strRtnValue
	
	if (g_iAccessPrivShowFullNames = INT_TRUE) then
		strRtnValue = TruncateString(strFirstName, 10)
		strRtnValue = "<span title=""" & strFirstName & " " & strSurname & """ class=""tool_tip"">" & strRtnValue & "</span>"
	else
		strRtnValue = strInitials
	end if
	

	GetAssignedToName = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetIMClientNames(iInputSelectedOption)

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	'return a list of all available IM clients
	strSqlQuery = "SELECT id_item, item_name FROM tbl_one_to_one_mapping_items WHERE id_belongs_to_group = 19;"
	
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	Do Until objRecordSet.EOF
		strRtnValue = strRtnValue & "<option " & IsSelected(iInputSelectedOption, objRecordSet("id_item")) & " value=""" & objRecordSet("id_item") & """>" & objRecordSet("item_name") & "</option>" & vbCrLf
		objRecordSet.MoveNext
	Loop
				
	objRecordSet.Close
	Set objRecordSet = Nothing
		
	GetIMClientNames = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetAccessPrivileges()

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	Dim iArrAccessSettings
	Dim iCounter

	strSqlQuery = "SELECT " & g_strAccountTypeEnabledFor & " FROM [tbl_account_access_privileges] ORDER BY id_account_access_privilege;"

	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (objRecordSet.EOF) then
		response.write "Error: could not retrieve account access privilege settings."
		response.end
	end if

	ReDim iArrAccessSettings(objRecordSet.RecordCount)

	For iCounter = 1 To UBound(iArrAccessSettings)
		iArrAccessSettings(iCounter) = objRecordSet(0)
		objRecordSet.MoveNext
	Next

	g_iAccessPrivUploadFiles = iArrAccessSettings(1)
	g_iAccessPrivLogBugsButton = iArrAccessSettings(2)
	g_iAccessPrivNavHome = iArrAccessSettings(3)
	g_iAccessPrivNavOnlineHelp = iArrAccessSettings(4)
	g_iAccessPrivNavProjects = iArrAccessSettings(5)
	g_iAccessPrivNavSettings = iArrAccessSettings(6)
	g_iAccessPrivNavMyProfile = iArrAccessSettings(7)
	g_iAccessPrivNavLogout = iArrAccessSettings(8)
	g_iAccessPrivSearchBox = iArrAccessSettings(9)
	g_iAccessPrivShowFilterToggles  = iArrAccessSettings(10)
	g_iAccessPrivLoggedInAsLabel = iArrAccessSettings(11)
	g_iAccessPrivSummaryPanel = iArrAccessSettings(12)
	g_iAccessPrviSystemVersionLabel = iArrAccessSettings(13)
	g_iAccessPrivCanApproveCosts = iArrAccessSettings(14)
	g_iAccessPrivShowAssignedToProject = iArrAccessSettings(15)
	g_iAccessPrivNavUsers = iArrAccessSettings(16)
	g_iAccessPrivShowFullNames = iArrAccessSettings(17)

	'check if a person has set their interface style to basic
	if (g_rsUserAccountDetails("interface_style") = UI_STYLE_BASIC) then
		DoInterfaceStyleOverRide()
	end if

End Function
'--------------------------------------------------------------------------------------------------------
Function DoInterfaceStyleOverRide()

	g_iAccessPrivSearchBox = INT_FALSE
	g_iAccessPrivShowFilterToggles = INT_FALSE
	g_iAccessPrivSummaryPanel = INT_FALSE
	g_iAccessPrivLoggedInAsLabel = INT_FALSE
	g_iAccessPrviSystemVersionLabel = INT_FALSE
	
	g_iUserPopUpHelpStyle = POP_UP_HELP_ADVANCED_ONLY

End Function
'--------------------------------------------------------------------------------------------------------
Function GetAccuntTypeMiniIcon()

	Dim strRtnValue
	
		Select Case g_rsUserAccountDetails("id_user_account_type")
	
		Case ACCOUNT_TYPE_ID_CLIENT
			strRtnValue = "<sup title=""Client"" class=""access_level_superscript"">C</sup >" 'ICON_MINI_CLIENT
			
		Case ACCOUNT_TYPE_ID_DEVELOPER
			strRtnValue = "<sup title=""Developer"" class=""access_level_superscript"">D</sup >" 'ICON_MINI_DEV
		
		Case ACCOUNT_TYPE_ID_ADMIN
			strRtnValue = "<sup title=""Admin"" class=""access_level_superscript"">A</sup >" 'ICON_MINI_ADMIN
	
	End Select

	GetAccuntTypeMiniIcon = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function BoolToInt(strInputValue)

	Dim iRtnValue
	
	if (Trim(LCase(strInputValue)) = "false") then
		iRtnValue = 0
	elseif (Trim(LCase(strInputValue)) = "true") then
		iRtnValue = 1
	else
		iRtnValue = "<b>Error:</b> could not convert bool to int in function BoolToInt()."
		response.end
	end if
	
	BoolToInt	= iRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function CheckboxToIntBool(strInputValue)

	Dim iRtnValue
	
	if (Trim(strInputValue) = "") then
		iRtnValue = 0
	else
		iRtnValue = 1
	end if
	
	CheckboxToIntBool= iRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function CheckboxToInt(strInputValue)

	Dim strRtnValue
	
	if (Trim(strInputValue) = "") then
		strRtnValue = 0
	else
		strRtnValue = strInputValue
	end if
	
	CheckboxToInt	= strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetNewlyAddedRecordID()

	Dim iRtnValue
	Dim strSqlQuery
	Dim objRecordSet
			
	strSqlQuery = "SELECT @@IDENTITY AS NewID"
	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

	iRtnValue = objRecordSet.Fields("NewID").value
	
	GetNewlyAddedRecordID = iRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetActiveProjectID()

	Dim iRtnValue
	Dim strValueToSaveToCookie
	Dim strArrSavedCookieValue


	if (Trim(Request.QueryString("active_project_id")) = "") then

		'get the cookie that has saved the last selected project id, it also contains the user id of who last used the system
		strArrSavedCookieValue = Split(GetCookie(COOKIE_NAME), "|")
		
	
		if (UBound(strArrSavedCookieValue) = -1) then

				'no cookie could be found relating to the logged in user. it could be their first login or they dont have access to that project id.
				iRtnValue = GetUsersFirstProjectID()

				'if the project id comes back empty, it could mean its a fresh install, or the user has no projects linked to them.
				if (iRtnValue = "") then
					DealWithMissingProjectError()
					'ThrowTerminatingErrorMessage(NO_PROJECT_ASSOCIATIONS_ASSIGNED_TO_USER_MSG)
					iRtnValue = 0
				end if			
			
		else
				
			if (strArrSavedCookieValue(COOKIE_USER_ID) = CStr(g_iUserID)) then
				'the user id in the cookie matches the id of the currently logged in user.
				iRtnValue = strArrSavedCookieValue(COOKIE_PROJECT_ID)
			else
				'the info in the cookie doesnt match up the users id with an acceptable project for them
				iRtnValue = GetUsersFirstProjectID()
			end if

		end if
		
	else
	
		'a project id has come in via the querystring
		iRtnValue = Request.QueryString("active_project_id")
		
		'we are combining the active project id with the user id because a different users logging in belong to different projects
		strValueToSaveToCookie = iRtnValue & "|" & g_iUserID
		
		'save the active project ID to a cookie if it has been selected by the user
		Call CreateCookie(COOKIE_NAME, strValueToSaveToCookie, 12)
		
	end if


	GetActiveProjectID = CInt(iRtnValue)

End Function
'--------------------------------------------------------------------------------------------------------
Function GetUsersFirstProjectID()

	Dim iRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	'make sure the first project id we get actually has bugs associated with it.
	strSqlQuery = "SELECT TOP 1 tbl_user_to_project_mapping.id_project " & _
								"FROM tbl_user_to_project_mapping LEFT JOIN tbl_bugs ON tbl_user_to_project_mapping.id_project = tbl_bugs.id_project " & _
								"WHERE tbl_user_to_project_mapping.id_user = " & g_iUserID & ";"
	Set objRecordSet = GetRecordSet(strSqlQuery)

	if (NOT objRecordSet.EOF) then
		iRtnValue = objRecordSet("id_project")	
	end if

	objRecordSet.Close
	Set objRecordSet = Nothing
	
	GetUsersFirstProjectID = iRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetCurrentProjectAssociations(iInputUserID)

	Dim iArrRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	Dim iCounter
	
	iCounter = 0
	
	strSqlQuery = "SELECT * FROM tbl_user_to_project_mapping WHERE id_user = " & iInputUserID
	Set objRecordSet = GetRecordSet(strSqlQuery)

	'resize the array to be the same size as the number of projects the user is associated too (account for zero element array vs record set using full numbers)
	ReDim iArrRtnValue(objRecordSet.RecordCount-1)

	Do Until objRecordSet.EOF
		iArrRtnValue(iCounter) = objRecordSet("id_project")
		objRecordSet.MoveNext
		iCounter = iCounter + 1		
	Loop
	
	objRecordSet.Close
	Set objRecordSet = Nothing
	
	GetCurrentProjectAssociations = iArrRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetDropListDateControl(strInputPreSelectedDate, strInputDefaultDate)

	Dim strRtnValue
	Dim iCounter
	
	Dim strDay
	Dim strMonth
	Dim strYear
	
	Dim strDayOptions
	Dim strMonthOptions
	Dim strYearOptions
	
	Dim strShortMonthName
	Dim strArrPreSelectDate
	Dim strSelectedMarker

	'set the default date (creating the date using data functions to be safer since US vs AU servers have different dates formats).
	if (strInputPreSelectedDate = "") then
	
		if (strInputDefaultDate = "") then
			strInputPreSelectedDate = Day(Date()) & "/" & Month(Date()) & "/" & Year(Date())
		else
			strInputPreSelectedDate = strInputDefaultDate
		end if
		
	end if
	
	strArrPreSelectDate = Split(strInputPreSelectedDate, "/")
		
	'debug strInputPreSelectedDate
	'debug strArrPreSelectDate(0)
	'debug strArrPreSelectDate(1)
	'debug strArrPreSelectDate(2)
	
	For iCounter = 1 To 31
		if (CStr(iCounter) = strArrPreSelectDate(0) ) then
			strSelectedMarker = " selected "
		else
			strSelectedMarker = ""
		end if
		strDayOptions = strDayOptions & "<option " & strSelectedMarker & " value=""" & iCounter & """>" & iCounter & "</option>" & vbCrLf
	Next
	
	For iCounter = 1 To 12
		if (iCounter = CInt(strArrPreSelectDate(1)) ) then
			strSelectedMarker = " selected "
		else
			strSelectedMarker = ""
		end if
		strShortMonthName = MonthName(iCounter, true)
		strMonthOptions = strMonthOptions & "<option " & strSelectedMarker & " value=""/" & strShortMonthName & "/"">" & strShortMonthName & "</option>" & vbCrLf
	Next
	
	For iCounter = 2007 To (Year(Date())+15)
		if (CStr(iCounter) = strArrPreSelectDate(2) ) then
			strSelectedMarker = " selected "
		else
			strSelectedMarker = ""
		end if
		strYearOptions = strYearOptions & "<option " & strSelectedMarker & " value=""" & iCounter & """>" & iCounter & "</option>" & vbCrLf
	Next
	
	strDay = "<select size=""1"" class=""ctrl_drop_list_date""  name=""drp_day"">" & vbCrLf & _
					 strDayOptions & _
					 "</select>" & vbCrLf

	strMonth = "<select size=""1"" class=""ctrl_drop_list_date"" name=""drp_month"">" & vbCrLf & _
					 strMonthOptions & _
					 "</select>" & vbCrLf
					 
	strYear = "<select size=""1"" class=""ctrl_drop_list_date"" name=""drp_year"">" & vbCrLf & _
					 strYearOptions & _
					 "</select>" & vbCrLf					 					 
	
	strRtnValue = strDay &  strMonth & strYear
	GetDropListDateControl  = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function ShowNoProjectsDialogue()

	Dim bRtnValue

	'the no projects in system message shouldnt be shown if the user is on the projects or users page (they need to be able to create a project).
	if (g_strPageName = "projects.asp") then
		bRtnValue = false	
	elseif (g_strPageName = "users.asp") then
		bRtnValue = false
	else 
		bRtnValue = true
	end if
	
	ShowNoProjectsDialogue = bRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DealWithMissingProjectError()
			
	
	'a different error message is shown based on the user accont type
	if (g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_ADMIN) then

		'its an administration level user. its likely this is the first time the system is being used, so no projects exist yet.
		if (ShowNoProjectsDialogue() = true) then
			DrawNoProjectsInSystemMessageHTML()
			response.end
		end if

	else

		'its either a developer level user or client account, but they have no project associations set
		DrawNoProjectsAssociationsMsgHTML()
		response.end

	end if
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawNoProjectsAssociationsMsgHTML()

	%>
	<html>
	<head>
		<title><%= APP_NAME & ": " & FriendlyFileName(GetPageName()) %> (<%= g_strActiveProjectName %>)</title>
		<link rel="stylesheet" type="text/css" href="include/bugweb.css">	
		
		<script>
		function VerticallyCentreMsgDialogue()
		{
			var iPaddingAmount;
			iPaddingAmount = (document.documentElement.clientHeight / 2) - 57;
			
			document.getElementById('verticle_centering').style.paddingBottom = iPaddingAmount;
		}
		</script>
	</head>
	
	<body onload="VerticallyCentreMsgDialogue();">

	<center>
	<div id="verticle_centering" style="padding-bottom: 20px;"></div>
	<table id="warning_msg_container" width="420">
	<tr>
		<td style="background: transparent url(images_layout/dialogue_corner_top_left.png) no-repeat; width: 15px; height: 15px;"></td>
		<td style="border-top: solid 1px #A7A7A7;">&nbsp;</td>
		<td style="border-top: solid 1px #A7A7A7;">&nbsp;</td>
		<td style="background: transparent url(images_layout/dialogue_corner_top_right.png) no-repeat; width: 15px; height: 15px;"></td>
	</tr>
	<tr>
		<td style="border-left: solid 1px #A7A7A7;">&nbsp;</td>
		<td style="padding-bottom: 10px; text-align: left;"><%= ICON_ERROR %> <SPAN class="major_heading"><b>Error:</b> you aren't linked to any projects</SPAN></td>
		<td></td>
		<td style="border-right: solid 1px #A7A7A7;">&nbsp;</td>
	</tr>
	<tr>
		<td style="border-left: solid 1px #A7A7A7;">&nbsp;</td>
		<td colspan="2" style="text-align: left;">
		Your account currently has no association with any projects.<br/>
		<div style="padding-bottom: 10px;"></div>
		Unfortunately, this means you can't continue on into the system<br/>
		<div style="padding-bottom: 10px;"></div>
		You will need to contact the system admin for help<%= ICON_ARROW %><a href="mailto:<%= g_strSettingTechSupporEmail %>?subject=BugWeb: my account has no project associations">email support</a>
		<div style="padding-bottom: 10px;"></div>
		</td>
		<td style="border-right: solid 1px #A7A7A7; height: 22px;">&nbsp;</td>
	</tr>
	<tr>
		<td style="background: transparent url(images_layout/dialogue_corner_bottom_left.png) no-repeat; width: 15px; height: 15px;"></td>
		<td style="border-bottom: solid 1px #A7A7A7;">&nbsp;</td>
		<td style="border-bottom: solid 1px #A7A7A7;">&nbsp;</td>
		<td style="background: transparent url(images_layout/dialogue_corner_bottom_right.png) no-repeat; width: 15px; height: 15px;""></td>
	</tr>
	</table>
	</center>
	
	</body>
	</html>
	<%  

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawNoProjectsInSystemMessageHTML()

	%>
	<html>
	<head>
		<title><%= APP_NAME & ": " & FriendlyFileName(GetPageName()) %> (<%= g_strActiveProjectName %>)</title>
		<link rel="stylesheet" type="text/css" href="include/bugweb.css">	
		
		<script>
		function VerticallyCentreMsgDialogue()
		{
			var iPaddingAmount;
			iPaddingAmount = (document.documentElement.clientHeight / 2) - 57;
			
			document.getElementById('verticle_centering').style.paddingBottom = iPaddingAmount;
		}
		</script>
		
			<link rel="stylesheet" type="text/css" href="css/bugweb.css">
			
	</head>
	
	<body onload="VerticallyCentreMsgDialogue();">

	<center>
	<div id="verticle_centering" style="padding-bottom: 20px;"></div>
	
	<div style="background:url('images_layout/dialogue_background_330.png') center center no-repeat; padding: 20px; width: 300px; text-align: left; font-family: Verdana; font-size: 13px; ">
	<img src="images_icons/icon_settings.png" alt="Icon" class="" /> <span class="major_heading">No Project Available</span>
	<div class="medium_spacer"></div>
	There are no projects in the system (often the case after a fresh install). Before <i>BugWeb</i> can be used, at least one project must be created.
	To create your first project, go to the <a href="projects.asp" style="font-size: 13px;">Projects</a> page.
	<div class="medium_spacer"></div>		
	<img src="images_icons/icon_note.png" alt="Icon" class="" />  You will automatically be associated with this first project.
	</div>

	</center>
	
	</body>
	</html>
	<%  

End Function
'--------------------------------------------------------------------------------------------------------
Function GetActiveProjectDetails(iInputProjectID)

	Dim strSqlQuery
	Dim iUsersFirstProjectID

	strSqlQuery = "SELECT * FROM tbl_projects WHERE id_project = " & iInputProjectID
	Set g_rsActiveProject = GetRecordSet(strSqlQuery)

	if (g_rsActiveProject.EOF) then
	
		'the project id wasnt found, this could be because the cookie on the system refers to a bogus project id (try getting the users first project id).
		iUsersFirstProjectID = GetUsersFirstProjectID()
						
		if (iUsersFirstProjectID ="") then
			'the project details recordset is empty, this probably means its a new installation or no projects exist in the system curently
			DealWithMissingProjectError()
		else
			strSqlQuery = "SELECT * FROM tbl_projects WHERE id_project = " & iUsersFirstProjectID
			Set g_rsActiveProject = GetRecordSet(strSqlQuery)
			g_strActiveProjectName = g_rsActiveProject("project_name")
		end if
		
	else
		g_strActiveProjectName = g_rsActiveProject("project_name")
	end if

End Function
'--------------------------------------------------------------------------------------------------------
Function HoverOverSafe(strInputString)

	Dim strRtnValue
	
	strRtnValue = Replace(strInputString, "'", "")
	strRtnValue = Replace(strRtnValue, vbCrLf, "")
	
	HoverOverSafe = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetUserShortName(iInputUserID, bShowAccountType)

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	strSqlQuery = "SELECT first_name, last_name, initials, tbl_user_account_types.account_type_name " & _
								"FROM tbl_users INNER JOIN tbl_user_account_types ON tbl_users.id_user_account_type = tbl_user_account_types.id_user_account_type " & _
								"WHERE (((tbl_users.id_user) = " & iInputUserID & "));"
		
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (NOT objRecordSet.EOF) then
	
		if (g_iAccessPrivShowFullNames = INT_TRUE) then
			strRtnValue = "<span class=""tool_tip"" title=""" & objRecordSet("first_name") & " " & objRecordSet("last_name") & """>" & objRecordSet("initials") & "</span>"
		else
			strRtnValue = objRecordSet("initials")
		end if
	
		'tac on the account type if needed.
		if (bShowAccountType = true) then
			strRtnValue = strRtnValue & " (" & objRecordSet("account_type_name") & ")"
		end if
		
	else
		strRtnValue = "<i>(Unknown User)</i>"
	end if
	
	objRecordSet.Close
	Set objRecordSet = Nothing

	GetUserShortName = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetUserFullName(iInputUserID, bShowAccountType)

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	

	strSqlQuery = "SELECT first_name +' '+ last_name AS full_name, initials, tbl_user_account_types.account_type_name " & _
								"FROM tbl_users INNER JOIN tbl_user_account_types ON tbl_users.id_user_account_type = tbl_user_account_types.id_user_account_type " & _
								"WHERE (((tbl_users.id_user) = " & iInputUserID & "));"
	
	
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (NOT objRecordSet.EOF) then
	
		if (g_iAccessPrivShowFullNames = INT_TRUE) then
			strRtnValue = objRecordSet("full_name")
		else
			strRtnValue = objRecordSet("initials")
		end if
	
		'tac on the account type if needed.
		if (bShowAccountType = true) then
			strRtnValue = strRtnValue & " (" & objRecordSet("account_type_name") & ")"
		end if
		
	else
		strRtnValue = "<i>(Unknown User)</i>"
	end if
	
	objRecordSet.Close
	Set objRecordSet = Nothing

	GetUserFullName = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawStatusIcon(iInputProjectIsActive)

	Dim strRtnValue
	
	if (iInputProjectIsActive = INT_TRUE) then
		strRtnValue = ICON_PROJECT_ACTIVE
	else
		strRtnValue = ICON_PROJECT_INACTIVE
	end if

	DrawStatusIcon = strRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------
Function MakeOverlibSafe(strInputValue)

	Dim strRtnValue
	
	strRtnValue = Replace(strInputValue, "'", "\'")
	
	MakeOverlibSafe = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function BoldActiveNavigation(strInputNavigationName, strInputAuxiliaryNames)
	
	Dim strRtnValue
	Dim iCounter
	Dim strArrAuxSections

	if (lcase(strInputNavigationName) = lcase(Replace(FriendlyFileName(g_strPageName), "_", " ")) ) then
		strRtnValue = "<b style=""border-bottom: 1px solid #ed8223;"">" & strInputNavigationName & "</b>"
	else
		strRtnValue = strInputNavigationName
	end if
	
	if (NOT Trim(strInputAuxiliaryNames) = "") then
	
		strArrAuxSections = Split(strInputAuxiliaryNames, ", ")
		
		For iCounter = 0 To UBound(strArrAuxSections)
			'check to see if there are auxilary names, these are other nav sections bolded in addition
			if (lcase(strArrAuxSections(iCounter)) = lcase(Replace(FriendlyFileName(g_strPageName), "_", " ")) ) then
				strRtnValue = "<b>" & strInputNavigationName & "</b>"
			end if
		Next
	
	end if
		
	BoldActiveNavigation = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function SetAccountTypeEnabledFor(iInputAccountTypeID)

	Dim strRtnValue
	
	Select Case iInputAccountTypeID
	
		Case ACCOUNT_TYPE_ID_CLIENT
			strRtnValue = "enabled_for_client"
			
		Case ACCOUNT_TYPE_ID_DEVELOPER
			strRtnValue = "enabled_for_developer"
		
		Case ACCOUNT_TYPE_ID_ADMIN
			strRtnValue = "enabled_for_admin"
	
	End Select
	
	SetAccountTypeEnabledFor = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawSaveSuccessfulHTML(strShowMessage)

	if (strShowMessage = STR_TRUE) then
		%>
		<br>
		<span class="save_successful_message">The task was successful.</span>
		<%
	elseif (strShowMessage = STR_FALSE) then
		%>
		<br>
		<span class="save_cancel_message">You cancelled the task.</span>
		<%
	end if

End Function
'--------------------------------------------------------------------------------------------------------
Function IntToYesNo(iInputValue)
	
	Dim strRtnValue
	
	if (iInputValue = INT_TRUE) then
		strRtnValue = "Yes"
	elseif (iInputValue = INT_FALSE) then
		strRtnValue = "No"
	else 
		strRtnValue = "<i>(Unknown)</i>"
	end if
	
	IntToYesNo = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function IntToStatus(iInputStatusValue)
	
	Dim strRtnValue
	
	if (iInputStatusValue = INT_TRUE) then
		strRtnValue = "Enabled"
	elseif (iInputStatusValue = INT_FALSE) then
		strRtnValue = "Disabled"
	else 
		strRtnValue = "<i>(Unknown)</i>"
	end if
	
	IntToStatus = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetUserAccountDetails(iInputUserID)

	Dim strRtnValue
	Dim strSqlQuery

	strSqlQuery = "SELECT tbl_users.*, tbl_user_account_types.account_type_name " & _
								"FROM tbl_user_account_types INNER JOIN tbl_users ON tbl_user_account_types.id_user_account_type = tbl_users.id_user_account_type " & _
								"WHERE id_user = " & iInputUserID
	
	Set g_rsUserAccountDetails = GetRecordSet(strSqlQuery)
										
	g_strAccountTypeEnabledFor = SetAccountTypeEnabledFor(g_rsUserAccountDetails("id_user_account_type"))
		
	if (g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_CLIENT) then
		g_bIsClientAccount = true
	end if
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetSystemSetting(iInputSettingID)

	Dim strRtnValue
	Dim objRecordSet
	Dim strSqlQuery

	strSqlQuery = "SELECT setting_value FROM tbl_system_configuration WHERE id_system_configuration = " & iInputSettingID
		
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (NOT objRecordSet.EOF) then
		strRtnValue = objRecordSet("setting_value")
	else
		strRtnValue = "Error: system setting value not found."
	end if
	
	objRecordSet.Close
	Set objRecordSet = Nothing
	
	GetSystemSetting = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function ReleaseDatabaseResources()

	g_rsUserAccountDetails.Close
	Set g_rsUserAccountDetails = Nothing
		
	g_rsActiveProject.Close
	Set g_rsActiveProject = Nothing

End Function
'--------------------------------------------------------------------------------------------------------
%>