<!-- Home (07072007) -->
<% 
Dim g_strSearchKeyword
Dim g_iCurrentPage
Dim g_strArrAssignedToFilter

Dim g_iCurrentPageNumber
Dim g_iTotalNumberOfBugs
Dim g_strFilterToggleStates

Dim g_strSaveOperation

'--------------------------------------------------------------------------------------------------------
Function HomePageStartUp()

	g_strSearchKeyword = Request.Querystring("txt_keyword")
	g_strSaveOperation = Request.QueryString("save_operation")
	
	'get the page number (used with the paging mechanism)
	if (NOT Request.QueryString("page") = "") then
		g_iCurrentPageNumber = CInt(Request.QueryString("page"))
	else
		g_iCurrentPageNumber = 1
	end if
	
	g_strFilterToggleStates = GetToggleButtonStates()
	
	g_strArrAssignedToFilter = GetAssignedToSettings()

	'this will write the cookie used to store the toggle button states (only if the user has submitted a change).
	WriteToggleButtonCookie()
	
	WriteAssignedToCookie()
	
End Function
'--------------------------------------------------------------------------------------------------------
Function WriteToggleButtonCookie()
	
	Dim strBtnToggleID
	Dim strToggleState
	Dim strCurrentCookieSettings
	
	Dim strNewCookieSettings
	Dim iCounter
	Dim strArrToggleSettings

	'only write the cookie if the user has clicked one of the filter toggle buttons
	if (NOT Request.Querystring("btn_toggle_id") = "") then
	
		strBtnToggleID = Request.Querystring("btn_toggle_id")
		strToggleState = Request.Querystring("btn_toggle_state")
		
		'get the current cookie settings
		strCurrentCookieSettings = GetCookie("toggle_button_states")
		
		'first may an array thats big enought to hold a toggle state for each button (i.e. 9 elements)
		ReDim strArrToggleSettings(Len(strCurrentCookieSettings)) 
		
		For iCounter = 1 To UBound(strArrToggleSettings)
		
			'cycle through the array and fill it with settings from the cookie (+ slip in the new toggle state).
			if (CStr(iCounter) = strBtnToggleID) then
				strArrToggleSettings(iCounter) = strToggleState
			else
				strArrToggleSettings(iCounter) = Mid(strCurrentCookieSettings, iCounter, 1)
			end if
			
		Next
		
		'turn the array back into one long string		
		strNewCookieSettings = Replace(Join(strArrToggleSettings), " ", "")
		
		Call CreateCookie("toggle_button_states", strNewCookieSettings, 12)
		g_strFilterToggleStates = strNewCookieSettings
	
	end if

End Function
'--------------------------------------------------------------------------------------------------------
Function WriteAssignedToCookie()

	Dim strAssignedToGroupID
	Dim strAssignedToUserID
	
	strAssignedToGroupID =  Request.Querystring("assigned_to_group_id")
	strAssignedToUserID = Request.Querystring("assigned_to_user_id")
	
	'only write to the cookie if the user has changed the assigned to setting
	if ( (NOT strAssignedToGroupID = "") OR (NOT strAssignedToUserID = "") ) then
		Call CreateCookie("assigned_to_settings", strAssignedToGroupID & ", " & strAssignedToUserID, 12)
		g_strArrAssignedToFilter(ASSIGNED_TO_GROUP_ID) = strAssignedToGroupID
		g_strArrAssignedToFilter(ASSIGNED_TO_USER_ID)  = strAssignedToUserID
	end if
	

End Function
'--------------------------------------------------------------------------------------------------------
Function GetAssignedToSettings()
 
 	Dim strArrRtnValue(1)
	Dim strAssignedToSettings
	Dim strArrSplitCookie
	
	'defualts to be used in case there is no cookie yet.
	strArrRtnValue(ASSIGNED_TO_GROUP_ID) = CStr(ASSIGNED_TO_FILTER_ID_ANYONE)
	strArrRtnValue(ASSIGNED_TO_USER_ID)  = ""
	
	strAssignedToSettings = GetCookie("assigned_to_settings")
	
	strArrSplitCookie = Split(strAssignedToSettings, ",")
	
	'check if the cookie is empty (it could be first run of the program). create a cookie based on defauts if it is.
 	if (Trim(strAssignedToSettings) = "") then
		Call CreateCookie("assigned_to_settings", strArrRtnValue(ASSIGNED_TO_GROUP_ID) & ", ", 12)
	else
		strArrRtnValue(ASSIGNED_TO_GROUP_ID) = Trim(strArrSplitCookie(ASSIGNED_TO_GROUP_ID))
		strArrRtnValue(ASSIGNED_TO_USER_ID) = Trim(strArrSplitCookie(ASSIGNED_TO_USER_ID))
	end if
	
	GetAssignedToSettings = strArrRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetToggleButtonStates()

	Dim strRtnValue
	Dim strDefaultToggleStates
	
	'defualts to be used in case there is no cookie yet.
	strDefaultToggleStates = "111111111"
	
	'get the toggle button states from the stored cookie
	strRtnValue = GetCookie("toggle_button_states")
	
	'check if there are any values in the cookie (it may be the first run of the program)
 	if (Trim(strRtnValue) = "") then
		'set-up the initial state of the toggle buttons since this may be the first time the user is entering the program
		strRtnValue = strDefaultToggleStates
		Call CreateCookie("toggle_button_states", strDefaultToggleStates, 12)
	end if
	
	GetToggleButtonStates = strRtnValue
 
End Function
'--------------------------------------------------------------------------------------------------------
Function BoolToYesNo(iInputValue)

	Dim strRtnValue
	
	if (iInputValue = INT_TRUE) then
		strRtnValue = "Yes"
	else
		strRtnValue = "No"
	end if
	
	BoolToYesNo = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawProjectsHTML()

	Dim strSqlQuery
	Dim objRecordSet
	Dim strProjectHoverOverDescription
	
	Dim iArrProjectAssociations
	Dim iCounter
	Dim strProjectAssociationIDs
	
	iArrProjectAssociations = GetCurrentProjectAssociations(g_iUserID)
	
	response.write "<br>"
	For iCounter = 0 To UBound(iArrProjectAssociations)
		strProjectAssociationIDs = strProjectAssociationIDs & iArrProjectAssociations(iCounter) & " "
	Next
	
	'put commas in between the ID numbers
	strProjectAssociationIDs = Replace(Trim(strProjectAssociationIDs), " ", ", ")

	strSqlQuery = "SELECT tbl_projects.*, tbl_users.first_name + ' ' + tbl_users.last_name AS project_manager " & _
								"FROM tbl_users INNER JOIN tbl_projects ON tbl_users.id_user = tbl_projects.id_user_project_manager " & _
								"WHERE id_project IN (" & Trim(strProjectAssociationIDs) & ") AND (tbl_projects.has_been_deleted = 0) " & _
								"ORDER BY project_code;"
		
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	%>
	<div style="padding-bottom: 8px;"></div>
	<span style="color: #000;">Project:</span>
	<%  
	
	Do Until objRecordSet.EOF

		'highlight the active project
		if (g_iActiveProjectID = objRecordSet("id_project")) then
			%><span class="current_assignment tool_tip" title="<%= objRecordSet("project_name") %>"><%= objRecordSet("project_code") %></span><%  
		else
			strProjectHoverOverDescription = "<b>Project Name:</b> " & HoverOverSafe(objRecordSet("project_name")) & "<br>" & _
																		 	 "<b>Active:</b> " & BoolToYesNo(objRecordSet("project_is_active")) & "<br>" & _
																			 "<b>PM:</b> " & objRecordSet("project_manager") & "<br>" & _											 
																		 	 "<b>Date Created:</b> " & CompactDate(objRecordSet("date_created"))

			%><span class="tool_tip_container"><span class="vtip" title="<%= strProjectHoverOverDescription %>"><a href="<%= g_strPageName %>?active_project_id=<%= objRecordSet("id_project") %>&assigned_to_group_id=<%= ASSIGNED_TO_FILTER_ID_ANYONE %>"><%= objRecordSet("project_code") %></a></span></span><%
		end if
			
		objRecordSet.MoveNext
		
		if (NOT objRecordSet.EOF) then %><span class="standard_divider">|</span><%	end if
		
	Loop
			
	objRecordSet.Close
	Set objRecordSet = Nothing

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawAssignedToUsersHTML()
			
	Dim strSqlQuery
	Dim objRecordSet
	Dim strUserFullName
	
	strSqlQuery = "SELECT tbl_users.id_user, tbl_users.first_name, tbl_users.last_name, tbl_users.initials, tbl_user_account_types.account_type_name  " & _
								"FROM (tbl_users INNER JOIN tbl_user_account_types ON tbl_users.id_user_account_type = tbl_user_account_types.id_user_account_type)  " & _
								"INNER JOIN tbl_user_to_project_mapping ON tbl_users.id_user = tbl_user_to_project_mapping.id_user  " & _
								"WHERE (((tbl_users.[has_been_deleted])=0) AND ((tbl_user_to_project_mapping.id_project)= " & g_iActiveProjectID & ")) " & _
								"ORDER BY tbl_users.initials;"
		
	Set objRecordSet = GetRecordSet(strSqlQuery)

	DrawAsssignedToGroupsHTML()
	
	Do Until objRecordSet.EOF
	
		if (NOT objRecordSet.EOF) then %><span class="standard_divider">|</span><% end if
		
		 %><%= GetAssignedToUser(objRecordSet("id_user"), objRecordSet("first_name"),  objRecordSet("last_name"), objRecordSet("initials"), objRecordSet("account_type_name") ) %><% 
		
		objRecordSet.MoveNext
				
	Loop
			
	objRecordSet.Close
	Set objRecordSet = Nothing

End Function
'--------------------------------------------------------------------------------------------------------
Function GetAssignedToUser(iInputUsedID, strFirstName, strSurname, strInputInitials, strInputAccountType)

	Dim strRtnValue
	Dim strTitleTag
	
	if (g_iAccessPrivShowFullNames = INT_TRUE) then
		strTitleTag = strFirstName & " (" & strInputAccountType & ")"
	else
		strTitleTag = strInputInitials
	end if
	
	if (g_strArrAssignedToFilter(ASSIGNED_TO_USER_ID) = CStr(iInputUsedID) ) then
		strRtnValue = "<span class=""current_assignment"" title=""" & strTitleTag & """>" & strInputInitials & "</span>"
	else
		strRtnValue = "<a href=""" & g_strPageName & "?assigned_to_user_id=" & iInputUsedID & """ title=""" & strTitleTag & """>" & TruncateString(strFirstName, 10) & "</a>"
	end if
	
	GetAssignedToUser =  strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawAsssignedToGroupsHTML()
		
	response.write "<span style=""; color: #000;"">Owner:</span> "
	response.write GetAssignedToGroup("(Anyone)", ASSIGNED_TO_FILTER_ID_ANYONE) & "<span class=""standard_divider"">|</span>"
	response.write GetAssignedToGroup("(Admin Only)", ACCOUNT_TYPE_ID_ADMIN ) & "<span class=""standard_divider"">|</span>"
	response.write GetAssignedToGroup("(Dev. Only)", ACCOUNT_TYPE_ID_DEVELOPER ) & "<span class=""standard_divider"">|</span>"
	response.write GetAssignedToGroup("(Clients Only)", ACCOUNT_TYPE_ID_CLIENT )
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetAssignedToGroup(strGroupLabel, iInputGroupID)

	Dim strRtnValue

	if (g_strArrAssignedToFilter(ASSIGNED_TO_GROUP_ID) = CStr(iInputGroupID) ) then
		strRtnValue = "<span class=""current_assignment"">" & Replace(Replace(strGroupLabel, "(", ""), ")", "") & "</span>"
	else		
		strRtnValue = "<a href=""" & g_strPageName & "?assigned_to_group_id=" & iInputGroupID & """ >" & strGroupLabel & "</a>"
	end if	
	 
	GetAssignedToGroup = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function RoundUp(iInputValue)

	Dim iRtnValue
	
	if ( (iInputValue = 0) OR IsNull(iInputValue) ) then
		iRtnValue = 0
	else
	
		if (InStr(iInputValue, ".") = 0) then
			iRtnValue = CInt(iInputValue)
		else
			iRtnValue = Split(iInputValue, ".")(0) + 1
		end if
		
	end if
	
	RoundUp = iRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawPagingMechanismHTML()

	Dim iCounter
	Dim iNumberOfRecordsPages
	
	iNumberOfRecordsPages = RoundUp(g_iTotalNumberOfBugs / g_iRecordsToShowPerPage)

	if (iNumberOfRecordsPages = 0 OR iNumberOfRecordsPages = 1) then
	
		'the paging mechanism is disabled because there is only one page of records to show
		response.write "<span class=""lbl_disabled""></span>" & _
									 GetPagingIcon(6, "") & _
									 GetPagingIcon(4, "") & _
									 " <select name=""drp_paging"" class=""ctrl_drop_list"" style=""vertical-align: middle;"" disabled><option>1</option></select> " & _
									 GetPagingIcon(2, "") & _
									 GetPagingIcon(8, "")
	else

		response.write "<span class=""standard_note""></span>"
		
		'FIRST/PREV BTN 
		if (g_iCurrentPageNumber = 1) then
			'disable the first/prev buttons if we are at the start of the catalogue
			response.write GetPagingIcon(6, "")
			response.write GetPagingIcon(4, "")
		else
			response.write GetPagingIcon(5, 1)
			response.write GetPagingIcon(3,  g_iCurrentPageNumber - 1)
		end if
		
		response.write " <select id=""paging_droplist"" onchange=""SetPage();"" name=""drp_paging"" class=""ctrl_drop_list"" style=""vertical-align: middle;"">" & vbCrLf
			
			For iCounter = 1 To iNumberOfRecordsPages
				response.write "<option " & IsSelected(iCounter, g_iCurrentPageNumber) & "value=""" & iCounter & """>" & iCounter & "</option>" & vbCrLf
			Next
			
		response.write "</select>" & vbCrLf
		
		'NEXT/LAST BTN
		if (g_iCurrentPageNumber = iNumberOfRecordsPages) then
			'disable the next/last icons if we are at the end of the catalogue
			response.write GetPagingIcon(2, "")
			response.write GetPagingIcon(8, "")
		else
			response.write GetPagingIcon(1, g_iCurrentPageNumber + 1)
			response.write GetPagingIcon(7, iNumberOfRecordsPages)
		end if
	

	end if
	
	%> <span class="general_note" style="padding: 0 0 0 5px;"><img src="images_icons/icon_number_of_issues.png" alt="No. of Issues" class="icon_standard icon_shift_up" /> x <%= g_iTotalNumberOfBugs %></span><%  

End Function

'--------------------------------------------------------------------------------------------------------
Function GetPagingIcon(iInputPagingIcon, iInputGoToPage)

	const ICON_NEXT = "<a href=""?page={GOTO_PAGE_PLACE_HOLDER}"" class=""paging_hyperlink""><img alt="""" src=""images_icons/icon_paging_next.png"" class=""icon_paging"" /></a>"
	const ICON_NEXT_DISABLED = "<img alt="""" src=""images_icons/icon_paging_next_disabled.png"" class=""icon_paging"" />"
	
	const ICON_PREV = "<a href=""?page={GOTO_PAGE_PLACE_HOLDER}"" class=""paging_hyperlink""><img alt="""" src=""images_icons/icon_paging_prev.png"" class=""icon_paging"" /></a>"
	const ICON_PREV_DISABLED = "<img alt="""" src=""images_icons/icon_paging_prev_disabled.png"" class=""icon_paging"" />"
	
	const ICON_FIRST = "<a href=""?page={GOTO_PAGE_PLACE_HOLDER}"" class=""paging_hyperlink""><img alt="""" src=""images_icons/icon_paging_first.png"" class=""icon_paging"" /></a>"
	const ICON_FIRST_DISABLED = "<img alt="""" src=""images_icons/icon_paging_first_disabled.png"" class=""icon_paging"" />"
	
	const ICON_LAST = "<a href=""?page={GOTO_PAGE_PLACE_HOLDER}"" class=""paging_hyperlink""><img alt="""" src=""images_icons/icon_paging_last.png"" class=""icon_paging"" /></a>"
	const ICON_LAST_DISABLED = "<img alt="""" src=""images_icons/icon_paging_last_disabled.png"" class=""icon_paging"" />"

	Dim strRtnValue
	
	Select Case iInputPagingIcon
	
		Case 1
			strRtnValue = ICON_NEXT
			
		Case 2
			strRtnValue = ICON_NEXT_DISABLED
			
		Case 3
			strRtnValue = ICON_PREV
			
		Case 4
			strRtnValue = ICON_PREV_DISABLED
			
		Case 5
			strRtnValue = ICON_FIRST
			
		Case 6
			strRtnValue = ICON_FIRST_DISABLED		
						
		Case 7
			strRtnValue = ICON_LAST

		Case 8
			strRtnValue = ICON_LAST_DISABLED
					
	End Select

	GetPagingIcon = Replace(strRtnValue, "{GOTO_PAGE_PLACE_HOLDER}", iInputGoToPage)

End Function
'--------------------------------------------------------------------------------------------------------
Function GetBugListTitle() 
	
	Dim strRtnValue
	
	if (NOT Trim(g_strSearchKeyword) = "") then
		strRtnValue = "Bugs" & ARROW_SECTION_DIVIDER & "<span style=""color: #8e8d8d;"">Search</span>"
	else
		strRtnValue = "Bugs" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">" & g_rsActiveProject("project_name") & "</span>"
	end if
	
	GetBugListTitle = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetToggleFiltersSQL()

	Dim strRtnValue

	Dim strStatusIDs
	Dim strPriorityIDs
	Dim strTypeIDs
	
	Dim strStatusFilters
	Dim strPriorityFilters
	Dim strTypeFilters
	
	
	if (Mid(g_strFilterToggleStates, TOGGLE_BUG_STATUS_OPEN, 1) = "1") then
		strStatusIDs = BUG_STATUS_OPEN_ID & ", "
	end if
	
	if (Mid(g_strFilterToggleStates, TOGGLE_BUG_STATUS_ON_HOLD, 1) = "1") then
		strStatusIDs = strStatusIDs & BUG_STATUS_ON_HOLD_ID  & ", "
	end if
	
	if (Mid(g_strFilterToggleStates, TOGGLE_BUG_STATUS_CLOSED, 1) = "1") then
		strStatusIDs = strStatusIDs & BUG_STATUS_CLOSED_ID & ", "
	end if
	
	if (NOT strStatusIDs = "") then
		strStatusIDs = Left(strStatusIDs, Len(strStatusIDs)-2)
		strStatusFilters = " AND (tbl_bugs.id_status IN (" & strStatusIDs & ") )"
	end if

	
	
	if (Mid(g_strFilterToggleStates, TOGGLE_PRIORITY_HIGH, 1) = "1") then
		strPriorityIDs = BUG_PRIORITY_HIGH_ID & ", "
	end if
	
	if (Mid(g_strFilterToggleStates, TOGGLE_PRIORITY_NORMAL, 1) = "1") then
		strPriorityIDs = strPriorityIDs & BUG_PRIORITY_NORMAL_ID  & ", "
	end if
	
	if (Mid(g_strFilterToggleStates, TOGGLE_PRIORITY_LOW, 1) = "1") then
		strPriorityIDs = strPriorityIDs & BUG_PRIORITY_LOW_UI_ID & ", "
	end if
	
	if (NOT strPriorityIDs = "") then
		strPriorityIDs = Left(strPriorityIDs, Len(strPriorityIDs)-2)
		strPriorityFilters = " AND (tbl_bugs.id_priority IN (" & strPriorityIDs & ") )"
	end if		

	
	
	if (Mid(g_strFilterToggleStates, TOGGLE_TYPE_BUG, 1) = "1") then
		strTypeIDs = BUG_TYPE_BUG_ID & ", "
	end if
	
	if (Mid(g_strFilterToggleStates, TOGGLE_TYPE_FEATURE, 1) = "1") then
		strTypeIDs = strTypeIDs & BUG_TYPE_FEATURE_REQUEST_ID  & ", "
	end if
	
	if (Mid(g_strFilterToggleStates, TOGGLE_TYPE_GENERAL, 1) = "1") then
		strTypeIDs = strTypeIDs & BUG_TYPE_GENERAL_ID & ", "
	end if
	
	if (NOT strTypeIDs = "") then
		strTypeIDs = Left(strTypeIDs, Len(strTypeIDs)-2)
		strTypeFilters = " AND (tbl_bugs.id_type IN (" & strTypeIDs & ") )"
	end if		

		
	strRtnValue = strStatusFilters & strPriorityFilters &  strTypeFilters
	
	GetToggleFiltersSQL = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetAssignToSQL()

	Dim strRtnValue

	if ( (NOT g_strArrAssignedToFilter(ASSIGNED_TO_GROUP_ID) = "") AND (NOT g_strArrAssignedToFilter(ASSIGNED_TO_GROUP_ID) = CStr(ASSIGNED_TO_FILTER_ID_ANYONE) ) ) then
		strRtnValue = "  AND (tbl_users.id_user_account_type = " & 	g_strArrAssignedToFilter(ASSIGNED_TO_GROUP_ID) & ") "
	end if				
		
	if ( NOT g_strArrAssignedToFilter(ASSIGNED_TO_USER_ID) = "") then
		strRtnValue = "  AND (tbl_bugs.id_user_assigned_to = " & 	g_strArrAssignedToFilter(ASSIGNED_TO_USER_ID) & ") "
	end if				
	
	GetAssignToSQL = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawBugListItemsHTML()
	
	Dim objRecordSet :	Dim strSqlQuery
	Dim strBugStatus :	Dim strBugPriority :	Dim strBugType :	Dim strBugDescription
	Dim strDateLogged :	Dim strLoggedBy : 	Dim strHoverOverText
	Dim strSqlVisibleToClient :	Dim strSqlKeywordSearch :	Dim strAssignedToUser
	Dim strUploadFile : 	Dim strRequiresApprovalIcon :	Dim strArrBugNotLookedAt(1)
	Dim strInvisibleToClientIcon :	Dim bHasBeenApproved :	Dim strFileAttachmentIcon
	Dim strToggleFiltersSQL : 	Dim strAssignToSQL :	Dim iShiftRecordsetForwardBy
	Dim iCounter : 	Dim strIDsOfBugsToShowOnPage :	Dim strTimeEstimate
	Dim strCommentsIcon

	%>
	<script language="JavaScript">
	function GetBugStatusID(strInputElementID) 
	{ 
		var iBugStatusID;
		var strArrImageSrc = document.getElementById(strInputElementID).src.split("/");
		var strCurrentIconImage = strArrImageSrc[strArrImageSrc.length-1]
	
		//work out the correct ID to send the database based on the icons current image.
		if (strCurrentIconImage == '<%= g_strOpenBugIcon %>')
			iBugStatusID = <%= BUG_STATUS_ON_HOLD_ID %>
				
		if (strCurrentIconImage == '<%= g_strOnHoldBugIcon %>')
			iBugStatusID = <%= BUG_STATUS_CLOSED_ID %>
		
		if (strCurrentIconImage == '<%= g_strClosedBugIcon %>')
			iBugStatusID = <%= BUG_STATUS_OPEN_ID %>
	
		return iBugStatusID;
	}
	
	
	function GetBugPriorityID(strInputElementID) 
	{ 
		var iBugPriorityID;
		var strArrImageSrc = document.getElementById(strInputElementID).src.split("/");
		var strCurrentIconImage = strArrImageSrc[strArrImageSrc.length-1]
	
		//work out the correct ID to send the database based on the icons current image.
		if (strCurrentIconImage == '<%= g_strPriorityHighIcon %>')
			iBugPriorityID = <%= BUG_PRIORITY_NORMAL_ID %>
				
		if (strCurrentIconImage == '<%= g_strPriorityNormalIcon %>')
			iBugPriorityID = <%= BUG_PRIORITY_LOW_UI_ID %>
		
		if (strCurrentIconImage == '<%= g_strPriorityLowUIIcon %>')
			iBugPriorityID = <%= BUG_PRIORITY_HIGH_ID %>
	
		return iBugPriorityID;
	}

	
	function GetBugTypeID(strInputElementID) 
	{ 
		var iBugTypeID;
		var strArrImageSrc = document.getElementById(strInputElementID).src.split("/");
		var strCurrentIconImage = strArrImageSrc[strArrImageSrc.length-1]
	
		//work out the correct ID to send the database based on the icons current image.
		if (strCurrentIconImage == '<%= g_strTypeBugIcon %>')
			iBugTypeID = <%= BUG_TYPE_FEATURE_REQUEST_ID %>
				
		if (strCurrentIconImage == '<%= g_strTypeFeatureRequestIcon %>')
			iBugTypeID = <%= BUG_TYPE_GENERAL_ID %>
		
		if (strCurrentIconImage == '<%= g_strTypeGeneralIcon %>')
			iBugTypeID = <%= BUG_TYPE_BUG_ID %>
	
		return iBugTypeID;
	}
	</script>
	<%

	
	'adjust the sql query so it doesnt bring back bugs the client isnt allowed to see (the logged-in user type has to be a client type user too).
	if (g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_CLIENT) then
		strSqlVisibleToClient = " AND (visible_to_client = 1) "
	end if
	
	'adjust the sql query to do a like search if the user has submitted a keyword search.
	if (NOT Trim(g_strSearchKeyword) = "") then
		strSqlKeywordSearch = " AND (tbl_bugs.title LIKE '%" & g_strSearchKeyword & "%' " & _
													" OR tbl_bugs.description LIKE '%" & g_strSearchKeyword & "%' " & _
													" OR tbl_bugs.id_bug LIKE '%" & g_strSearchKeyword & "%') "
	end if
	
	strToggleFiltersSQL = GetToggleFiltersSQL()
	strAssignToSQL = GetAssignToSQL()
	
	strIDsOfBugsToShowOnPage = GetIDsOfBugsToShowOnPage(strSqlVisibleToClient & strSqlKeywordSearch & strToggleFiltersSQL & strAssignToSQL)

	strSqlQuery = "SELECT tbl_bugs.*, tbl_users.id_user, tbl_users.first_name, tbl_users.last_name, tbl_users.initials, " & _
								"tbl_users_1.first_name AS logged_by_user_firstname, tbl_users_1.last_name AS logged_by_user_surname, tbl_users_1.initials AS logged_by_user_initials " & _
								"FROM tbl_users AS tbl_users_1 INNER JOIN (tbl_users INNER JOIN tbl_bugs ON tbl_users.id_user = tbl_bugs.id_user_assigned_to) ON " & _
								"tbl_users_1.id_user = tbl_bugs.id_logged_by_user " & _
								"WHERE (tbl_bugs.has_been_deleted = 0) AND (tbl_bugs.id_project = " & g_iActiveProjectID & ") " & _
								strSqlVisibleToClient & strSqlKeywordSearch & strToggleFiltersSQL & strAssignToSQL & strIDsOfBugsToShowOnPage & _
								" ORDER BY tbl_bugs.date_logged DESC;"
								
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (objRecordSet.EOF) then
		DrawEmptyBugList()
	end if
		
	Do While NOT objRecordSet.EOF
		
		strBugStatus = GetBugStatusIcon(objRecordSet("id_status"), objRecordSet("id_bug"))
		strBugPriority = GetBugPriorityIcon(objRecordSet("id_priority"), objRecordSet("id_bug"))
		strBugType = GetBugTypeIcon(objRecordSet("id_type"), objRecordSet("id_bug"))
		
		if (g_iAccessPrivShowFullNames = INT_TRUE) then
			strLoggedBy = objRecordSet("logged_by_user_firstname") & " " & Left(objRecordSet("logged_by_user_surname"), 1) & "."
		else
			strLoggedBy = objRecordSet("logged_by_user_initials")
		end if
		
		strDateLogged = CompactDate(objRecordSet("date_logged"))
		strBugDescription = Replace(objRecordSet("description"), "'", "")
		strRequiresApprovalIcon = ""
		strInvisibleToClientIcon = ""
		
		'mark whether the bug has been approved (if it required it)
		bHasBeenApproved = GetApprovalStatus(objRecordSet("id_approved_by_user"))

		'put in the time estimate if there is one.
		strTimeEstimate = GetTimeEstimate(objRecordSet("time_estimate"))
		
		if (NOT objRecordSet("upload_file_name") = "") then
			'strUploadFile = "<br>File Attachment: " & objRecordSet("upload_file_name") 'removed because not really needed
			strFileAttachmentIcon = "<a href=""" & g_strUploadDirectory & objRecordSet("upload_file_name") & """ target=""_blank"" class=""icon_hyperlink"">" & Replace(ICON_FILE_ATTACHMENT, "FILE_NAME_PLACE_HOLDER", TruncateString(objRecordSet("upload_file_name"), 49) ) & "</a>"
		else
			strUploadFile = ""
			strFileAttachmentIcon = ""
		end if
		
		
		strHoverOverText = strBugDescription & "<br/><br/><span class=vtip_balloon_note> Logged by: " & strLoggedBy & " on " & strDateLogged & "</span>"
		strAssignedToUser = GetAssignedToName( objRecordSet("first_name"), objRecordSet("last_name"), objRecordSet("initials") )

		'adjust the appearance of assigned users name if its the 'unassigned' user.
		if (objRecordSet("id_user") = UNASSIGNED_USER_ID) then
			strAssignedToUser = "<span style=""color: " & UNASSIGNED_USER_COLOR & """>" & strAssignedToUser & "</span>"
		end if
		
		if (objRecordSet("has_been_looked_at") = INT_FALSE) then
			strArrBugNotLookedAt(0) = "<span class=""bug_not_looked_at"">"
			strArrBugNotLookedAt(1) = "</span>"
		else
			strArrBugNotLookedAt(0) = ""
			strArrBugNotLookedAt(1) = ""
		end if
		
		'show an icon if the logged item requires client approval.
		if (objRecordSet("requires_client_approval") = INT_TRUE) then
			
			if (bHasBeenApproved = true) then	
				strRequiresApprovalIcon = ICON_REQUIRES_APPROVAL_APPROVED
			else
				strRequiresApprovalIcon = ICON_FEATURE_REQUIRES_APPROVAL
			end if
			
		end if
		
		'over-ride the approval icon with the implementation cost icon if their is an expense related to the issue
		if (NOT objRecordSet("implementation_cost") = 0.0) then
		
			if (bHasBeenApproved = true) then
				strRequiresApprovalIcon = ICON_IMPLEMENTATION_COST_APPROVED
			else
				strRequiresApprovalIcon = ICON_IMPLEMENTATION_COST
			end if
			
		end if
		
		'show an icon if the particular bug is invisible to clients (icon wont show up for clients)
		if (objRecordSet("visible_to_client") = INT_FALSE) then
			strInvisibleToClientIcon = ICON_INVISIBLE_TO_CLIENT
		end if
		
		'see if the bug has comments attached to it.
		strCommentsIcon = GetBugCommentsIcon(objRecordSet("id_bug"))
		
		%>
		<tr>
			<td width="55" class="bug_list_table_text" align="left"><%= strArrBugNotLookedAt(0) & objRecordSet("id_bug") & strArrBugNotLookedAt(1) %></td>
			<td width="550" class="bug_list_table_text" align="left">
			<span class="tool_tip_container"><span class="vtip" title="<%= strHoverOverText %>"><a href="log_bug.asp?bug_id=<%= objRecordSet("id_bug") %>"><%= Trim(objRecordSet("title")) %></a></span></span>
			<%= strRequiresApprovalIcon %><%= strInvisibleToClientIcon %> <%= strFileAttachmentIcon %>  <%= strCommentsIcon %>
			</td>
			<td class="bug_list_table_text" align="left"><%= strAssignedToUser %></td>
			<td width="60" class="bug_list_table_text" align="center"><%= strBugStatus%></td>
			<td width="60" class="bug_list_table_text" align="center"><%= strBugPriority %></td>
			<td width="60" class="bug_list_table_text" align="center"><%= strBugType %></td>			
		</tr>
		<%  
		objRecordSet.MoveNext
		
	Loop
	
	objRecordSet.Close
	Set objRecordSet = Nothing	
		
End Function
'--------------------------------------------------------------------------------------------------------	
Function GetBugCommentsIcon(iInputBugID)

	Dim strRtnValue :	Dim objRecordSet :	Dim strSqlQuery
	Dim strComments : Dim strCommentDate : Dim strCommentBy
	
	strSqlQuery = "SELECT tbl_users.first_name, tbl_users.last_name, tbl_bug_comments.date_of_comment, tbl_bug_comments.time_of_comment " & _
							  "FROM tbl_users INNER JOIN tbl_bug_comments ON tbl_users.id_user = tbl_bug_comments.comment_by_user_id " & _
								"WHERE (((tbl_bug_comments.belongs_to_bug_id)=" & iInputBugID & ")) AND (tbl_bug_comments.has_been_deleted = 0)" & _
								"ORDER BY tbl_bug_comments.date_of_comment, tbl_bug_comments.time_of_comment;"

	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (objRecordSet.EOF) then
		strRtnValue = ""
	else

		Do While NOT objRecordSet.EOF
			
			strCommentDate = CompactDate(objRecordSet("date_of_comment")) & " (" & GetShortTime(objRecordSet("time_of_comment")) & ") " 
			strCommentBy = objRecordSet("first_name") & " " & Left(objRecordSet("last_name"), 1) & "."
			
			strComments = "<span class=vtip_balloon_note>&bull; " & strCommentBy & " on " & strCommentDate &  "</span><br/>" & strComments
																				
			objRecordSet.MoveNext
		Loop
	
		strRtnValue = GetvTipBalloon("<b>Comment added by...</b><br/>" & strComments, "<img src=""images_icons/icon_comment.png"" class=""icon_standard icon_tool_tip icon_spacer"" />", DONT_SHOW_VTIP_ICON, NO_EXTRA_CSS)
	
	end if
		
	objRecordSet.Close
	Set objRecordSet = Nothing	
		
	GetBugCommentsIcon = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------	
Function GetTimeEstimate(strInputTimeEstimate)

	Dim strRtnValue

	if (Trim(strInputTimeEstimate = "")) OR IsNull(strInputTimeEstimate) then
		strRtnValue = ""
	elseif (strInputTimeEstimate = 1) then
		strRtnValue = "Time Estimate: " & strInputTimeEstimate & " hr" 'plural vs singular
	else
		strRtnValue = "Time Estimate: " & strInputTimeEstimate & " hrs"
	end if

	GetTimeEstimate = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------	
Function GetNumberOfRecordsToRetreive()
	
	Dim iRtnValue
	Dim iTotalNumberOfBugPages

	iTotalNumberOfBugPages = RoundUp(g_iTotalNumberOfBugs / g_iRecordsToShowPerPage)
	
	'if its the first page, then the first TOP is equal to the total number of valid bug records (e.g. 31 if there are 31 valid bugs logged)
	if (g_iCurrentPageNumber = 1) then
	
		iRtnValue = g_iTotalNumberOfBugs
		
	elseif (g_iCurrentPageNumber = iTotalNumberOfBugPages) then
	
		'if its the very last page, then only the left over bugs should be shown (this may be just one bug).
		iRtnValue = g_iTotalNumberOfBugs - (g_iRecordsToShowPerPage * (iTotalNumberOfBugPages-1) )
		
	else
		
		'if its anything but the first page or the very last page, then TOP2 is equal to the number of bugs to be shown per page
		iRtnValue = g_iRecordsToShowPerPage
		
	end if
	
	GetNumberOfRecordsToRetreive = iRtnValue
		
End Function
'--------------------------------------------------------------------------------------------------------	
Function GetPagingOffset()

	Dim iRtnValue

	iRtnValue = g_iCurrentPageNumber * g_iRecordsToShowPerPage
	
	if (iRtnValue > g_iTotalNumberOfBugs) then
		iRtnValue = g_iTotalNumberOfBugs
	end if 
	
	GetPagingOffset = iRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------	
Function GetIDsOfBugsToShowOnPage(strInputExtraSQL)

	Dim strRtnValue
	Dim objRecordSet
	Dim strSqlQuery
	
	Dim iPagingOffset
	Dim iNumberOfRecordsToRetreive
	Dim iRecordsForLastPageCounter
	
	strSqlQuery = "SELECT Count(*) AS NumberOfRecords " & _
								"FROM tbl_users INNER JOIN tbl_bugs ON tbl_users.id_user = tbl_bugs.id_user_assigned_to " & _
								"WHERE (tbl_bugs.has_been_deleted=0) AND " & _
								"(tbl_bugs.id_project = " & g_iActiveProjectID & ") " & _
								strInputExtraSQL
								

	Set objRecordSet = GetRecordSet(strSqlQuery)
	g_iTotalNumberOfBugs = objRecordSet("NumberOfRecords")	
	objRecordSet.Close
	
	'there may be no bugs logged yet
	if (g_iTotalNumberOfBugs = 0) then
		Exit Function
	end if
		
	iNumberOfRecordsToRetreive = GetNumberOfRecordsToRetreive() 
	iPagingOffset = GetPagingOffset()

		
	strSqlQuery = "SELECT t.id_bug FROM ( " & _
								"SELECT TOP " & iNumberOfRecordsToRetreive & " id_bug, date_logged FROM ( " & _
								"SELECT TOP " & iPagingOffset & " id_bug, date_logged " & _
								"FROM tbl_users INNER JOIN tbl_bugs ON tbl_users.id_user = tbl_bugs.id_user_assigned_to " & _
								"WHERE (tbl_bugs.has_been_deleted = 0) AND (id_project = " & g_iActiveProjectID & ") " & _
  							strInputExtraSQL & " " & _
								"ORDER BY id_bug DESC) AS foo " & _
								"ORDER BY id_bug ASC) AS bar " & _
								"INNER JOIN tbl_bugs AS t ON bar.id_bug = t.id_bug " & _
								"ORDER BY bar.id_bug ASC"
								
	Set objRecordSet = GetRecordSet(strSqlQuery)

	if (NOT objRecordSet.EOF) then
		
		Do While NOT objRecordSet.EOF
			strRtnValue = strRtnValue & " " & objRecordSet("id_bug")
			objRecordSet.MoveNext
		Loop
		
		strRtnValue = replace(Trim(strRtnValue), " ", ", ")
		
	end if
	
	objRecordSet.Close
	Set objRecordSet = Nothing	
	
	'if there are actually bug ids to send, then construct the correct sql syntax
	if (NOT strRtnValue = "") then
		strRtnValue = " AND id_bug IN (" & strRtnValue & ") "
	end if
	
	GetIDsOfBugsToShowOnPage = strRtnValue

End Function				
'--------------------------------------------------------------------------------------------------------	
Function GetTotalNumberOfBugs(strInputExtraSQL)

	Dim iRtnValue
	Dim objRecordSet
	Dim strSqlQuery
	
	strSqlQuery = "SELECT COUNT(*) AS total_bug_count " & _
								"FROM tbl_users AS tbl_users_1 INNER JOIN (tbl_users INNER JOIN tbl_bugs ON tbl_users.id_user = tbl_bugs.id_user_assigned_to) ON " & _
								"tbl_users_1.id_user = tbl_bugs.id_logged_by_user " & _
								"WHERE (tbl_bugs.has_been_deleted = 0) AND (id_project = " & g_iActiveProjectID & ") " & _
								strInputExtraSQL

	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (NOT objRecordSet.EOF) then
		iRtnValue = objRecordSet("total_bug_count")
	end if
			
	objRecordSet.Close
	Set objRecordSet = Nothing	
	
	GetTotalNumberOfBugs = iRtnValue

End Function
'--------------------------------------------------------------------------------------------------------	
Function GetApprovalStatus(strInputApprovedByUser)
		
	Dim bRtnValue
			
	if ( IsNull(strInputApprovedByUser) = true ) then
		bRtnValue = false
	else
		bRtnValue = true
	end if
		
	GetApprovalStatus = bRtnValue
		
End Function		
'--------------------------------------------------------------------------------------------------------	
Function DrawEmptyBugList()

		if (NOT Trim(g_strSearchKeyword) = "") then
		%>
		<tr>
			<td colspan="5" width="100%" class="bug_list_table_text" align="left"><%= ICON_MINOR_DISAPPOINTMENT %> <i>Your search for '<b><%= g_strSearchKeyword %></b>' returned no results.</i></td>
		</tr>
		<%  
		else
		%>
		<tr>
			<td colspan="5" width="100%" class="bug_list_table_text" align="left"><br><%= ICON_EXCLAIM %> <i><%= NO_BUGS_AVAILABLE %></i></td>
		</tr>
		<%
		end if
	
End Function
'--------------------------------------------------------------------------------------------------------	
Function GetBugStatusIcon(iInputStatusID, iInputBugID)

	Dim strRtnValue
	Dim strElementID
	Dim strIconImageSeries
	
	Dim strIconTitleSeries
	Dim bIsClientAccount

	strElementID = "bug_status_icon_" & iInputBugID
	strIconImageSeries = "'" & g_strOpenBugIcon & "', '" & g_strOnHoldBugIcon & "', '" & g_strClosedBugIcon & "'"
	strIconTitleSeries = "'Open', 'On-Hold', 'Closed'"

	Select Case iInputStatusID

		Case BUG_STATUS_OPEN_ID
			if (g_bIsClientAccount = true) then
				strRtnValue = ICON_BUG_OPEN
			else
				strRtnValue = "<img class=""icon_ajax"" id=""" & strElementID & """ onclick=""AjaxUpdateBug(" & iInputBugID & ", 'id_status', GetBugStatusID('" & strElementID & "') ); CycleIconImage('" & strElementID & "', " & strIconImageSeries & ", 'images_icons/', " & strIconTitleSeries & "); "" border=""0"" title=""Open"" src=""images_icons/" & g_strOpenBugIcon & """ class=""general_icon_adjustment"" style=""cursor: url('custom.cur'),hand;"">"
			end if
		
		Case BUG_STATUS_ON_HOLD_ID
			if (g_bIsClientAccount = true) then
				strRtnValue = ICON_BUG_ON_HOLD
			else
				strRtnValue = "<img class=""icon_ajax"" id=""" & strElementID & """ onclick=""AjaxUpdateBug(" & iInputBugID & ", 'id_status', GetBugStatusID('" & strElementID & "') ); CycleIconImage('" & strElementID & "', " & strIconImageSeries & ", 'images_icons/', " & strIconTitleSeries & "); "" border=""0"" title=""On-hold"" src=""images_icons/" & g_strOnHoldBugIcon & """ class=""general_icon_adjustment"" style=""cursor: url('custom.cur'),hand;"">"
			end if
					
		Case BUG_STATUS_CLOSED_ID
			if (g_bIsClientAccount = true) then
				strRtnValue = ICON_BUG_CLOSED
			else
				strRtnValue = "<img class=""icon_ajax"" id=""" & strElementID & """ onclick=""AjaxUpdateBug(" & iInputBugID & ", 'id_status', GetBugStatusID('" & strElementID & "') ); CycleIconImage('" & strElementID & "', " & strIconImageSeries & ", 'images_icons/', " & strIconTitleSeries & "); "" border=""0"" title=""Closed"" src=""images_icons/" & g_strClosedBugIcon & """ class=""general_icon_adjustment"" style=""cursor: url('custom.cur'),hand;"">"
			end if
			
	End Select
	
	
	GetBugStatusIcon = strRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------	
Function GetBugPriorityIcon(iInputPriorityID, iInputBugID)

	Dim strRtnValue
	Dim strElementID
	Dim strIconImageSeries
	
	Dim strIconTitleSeries
	
	strElementID = "bug_priority_icon_" & iInputBugID
	strIconImageSeries = "'" & g_strPriorityHighIcon & "', '" & g_strPriorityNormalIcon & "', '" & g_strPriorityLowUIIcon & "'"
	strIconTitleSeries = "'High', 'Normal', 'Low (UI)'"
	
	Select Case iInputPriorityID

		Case BUG_PRIORITY_HIGH_ID
			if (g_bIsClientAccount = true) then
				strRtnValue = ICON_PRIORITY_HIGH
			else
				strRtnValue = "<img class=""icon_ajax"" id=""" & strElementID & """ onclick=""AjaxUpdateBug(" & iInputBugID & ", 'id_priority', GetBugPriorityID('" & strElementID & "') ); CycleIconImage('" & strElementID & "', " & strIconImageSeries & ", 'images_icons/', " & strIconTitleSeries & ");"" border=""0"" title=""High"" src=""images_icons/" & g_strPriorityHighIcon & """ class=""general_icon_adjustment"" style=""cursor: url('custom.cur'),hand;"">"
			end if
			
		Case BUG_PRIORITY_NORMAL_ID
			if (g_bIsClientAccount = true) then
				strRtnValue = ICON_PRIORITY_NORMAL
			else
				strRtnValue = "<img class=""icon_ajax"" id=""" & strElementID & """ onclick=""AjaxUpdateBug(" & iInputBugID & ", 'id_priority', GetBugPriorityID('" & strElementID & "') ); CycleIconImage('" & strElementID & "', " & strIconImageSeries & ", 'images_icons/', " & strIconTitleSeries & ");"" border=""0"" title=""Normal"" src=""images_icons/" & g_strPriorityNormalIcon & """ class=""general_icon_adjustment"" style=""cursor: url('custom.cur'),hand;"">"
			end if		
			
		Case BUG_PRIORITY_LOW_UI_ID
			if (g_bIsClientAccount = true) then
				strRtnValue = ICON_PRIORITY_LOW
			else		
				strRtnValue = "<img class=""icon_ajax"" id=""" & strElementID & """ onclick=""AjaxUpdateBug(" & iInputBugID & ", 'id_priority', GetBugPriorityID('" & strElementID & "') ); CycleIconImage('" & strElementID & "', " & strIconImageSeries & ", 'images_icons/', " & strIconTitleSeries & ");"" border=""0"" title=""Low (UI)"" src=""images_icons/" & g_strPriorityLowUIIcon & """ class=""general_icon_adjustment"" style=""cursor: url('custom.cur'),hand;"">"
			end if
			
	End Select
	
	GetBugPriorityIcon = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------	
Function GetBugTypeIcon(iInputTypeID, iInputBugID)

	Dim strRtnValue
	Dim strElementID
	Dim strIconImageSeries
	
	Dim strIconTitleSeries
	
	strElementID = "bug_type_icon_" & iInputBugID
	strIconImageSeries = "'" & g_strTypeBugIcon & "', '" & g_strTypeFeatureRequestIcon & "', '" & g_strTypeGeneralIcon & "'"
	strIconTitleSeries = "'Bug', 'Feature', 'General'"
	
	Select Case iInputTypeID

		Case BUG_TYPE_BUG_ID
			if (g_bIsClientAccount = true) then
				strRtnValue = ICON_TYPE_BUG
			else
				strRtnValue = "<img class=""icon_ajax"" id=""" & strElementID & """ onclick=""AjaxUpdateBug(" & iInputBugID & ", 'id_type', GetBugTypeID('" & strElementID & "') ); CycleIconImage('" & strElementID & "', " & strIconImageSeries & ", 'images_icons/', " & strIconTitleSeries & ");"" border=""0"" title=""Bug"" src=""images_icons/" & g_strTypeBugIcon & """ class=""general_icon_adjustment"" style=""cursor: url('custom.cur'),hand;"">"
			end if
			
		Case BUG_TYPE_FEATURE_REQUEST_ID
			if (g_bIsClientAccount = true) then
				strRtnValue = ICON_TYPE_FEATURE_REQUEST
			else
				strRtnValue = "<img class=""icon_ajax"" id=""" & strElementID & """ onclick=""AjaxUpdateBug(" & iInputBugID & ", 'id_type', GetBugTypeID('" & strElementID & "') ); CycleIconImage('" & strElementID & "', " & strIconImageSeries & ", 'images_icons/', " & strIconTitleSeries & ");"" border=""0"" title=""Feature"" src=""images_icons/" & g_strTypeFeatureRequestIcon & """ class=""general_icon_adjustment"" style=""cursor: url('custom.cur'),hand;"">"
			end if

		Case BUG_TYPE_GENERAL_ID
			if (g_bIsClientAccount = true) then
				strRtnValue = ICON_TYPE_GENERAL
			else
				strRtnValue = "<img class=""icon_ajax"" id=""" & strElementID & """ onclick=""AjaxUpdateBug(" & iInputBugID & ", 'id_type', GetBugTypeID('" & strElementID & "') ); CycleIconImage('" & strElementID & "', " & strIconImageSeries & ", 'images_icons/', " & strIconTitleSeries & ");"" border=""0"" title=""General"" src=""images_icons/" & g_strTypeGeneralIcon & """ class=""general_icon_adjustment"" style=""cursor: url('custom.cur'),hand;"">"
			end if

	End Select
	
	GetBugTypeIcon = strRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawBugListHTML()

	Dim strSearchBoxInitialViewStateDIV
	Dim strSearchBoxInitialViewStateIcon
	Dim strSearchBoxInitialViewStateTitleWidth
	
	Dim strSearchBoxInitialViewStateTitleHeight
	Dim g_strSearchBoxExpandingZoneIsOpen
	
	g_strSearchBoxExpandingZoneIsOpen = GetCookie("search_box_expanding_zone_is_open")
	
	if (g_strSearchKeyword = "") then
		strSearchBoxInitialViewStateDIV = "none;"
		strSearchBoxInitialViewStateIcon = "images_icons/icon_expand_zone_open.png"
		strSearchBoxInitialViewStateTitleWidth = "85"
		strSearchBoxInitialViewStateTitleHeight = "14"
	else
		strSearchBoxInitialViewStateDIV = "inline;"
		strSearchBoxInitialViewStateIcon = "images_icons/icon_expand_zone_close.png"
		strSearchBoxInitialViewStateTitleWidth = "1"		
		strSearchBoxInitialViewStateTitleHeight = "1"
	end if
	
	if (g_strSearchBoxExpandingZoneIsOpen = STR_TRUE) then
		strSearchBoxInitialViewStateDIV = "inline;"
		strSearchBoxInitialViewStateIcon = "images_icons/icon_expand_zone_close.png"
		strSearchBoxInitialViewStateTitleWidth = "1"		
		strSearchBoxInitialViewStateTitleHeight = "1"
	end if
	
	%>	
	<table width="100%">
	<tr>
		<td class="heading_bug_list" colspan="3" align="left"><%= GetBugListTitle() %></td>
	</tr>
	
	<% if (g_strSaveOperation = SAVE_OPERATION_SUCCESSFUL) then %>
	<tr>
		<td colspan="3" align="left" style="padding-bottom: 5px;"><% DrawSaveSuccessfulHTML(g_strSaveOperation) %></td>
	</tr>
	<% end if %>
	
	<tr>
		<td colspan="3">&nbsp;</td>
	</tr>
	<tr>
		<td colspan="3" align="center">
		
	<table width="100%">
	<tr>
		<td class="bug_list_table_header" width="55" align="left">ID</td>
		<td class="bug_list_table_header" width="550" align="left">Title</td>
		<td class="bug_list_table_header" width="60" align="left">Owner</td>
		<td class="bug_list_table_header" width="60" align="center" style="font-weight: normal;">Status</td>
		<td class="bug_list_table_header" width="60" align="center" style="font-weight: normal;">Priority</td>
		<td class="bug_list_table_header" width="60" align="center" style="font-weight: normal;">Type</td>		
	</tr>
	
	<% DrawBugListItemsHTML() %>
	
	</table>
						
		</td>
	</tr>
	<tr>
		<td class="paging_mechanism" width="30%" align="left">
		<% if (g_iAccessPrivSearchBox = INT_TRUE) then %>

		<div class="float_left" style="margin: 5px 0 0 0;"><a href="" OnClick="javascript:ExpandSearch(); return false;"><img id="expanding_zone_icon_search" src="<%= strSearchBoxInitialViewStateIcon %>" alt="Expanding Zone"/></a><img OnClick="javascript:ExpandSearch(); return false;" src="images_layout/expanding_zone_title_search.png" id="expanding_zone_title_search" width="<%= strSearchBoxInitialViewStateTitleWidth %>" height="<%= strSearchBoxInitialViewStateTitleHeight %>"  alt="Search" class="icon_expanding_zone" style="margin: 0 0 4px 0;" class="clickable_element" /></div>
		
		<div style="display: <%= strSearchBoxInitialViewStateDIV %>" id="search_box" class="search_content_container">
		<form name="frm_search" id="keyword_search_form" class="standard_form;">
		<input type="text" id="search_keyword_textbox" name="txt_keyword" onKeyDown="ResetTextboxBackground('search_keyword_textbox');" value="<%= g_strSearchKeyword %>" maxlength="96" style="width: 115px; background-repeat: no-repeat; background-position: center center; color: #5f5f5f;" class="control_textbox_search float_left">
		<div class="ctrl_button_small float_left button_spacer"><a href="javascript:void();" onClick="ValidateSearch('<%= g_strPageName %>'); return false;">Search</a></div>
		
		<% if (NOT Trim(g_strSearchKeyword) = "") then %>
			<a href="<%= g_strPageName %>" style="margin: 5px 0 0 0px; float: left;">Reset</a>
		<% end if %>
		<%= GetPopupHelpDB(16, OVERLIB_X_POS) %>
		</form>
		
		</div >
		
		<% else %>
		&nbsp;
		<% end if %>
		</td>
		
		<td class="paging_mechanism" width="47%" align="center"><% DrawToggleFiltersHTML() %></td>
		
		<td class="paging_mechanism" width="23%" align="right"><% DrawPagingMechanismHTML() %></td>
	</tr>
	</table>
	
		</td>
	</tr>
	</table>
	
	<table width="900">
	<tr>
		<td align="left" valign="top">
		
	<%
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawToggleFiltersHTML()

	Dim g_strFilterTogglesExpandingZoneIsOpen
	Dim strToggleFiltersInitialViewStateDIV
	Dim strToggleFiltersInitialViewStateIcon

	Dim strToggleFiltersInitialViewStateTitleWidth
	Dim strToggleFiltersInitialViewStateTitleHeight

	g_strFilterTogglesExpandingZoneIsOpen = GetCookie("filter_toggles_expanding_zone_is_open")
	
	if (g_strFilterTogglesExpandingZoneIsOpen = STR_TRUE) then
		strToggleFiltersInitialViewStateDIV = "inline;"
		strToggleFiltersInitialViewStateIcon = "images_icons/icon_expand_zone_close.png"
		strToggleFiltersInitialViewStateTitleWidth = "1"		
		strToggleFiltersInitialViewStateTitleHeight = "1"
	else
		strToggleFiltersInitialViewStateDIV = "none;"
		strToggleFiltersInitialViewStateIcon = "images_icons/icon_expand_zone_open.png"
		strToggleFiltersInitialViewStateTitleWidth = "85"
		strToggleFiltersInitialViewStateTitleHeight = "14"
	end if
	
	%>
	<script language=""JavaScript"">

		</script>
	
	<% if (g_iAccessPrivShowFilterToggles = INT_TRUE) then %>
	<table>
	<tr>
		<td><a href="" OnClick="javascript:ExpandFilterToggles(); return false;" style="border-bottom: none;"><img id="expanding_zone_icon_filter_toggles" vspace="1" src="<%= strToggleFiltersInitialViewStateIcon %>" alt="Filter Toggles" class="icon_expanding_zone" /></a><img OnClick="javascript:ExpandFilterToggles(); return false;" src="images_layout/expanding_zone_title_filter_toggles.png" id="expanding_zone_title_filter_toggles" width="<%= strToggleFiltersInitialViewStateTitleWidth %>" height="<%= strToggleFiltersInitialViewStateTitleHeight %>" align="absmiddle" alt="Filter Toggles" class="clickable_element" /></td>
		<td>
	
	<DIV style="display: <%= strToggleFiltersInitialViewStateDIV %>" id="filter_toggles">	
	<table>
	<tr>
		<td style="padding: 0 8px 0 0;"></td>
		<td width="2"> </td>
		<% Call DrawFilterToggleButtonHTML(TOGGLE_BUG_STATUS_OPEN, ICON_TOGGLE_ON_BUG_OPEN, ICON_TOGGLE_OFF_BUG_OPEN) %>
		
		<td width="0" height="32"></td>
		<% Call DrawFilterToggleButtonHTML(TOGGLE_BUG_STATUS_ON_HOLD, ICON_TOGGLE_ON_BUG_ON_HOLD, ICON_TOGGLE_OFF_BUG_ON_HOLD) %>
		
		<td width="0" height="32"></td>
		<% Call DrawFilterToggleButtonHTML(TOGGLE_BUG_STATUS_CLOSED, ICON_TOGGLE_ON_BUG_CLOSED, ICON_TOGGLE_OFF_BUG_CLOSED) %>
		
		<td width="11" height="32"></td>
		<% Call DrawFilterToggleButtonHTML(TOGGLE_PRIORITY_HIGH, ICON_TOGGLE_ON_PRIORITY_HIGH, ICON_TOGGLE_OFF_PRIORITY_HIGH) %>
		
		<td width="0" height="32"></td>
		<% Call DrawFilterToggleButtonHTML(TOGGLE_PRIORITY_NORMAL, ICON_TOGGLE_ON_PRIORITY_NORMAL, ICON_TOGGLE_OFF_PRIORITY_NORMAL) %>
		
		<td width="0" height="32"></td>
		<% Call DrawFilterToggleButtonHTML(TOGGLE_PRIORITY_LOW, ICON_TOGGLE_ON_PRIORITY_LOW, ICON_TOGGLE_OFF_PRIORITY_LOW) %>
	
		<td width="11" height="32"></td>
		<% Call DrawFilterToggleButtonHTML(TOGGLE_TYPE_BUG, ICON_TOGGLE_ON_TYPE_BUG, ICON_TOGGLE_OFF_TYPE_BUG) %>
		
		<td width="0" height="32"></td>
		<% Call DrawFilterToggleButtonHTML(TOGGLE_TYPE_FEATURE, ICON_TOGGLE_ON_TYPE_FEATURE, ICON_TOGGLE_OFF_TYPE_FEATURE) %>
		
		<td width="0" height="32"></td>
		<% Call DrawFilterToggleButtonHTML(TOGGLE_TYPE_GENERAL, ICON_TOGGLE_ON_TYPE_GENERAL, ICON_TOGGLE_OFF_TYPE_GENERAL) %>
		
		<td style="padding-left: 6px;"><% if (NOT g_iUserPopUpHelpStyle = POP_UP_HELP_NONE) then %><img src="images_icons/icon_dotted_arrow.png" alt="" style="padding: 0 0 3px 0;" /><% end if %><%= GetPopupHelpDB(17, OVERLIB_X_POS) %></td>
		
	</tr>
	</table>
	</DIV>
	

		</td>
	</tr>	
	</table>
	<% end if %>
	
	<%  

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawFilterToggleButtonHTML(iInputToggleButtonID, strInputIconToggleOn, strInputIconToggleOff)

	Dim iButtonIsToggledOn
	Dim strToggleBackground
	Dim strToggleIcon

	'get the toggles current status by going to its relevant position in the toggle state string
	iButtonIsToggledOn = CInt(Mid(g_strFilterToggleStates, iInputToggleButtonID, 1))
	
	if (iButtonIsToggledOn = INT_TRUE) then
		strToggleBackground = TOGGLE_BKG_ON
		strToggleIcon = strInputIconToggleOn
		iButtonIsToggledOn = INT_FALSE 'reverse toggle button state in case the user submits a new toggle state
	else
		strToggleBackground = TOGGLE_BKG_OFF
		strToggleIcon = strInputIconToggleOff
		iButtonIsToggledOn = INT_TRUE
	end if
		
	%>
	<td background="images/<%= strToggleBackground %>" width="32" height="32" align="center">
	<a href="<%= g_strPageName %>?btn_toggle_id=<%= iInputToggleButtonID %>&btn_toggle_state=<%= iButtonIsToggledOn %>" class="icon_hyperlink"><%= strToggleIcon %></a>
	</td>
	<%

End Function
'--------------------------------------------------------------------------------------------------------
Function GetProjectTotals()

	Dim iArrRtnValue(12)
	Dim strSqlQuery
	Dim objRecordSet
	
	Dim iOpen
	Dim iOnHold
	Dim iClosed
	
	Dim iHigh
	Dim iNormal
	Dim iLowUI
	
	Dim iTotalBugs
	Dim iFeatureRequest
	Dim iGeneral
	
	Dim iTotalFeatures
	Dim iFeaturesAwaitingApproval
	Dim iOpenIssuesAssignedToClient
	
	Dim iTimeEstimateTotalForFeatures
	Dim iTimeEstimateTotalForBugs	
	Dim iOpenBugs
	
	iOpen = 0
	iOnHold = 0
	iClosed = 0
	iHigh = 0
	iNormal = 0
	iLowUI = 0
	iTotalBugs = 0
	iFeatureRequest = 0
	iGeneral = 0
	iTotalFeatures = 0
	iFeaturesAwaitingApproval  = 0
	iTimeEstimateTotalForFeatures = 0
	iTimeEstimateTotalForBugs = 0
	iOpenIssuesAssignedToClient = 0
	iOpenBugs = 0
	
	strSqlQuery = "SELECT * FROM tbl_bugs WHERE (has_been_deleted = 0) AND (id_project = " & g_iActiveProjectID & ");"

	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	'cycle thru all returned records and tally-up as you go along (hey, its better then multiple db calls).
	Do Until objRecordSet.EOF

	
		Select Case objRecordSet("id_status")
		
			Case BUG_STATUS_OPEN_ID
				iOpen = iOpen + 1
				
			Case BUG_STATUS_ON_HOLD_ID
				iOnHold = iOnHold + 1
				
			Case BUG_STATUS_CLOSED_ID
				iClosed = iClosed + 1
				
		End Select
		
		
		Select Case objRecordSet("id_priority")
		
			Case BUG_PRIORITY_HIGH_ID
				iHigh = iHigh + 1
				
			Case BUG_PRIORITY_NORMAL_ID
				iNormal = iNormal + 1
				
			Case BUG_PRIORITY_LOW_UI_ID
				iLowUI = iLowUI + 1
				
		End Select
		
		
		Select Case objRecordSet("id_type")
		
			Case BUG_TYPE_BUG_ID
				iTotalBugs = iTotalBugs + 1
				if (objRecordSet("id_status") = BUG_STATUS_OPEN_ID) then 
					iOpenBugs = iOpenBugs + 1
				end if
				
			Case BUG_TYPE_FEATURE_REQUEST_ID
				iFeatureRequest = iFeatureRequest + 1
				
			Case BUG_TYPE_GENERAL_ID
				iGeneral = iGeneral + 1
				
		End Select
		
		
		'only add to the requires approval tally if the bug is still open (we dont need to know about it if its been approved already)
		if ( (objRecordSet("requires_client_approval") = INT_TRUE) AND ( (objRecordSet("id_status") = BUG_STATUS_OPEN_ID) OR (objRecordSet("id_status") = BUG_STATUS_ON_HOLD_ID) ) ) then
			iFeaturesAwaitingApproval = iFeaturesAwaitingApproval + 1
		end if
		
		'only say that an issue is assigned to a client if its open (why do we want to know about it if its closed?)		
		if (objRecordSet("id_status") = BUG_STATUS_OPEN_ID) then
			iOpenIssuesAssignedToClient = iOpenIssuesAssignedToClient + IsClientAccount(objRecordSet("id_user_assigned_to"))
		end if
		
		'get a tally of the number of hours remaining on open tasks only (no point getting time for tasks already closed).
		if ( _
			 (NOT objRecordSet("id_status") = BUG_STATUS_CLOSED_ID) AND _		
			 (IsNull(objRecordSet("time_estimate")) = false) AND _
			 (NOT Trim(objRecordSet("time_estimate")) = "") _
			 ) then
			 
			'we are making a distrinction for the time required to do feature additions vs bug fixes
			if (objRecordSet("id_type") = BUG_TYPE_BUG_ID) then
				iTimeEstimateTotalForBugs = iTimeEstimateTotalForBugs + CDbl(objRecordSet("time_estimate"))
			elseif (objRecordSet("id_type") = BUG_TYPE_FEATURE_REQUEST_ID) then
				iTimeEstimateTotalForFeatures = iTimeEstimateTotalForFeatures + CDbl(objRecordSet("time_estimate"))
			end if
			
		end if
		
		objRecordSet.MoveNext
	Loop
				
	objRecordSet.Close
	Set objRecordSet = Nothing	
	
	iTotalFeatures = iOpen + iOnHold + iClosed

	iArrRtnValue(0) = iOpen
	iArrRtnValue(1) = iOnHold
	iArrRtnValue(2) = iClosed
	iArrRtnValue(3) = iHigh
	iArrRtnValue(4) = iNormal
	iArrRtnValue(5) = iLowUI
	iArrRtnValue(6) = iOpenBugs & "<sup title=""Total Bugs: " & iTotalBugs & """ class=""tool_tip"">T</sup>"
	iArrRtnValue(7) = iFeatureRequest
	iArrRtnValue(8) = iGeneral 
	iArrRtnValue(9) = iTotalFeatures 
	iArrRtnValue(10) = iFeaturesAwaitingApproval
	iArrRtnValue(11) = "<b>" & iTimeEstimateTotalForBugs & "</b><sup title=""Bugs"" class=""tool_tip"">B</sup> / <b>" & iTimeEstimateTotalForFeatures & "</b><sup title=""Features"" class=""tool_tip"">F</sup>"
	iArrRtnValue(12) = iOpenIssuesAssignedToClient

	GetProjectTotals = iArrRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function IsClientAccount(iInputUserID)
	
	Dim iRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	strSqlQuery = "SELECT id_user FROM tbl_users WHERE (id_user_account_type = " & ACCOUNT_TYPE_ID_CLIENT & ") AND (id_user = " & iInputUserID & ");"

	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (NOT objRecordSet.EOF) then
		iRtnValue = 1
	else
		iRtnValue = 0
	end if
	
	objRecordSet.Close
	Set objRecordSet = Nothing	
	
	IsClientAccount = iRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawSummaryZoneHTML()

	Dim iArrProjectTotals
	
	Dim g_strSummaryExpandingZoneIsOpen
	
	g_strSummaryExpandingZoneIsOpen = GetCookie("summary_panel_expanding_zone_is_open")

	Dim strSummaryInitialViewStateDIV
	Dim strSummaryInitialViewStateIcon
	Dim strSummaryInitialViewStateTitleWidth
	Dim strSummaryInitialViewStateTitleHeight
	Dim strSummaryInitialViewStateVertLine

	if (g_strSummaryExpandingZoneIsOpen = STR_TRUE) then
		strSummaryInitialViewStateDIV = "inline;"
		strSummaryInitialViewStateIcon = "images_icons/icon_expand_zone_close.png"
		strSummaryInitialViewStateTitleWidth = "1"		
		strSummaryInitialViewStateTitleHeight = "1"
		strSummaryInitialViewStateVertLine = ""
	else
		strSummaryInitialViewStateDIV = "none;"
		strSummaryInitialViewStateIcon = "images_icons/icon_expand_zone_open.png"
		strSummaryInitialViewStateTitleWidth = "96"
		strSummaryInitialViewStateTitleHeight = "14"
		strSummaryInitialViewStateVertLine  = "none;"
	end if
	
	iArrProjectTotals = GetProjectTotals()

	if (g_iAccessPrivSummaryPanel = INT_TRUE) then
	%>	
	
	<div class="medium_spacer float_clear"></div>
	<div class="float_left">
	<a href="" style="border-bottom: none;" OnClick="javascript:ExpandSummaryPanel(); return false;"><img style="position: relative; top: 10px;" id="expanding_zone_icon_sumamry_panel" src="<%= strSummaryInitialViewStateIcon %>" alt="Expanding Zone"/></a><img OnClick="javascript:ExpandSummaryPanel(); return false;" id="expanding_zone_title_summary_panel" style="position: relative; top: 9px;" src="images_layout/expanding_zone_title_summary.png" width="<%= strSummaryInitialViewStateTitleWidth %>" height="<%= strSummaryInitialViewStateTitleHeight %>" alt="Summary" class="clickable_element" />
	</div>
	
	<div class="summary_content_container">	
	<div style="display: <%= strSummaryInitialViewStateDIV %>;" id="summary_panel">
	
	<a title="<%= g_rsActiveProject("project_name") %>" href="projects.asp?mode=6"><%= g_rsActiveProject("project_code") %></a>
	<%= DrawStatusIcon(g_rsActiveProject("project_is_active")) %><span class="standard_divider">|</span><span style="color: #000;">PM:</span> <%= GetUserShortName(g_rsActiveProject("id_user_project_manager"), false) %>
	<%= GetPopupHelpDB(19, OVERLIB_X_POS) %>
		
	<table  cellpadding="0" cellspacing="0" width="100%" class="tbl_summary">
	<tr>
		<td class="sub_heading_summary" colspan="2" style="padding: 0 0 3px 0;">Status</td>
		<td class="heading_summary" width="30">&nbsp;</td>
		<td class="sub_heading_summary" colspan="2" style="padding: 0 0 3px 0;">Priority</td>
		<td class="heading_summary" width="30">&nbsp;</td>
		<td class="sub_heading_summary" colspan="2" style="padding: 0 0 3px 0;">Type</td>
		<td class="heading_summary" width="30">&nbsp;</td>
		<td class="sub_heading_summary" colspan="2" style="padding: 0 0 3px 0;">Metrics</td>
		<td width="30">&nbsp;</td>
		<td></td>
		<td></td>
	</tr>
	<tr>
		<td class="summary_text"><img src="images_icons/<%= ICON_BUG_OPEN_FILE %>" class="general_icon_adjustment icon_tool_tip" title="Open Issues"  /></td>
		<td class="summary_text">x <%= iArrProjectTotals(0) %></td>
		<td class="summary_text" width="30" height="30">&nbsp;</td>
		<td class="summary_text"><img src="images_icons/<%= ICON_PRIORITY_HIGH_FILE %>" class="general_icon_adjustment icon_tool_tip" title="High Priority" /></td>
		<td class="summary_text">x <%= iArrProjectTotals(3) %></td>
		<td class="summary_text" width="30">&nbsp;</td>
		<td class="summary_text"><img src="images_icons/<%= ICON_TYPE_BUG_FILE %>" class="general_icon_adjustment icon_tool_tip" title="Bug"  /></td>
		<td class="summary_text">x <%= iArrProjectTotals(6) %></td>
		<td class="summary_text"width="30">&nbsp;</td>
		<td class="summary_text"><img src="images_icons/<%= ICON_ISSUES_TOTAL_FILE %>" class="general_icon_adjustment icon_tool_tip" alt="Total Logged Issues" title="Total Logged Issues" /></td>
		<td class="summary_text"><b><%= iArrProjectTotals(9) %></b>&nbsp;<%= AdjustForPlural("issue", iArrProjectTotals(9)) %> logged</td>
		<td width="30">&nbsp;</td>		
		<td><img border="0" src="images_icons/<%= ICON_ISSUES_ASSIGNED_TO_CLIENT_FILE %>" class="general_icon_adjustment" alt=""  /></td>
		<td><b><%= iArrProjectTotals(12) %></b>&nbsp;<%= AdjustForPlural("issue", iArrProjectTotals(12)) %> assigned to client</td>
	</tr>
	<tr>
		<td class="summary_text" align="left"><img src="images_icons/<%= ICON_BUG_ON_HOLD_FILE %>" class="general_icon_adjustment icon_tool_tip" title="On-hold Issues"></td>
		<td class="summary_text" align="left">x <%= iArrProjectTotals(1) %></td>
		<td class="summary_text" align="left" width="30" height="35">&nbsp;</td>
		<td class="summary_text" align="left"><img src="images_icons/<%= ICON_PRIORITY_NORMAL_FILE %>" class="general_icon_adjustment icon_tool_tip" title="Normal Priority"></td>
		<td class="summary_text" align="left">x <%= iArrProjectTotals(4) %></td>
		<td class="summary_text" align="left" width="30">&nbsp;</td>
		<td class="summary_text" align="left"><img src="images_icons/<%= ICON_TYPE_FEATURE_REQUEST_FILE %>" class="general_icon_adjustment icon_tool_tip" title="Feature"></td>
		<td class="summary_text" align="left">x <%= iArrProjectTotals(7) %></td>
		<td class="summary_text" align="left" width="30">&nbsp;</td>
		<td class="summary_text"><img src="images_icons/<%= ICON_TIME_REMAINING %>" class="general_icon_adjustment icon_tool_tip" hspace="2" title="Time Estimate"></td>
		<td class="summary_text" align="left"><%= iArrProjectTotals(11) %> hours remaining</td>
		<td width="30">&nbsp;</td>		
		<td><img border="0" src="images_icons/<%= ICON_SHAKE_HANDS %>" class="general_icon_adjustment" hspace="2" alt="Time estimates requiring approval" /></td>
		<td><b><%= iArrProjectTotals(10) %></b>&nbsp;<%= AdjustForPlural("feature", iArrProjectTotals(10)) %> pending approval</td>
	</tr>
	<tr>
		<td class="summary_text" align="left"><img border="0" src="images_icons/<%= ICON_BUG_CLOSED_FILE %>" class="general_icon_adjustment icon_tool_tip" title="Closed Issues"></td>
		<td class="summary_text" align="left">x <%= iArrProjectTotals(2) %></td>
		<td class="summary_text" align="left" width="30">&nbsp;</td>
		<td class="summary_text" align="left"><img border="0" src="images_icons/<%= ICON_PRIORITY_LOW_FILE %>" class="general_icon_adjustment icon_tool_tip" title="Low Priority" /></td>
		<td class="summary_text" align="left">x <%= iArrProjectTotals(5) %></td>
		<td class="summary_text" align="left" width="30">&nbsp;</td>
		<td class="summary_text" align="left"><img border="0" src="images_icons/<%= ICON_TYPE_GENERAL_FILE %>" class="general_icon_adjustment icon_tool_tip" title="General" /></td>
		<td class="summary_text" align="left">x <%= iArrProjectTotals(8) %></td>
		<td class="summary_text" align="left" width="30">&nbsp;</td>
		<td class="summary_text" align="left"></td>
		<td class="summary_text" align="left"></td>
		<td width="30">&nbsp;</td>		
		<td></td>
		<td></td>
	</tr>
	</table>
	</div>
	</div><!-- expanding_content_container -->
	
	<div class="medium_spacer float_clear"></div>
	<% 
	end if 
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawAssignedToAndProjectsHTML()

	Dim g_strAssignedToAndProjectsExpandingZoneIsOpen

	Dim strAssignedToAndProjectsInitialViewStateDIV
	Dim strAssignedToAndProjectsInitialViewStateIcon
	Dim strAssignedToAndProjectsInitialViewStateTitleWidth
	Dim strAssignedToAndProjectsInitialViewStateTitleHeight
	
	Dim strAssignedToAndProjectsInitialViewStateVertLine

	g_strAssignedToAndProjectsExpandingZoneIsOpen = GetCookie("assigned_to_and_projects_expanding_zone_is_open")
	
	if (g_strAssignedToAndProjectsExpandingZoneIsOpen = STR_TRUE) then
		strAssignedToAndProjectsInitialViewStateDIV = "inline;"
		strAssignedToAndProjectsInitialViewStateIcon = "images_icons/icon_expand_zone_close.png"
		strAssignedToAndProjectsInitialViewStateTitleWidth = "1"		
		strAssignedToAndProjectsInitialViewStateTitleHeight = "1"
		strAssignedToAndProjectsInitialViewStateVertLine = ""
		
	else
		strAssignedToAndProjectsInitialViewStateDIV = "none;"
		strAssignedToAndProjectsInitialViewStateIcon = "images_icons/icon_expand_zone_open.png"
		strAssignedToAndProjectsInitialViewStateTitleWidth = "135"
		strAssignedToAndProjectsInitialViewStateTitleHeight = "14"
		strAssignedToAndProjectsInitialViewStateVertLine = "none;"
	end if

	%>	

	<% if (g_iAccessPrivShowAssignedToProject = INT_TRUE) then %>
	<div class="float_left"><a href="" style="border-bottom: none;" OnClick="javascript:ExpandAssignedToAndProjectsPanel(); return false;"><img style="position: relative; top: 10px;" id="expanding_zone_icon_assigned_to_and_projects_panel" src="<%= strAssignedToAndProjectsInitialViewStateIcon %>" alt="Expanding Zone"/></a><img OnClick="javascript:ExpandAssignedToAndProjectsPanel(); return false;" id="expanding_zone_title_assigned_to_and_projects_panel" style="position: relative; top: 9px;" src="images_layout/expanding_zone_title_owner_and_projects.png" width="<%= strAssignedToAndProjectsInitialViewStateTitleWidth %>" height="<%= strAssignedToAndProjectsInitialViewStateTitleHeight %>" alt="Owner / Projects Panel" class="clickable_element"/></div>
	<div style="display: <%= strAssignedToAndProjectsInitialViewStateVertLine %>" id="expanding_zone_vert_line_alt_02" /></div>
	
	<div style="display: <%= strAssignedToAndProjectsInitialViewStateDIV %>;" id="assigned_to_and_projects_panel">
	
	<div class="owner_and_project_content_container">
	<%= GetPopupHelpDB(18, OVERLIB_X_POS) %>

		<% 
		DrawAssignedToUsersHTML()
		DrawProjectsHTML()
		%>
	</div><!-- expanding_content_container -->
		
	</div>
	<div class="medium_spacer float_clear"></div>
	
	<% end if %>
	
	<% 

End Function
'--------------------------------------------------------------------------------------------------------
%>