<!-- Log Bug (02012008) -->

<% 
const LOG_BUG_MODE_NEW_ENTRY = 1
const LOG_BUG_MODE_EDIT = 2
const LOG_BUG_MODE_UPDATE = 3
const LOG_BUG_MODE_INSERT = 4
const LOG_BUG_MODE_SOFT_DELETE = 5
const LOG_BUG_MODE_APPROVE = 6
const LOG_BUG_MODE_DELETE_FILE_ATTACHMENT = 7

const ADD_COMMENT = 8
const EDIT_COMMENT = 9
const DELETE_COMMENT = 10
const UPDATE_COMMENT = 11

const EMAIL_NEW_BUG_LOGGED = 1	
const EMAIL_BUG_UPDATE = 3
const HIDE_EMAIL_NOTIFICATION_ICON = 3
const EMAIL_SENDING_IS_OFF = 4

Dim g_strLogBugPageName
Dim g_strBugID
Dim g_strPageMode

Dim g_strTitle
Dim g_strDescription
Dim g_iStatusID

Dim g_iPriorityID 
Dim g_iTypeID
Dim g_iProjectID

Dim g_iAssignedToUserID 
Dim g_iIsVisibleToClient
Dim g_strSaveOperation

Dim g_iRequiresClientApproval
Dim g_strImplementationCost 
Dim g_strDateLogged 

Dim g_strLoggedByUser
Dim g_strDateClosed 
Dim g_strApprovedByUser

Dim g_strApprovalDisabledStatus
Dim g_strUploadFileName
Dim g_iLoggedByUsedID

Dim g_iCommentID
Dim g_strComment
Dim g_strQuoteCommentID
Dim g_iCommentIsVisibleToClient

Dim g_strLastChangeByUser
Dim g_iEmailNotificationSent
Dim g_iNewlyLoggedBugID

Dim g_strTimeEstimate

'--------------------------------------------------------------------------------------------------------
Function LogBugStartUp()

	g_strBugID = Request.QueryString("bug_id")
	g_strSaveOperation = Request.QueryString("save_operation")
	g_iCommentID = Request.QueryString("comment_id")
	
	'set default values
	g_iStatusID = BUG_STATUS_OPEN_ID
	g_iPriorityID = BUG_PRIORITY_NORMAL_ID
	g_iTypeID = BUG_TYPE_BUG_ID
	g_iIsVisibleToClient = 1
	g_strImplementationCost = 0.0
	g_iEmailNotificationSent = HIDE_EMAIL_NOTIFICATION_ICON

End Function
'--------------------------------------------------------------------------------------------------------
Function TriggerEmailSend(iInputEmailSendMode)
	
	Dim bIsEmailBeingSent
	Dim strArrBugDetails

	'determine if the email notification should even be sent.
	bIsEmailBeingSent = ShouldEmailBeSent()
	
	if (bIsEmailBeingSent = true) then
	
		Select Case iInputEmailSendMode
						
			Case EMAIL_NEW_BUG_LOGGED 'a new bug has just been logged		
				strArrBugDetails = Array(g_iNewlyLoggedBugID, DBSafe(Request.QueryString("txt_title")), "Logged By", g_rsUserAccountDetails("first_name") & " " & g_rsUserAccountDetails("last_name"))
				Call SendBugEmail("A new bug has been logged and assigned to you", " - New Bug", g_iAssignedToUserID, NEW_BUG_COLOUR_SCHEME, strArrBugDetails)
				
			Case EMAIL_BUG_UPDATE 'the bug has been updated. send email to whoever the bug is currently assigned to.
				strArrBugDetails = Array(g_strBugID, g_strTitle, "Updated By", g_strLastChangeByUser)
				Call SendBugEmail("A bug assigned to you has been updated", " - Update", g_iAssignedToUserID, UPDATE_BUG_COLOUR_SCHEME, strArrBugDetails)
				
			Case ADD_COMMENT 'a comment has been added to the bug, notify the person who logged the bug
				strArrBugDetails = Array(g_strBugID, g_strTitle, "Comment By", g_strLastChangeByUser)
				Call SendBugEmail("A comment has been added to a bug which is assigned to you", " - Comment Added", g_iAssignedToUserID, COMMENT_ADDED_COLOUR_SCHEME, strArrBugDetails)				
		
		End Select

	end if

End Function
'--------------------------------------------------------------------------------------------------------
Function SendBugEmail(strInputMessageToUser, strInputSubjectExtraText, iInputEmailRecipientUserID, strInputBkgColour, strInputArrBugDetails)
	
	const EMAIL_FROM = 0
	const EMAIL_SUBJECT = 1
	const EMAIL_ADDITIONAL_MESSGE_BODY = 2
	
	Dim strArrEmailSettings
	Dim strEmailMessageBody
	Dim strEmailSubject
	
	Dim strHtmlHeader
	Dim strHtmlFooter
	Dim strArrBugAttributes
	
	Dim strMessageToUser
	Dim strBugWebUrl	
	Dim strBugWebUrlOverRide
	
	Dim strEmailRecipientUserFullName
	Dim rsEmailRecipientDetails
	
	'get various settings used with the email send-out
	Set rsEmailRecipientDetails = GetEmailRecipientDetails(iInputEmailRecipientUserID)
	strArrEmailSettings = GetEmailSettings()
	strHtmlHeader = GetHtmlHeader(strArrEmailSettings(EMAIL_SUBJECT))
	strHtmlFooter = GetHtmlFooter()
	strArrBugAttributes = GetBugAttributes()
	strBugWebUrlOverRide = GetSystemSetting(34)
	g_iEmailNotificationSent = INT_TRUE
	strEmailRecipientUserFullName = rsEmailRecipientDetails("first_name") & " " & rsEmailRecipientDetails("last_name")
	strEmailSubject = strArrEmailSettings(EMAIL_SUBJECT) & strInputSubjectExtraText
	
	if (Trim(strBugWebUrlOverRide) = "") then
		strBugWebUrl = Request.ServerVariables("PATH_INFO") & "?bug_id=" & strInputArrBugDetails(0)
	else
		strBugWebUrl = strBugWebUrlOverRide
	end if
	
	strMessageToUser = "<br/><br/>" & strInputMessageToUser & ". Go to <a href=""" & strBugWebUrl & """>BugWeb</a> for more details.<br/><br/>"
	
	strEmailMessageBody = strHtmlHeader & _
												CreateEmailSection("", "<b>ATT:</b> " & strEmailRecipientUserFullName & " "  & strMessageToUser, strInputBkgColour) & _
												CreateEmailSection("Bug ID", strInputArrBugDetails(0), strInputBkgColour) & _
												CreateEmailSection("Title", strInputArrBugDetails(1), strInputBkgColour) & _				
												CreateEmailSection(strInputArrBugDetails(2), strInputArrBugDetails(3), strInputBkgColour) & _														
											  CreateEmailSection("Project", GetProjectName(g_iProjectID), strInputBkgColour) & _
												CreateEmailSection("Status", strArrBugAttributes(0), strInputBkgColour) & _
												CreateEmailSection("Priority", strArrBugAttributes(1), strInputBkgColour) & _
												CreateEmailSection("Type", strArrBugAttributes(2), strInputBkgColour) & _																												
												CreateEmailSection("", "<br/>" & strArrEmailSettings(EMAIL_ADDITIONAL_MESSGE_BODY), strInputBkgColour) & _
												strHtmlFooter

	Call SendEmail(rsEmailRecipientDetails("email_address"), strArrEmailSettings(EMAIL_FROM), strEmailSubject, _
								 strEmailMessageBody, g_strSettingDebugModeEnabled, g_strSettingSendEmailsVia, g_strArrSettingsSmtpServer)
	
End Function
'--------------------------------------------------------------------------------------------------------
Function ShouldEmailBeSent()

	Dim bRtnValue
	Dim strTodaysDate
	Dim rsEmailRecipientDetails
	
	'if email sending has been turned off, its all over. no point going any further
	if (g_strSettingEmailSendingIsEnabled = STR_FALSE) then
		bRtnValue = false
		ShouldEmailBeSent = bRtnValue
		g_iEmailNotificationSent = EMAIL_SENDING_IS_OFF
		Exit Function
	end if
	
	Set rsEmailRecipientDetails = GetEmailRecipientDetails(g_iAssignedToUserID)

	'if the user currently looking at the bug is the same person updating the bug, theres no need to send an email (they already know about it)
	if ( CStr(g_iUserID) = CStr(g_iAssignedToUserID) ) then
		bRtnValue = false
		ShouldEmailBeSent = bRtnValue
		g_iEmailNotificationSent = HIDE_EMAIL_NOTIFICATION_ICON
		Exit Function
	end if
	
	'if the user has said they dont want to receive any updates when a bug assigned to them is updated, so be it.
	if (rsEmailRecipientDetails("email_when_bug_is_updated") = INT_TRUE) then
		bRtnValue = true
		ShouldEmailBeSent = bRtnValue
		g_iEmailNotificationSent = INT_TRUE
	else
		bRtnValue = false
		ShouldEmailBeSent = bRtnValue
		g_iEmailNotificationSent = INT_FALSE
		Exit Function
	end if
	
	'user may have set it so they arent informed when a comment is attached to a bug they own
	if (rsEmailRecipientDetails("email_when_comment_is_added") = INT_TRUE) then
		bRtnValue = true
		ShouldEmailBeSent = bRtnValue
		g_iEmailNotificationSent = INT_TRUE
	else
		bRtnValue = false
		ShouldEmailBeSent = bRtnValue
		g_iEmailNotificationSent = INT_FALSE
		Exit Function
	end if
	
	'first, discover if the user has his 'limit emails per day' toggle on.
	if (rsEmailRecipientDetails("limit_emails_per_day") = INT_TRUE) then
			
		strTodaysDate = DBDate(Date())
		
		'compare the date of the last email send out with today's date
		if (DBDate(rsEmailRecipientDetails("date_of_last_email_notification")) = strTodaysDate) then
			
			'the dates match, so other emails have been sent today - but has the limit been reeached?
			if (rsEmailRecipientDetails("emails_sent_for_day_counter") < MAX_EMAIL_NOTIFICATIONS_PER_DAY) then
				Call IncrementSentEamilsCouter(CInt(rsEmailRecipientDetails("emails_sent_for_day_counter")) + 1, g_iAssignedToUserID)	'need to increase the counter of how many emails have been sent for the day
				bRtnValue = true
				g_iEmailNotificationSent = INT_TRUE
			else
				bRtnValue = false
				g_iEmailNotificationSent = INT_FALSE
			end if
				
		else
			Call UpdateDateOfLastEmailNotification(strTodaysDate, g_iAssignedToUserID)	'the dates are different, therefore; update the date to todays date.
			Call IncrementSentEamilsCouter(1, g_iAssignedToUserID)	'increment the 'sent emails for day' counter since we are doing a send-out now.
			bRtnValue = true
			g_iEmailNotificationSent = INT_TRUE
		end if
	
	end if
	
	ShouldEmailBeSent = bRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------
Function IncrementSentEamilsCouter(iInputIncrementValue, iInputUserID)

	Dim strSqlQuery
	Dim objRecordSet

	strSqlQuery = "UPDATE tbl_users SET emails_sent_for_day_counter = " & iInputIncrementValue & " WHERE id_user = " & iInputUserID

	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)
	
End Function
'--------------------------------------------------------------------------------------------------------
Function UpdateDateOfLastEmailNotification(strInputTodaysDate, iInputUserID)

	Dim strSqlQuery
	Dim objRecordSet
				
	strSqlQuery = "UPDATE tbl_users SET date_of_last_email_notification = '" & strInputTodaysDate & "' WHERE id_user = " & iInputUserID

	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetBugAttributes()
	
	Dim strArrRtnValue(2)
	
	Select Case g_iStatusID
		Case BUG_STATUS_OPEN_ID strArrRtnValue(0) = "Open"
		Case BUG_STATUS_ON_HOLD_ID strArrRtnValue(0) = "On-hold"
		Case BUG_STATUS_CLOSED_ID strArrRtnValue(0) = "Closed"
	End Select
	
	Select Case g_iPriorityID
		Case BUG_PRIORITY_HIGH_ID strArrRtnValue(1) = "High"
		Case BUG_PRIORITY_NORMAL_ID strArrRtnValue(1) = "Normal"
		Case BUG_PRIORITY_LOW_UI_ID strArrRtnValue(1) = "Low (UI)"
	End Select
	
	Select Case g_iTypeID
		Case BUG_TYPE_BUG_ID strArrRtnValue(2) = "Bug"
		Case BUG_TYPE_FEATURE_REQUEST_ID strArrRtnValue(2) = "Feature"
		Case BUG_TYPE_GENERAL_ID strArrRtnValue(2) = "General"
	End Select
		
	GetBugAttributes = strArrRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetEmailRecipientDetails(iInputUserID)

	Dim objRecordSet
	Dim strSqlQuery
	Dim rsRtnValue
	
	strSqlQuery = "SELECT * FROM tbl_users WHERE id_user = " & iInputUserID
		
	Set rsRtnValue = GetRecordSet(strSqlQuery)
	
	GetEmailRecipientDetails = rsRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetEmailSettings()

	Dim strArrRtnValue(2)
	Dim objRecordSet
	Dim strSqlQuery
	
	strSqlQuery = "SELECT setting_value FROM tbl_system_configuration WHERE id_system_configuration IN (10, 11, 12);"
		
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (NOT objRecordSet.EOF) then
		strArrRtnValue(0) = objRecordSet("setting_value")
		objRecordSet.MoveNext
		
		strArrRtnValue(1) = objRecordSet("setting_value")
		objRecordSet.MoveNext		
		
		strArrRtnValue(2) = objRecordSet("setting_value")				
	end if
	
	objRecordSet.Close
	Set objRecordSet = Nothing
	
	GetEmailSettings = strArrRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DetermineLogBugPageMode()

	'determine the page mode
	if (Request.QueryString("page_mode") = CStr(LOG_BUG_MODE_UPDATE) AND (NOT g_strBugID = "") ) then
		g_strPageMode = LOG_BUG_MODE_UPDATE
		
	elseif ( (Request.QueryString("page_mode") = "") AND (NOT g_strBugID = "") ) then
		'just a bug id was passed and the page mode specifier is blank, then this means the page is in edit mode
		g_strPageMode = LOG_BUG_MODE_EDIT
		
	elseif (Request.QueryString("page_mode") = CStr(LOG_BUG_MODE_UPDATE) AND (NOT g_strBugID = "") ) then	
		g_strPageMode = LOG_BUG_MODE_UPDATE
		
	elseif (Request.QueryString("page_mode") = CStr(LOG_BUG_MODE_SOFT_DELETE) AND (NOT g_strBugID = "") ) then	
		g_strPageMode = LOG_BUG_MODE_SOFT_DELETE
	
	elseif (Request.QueryString("page_mode") = CStr(LOG_BUG_MODE_APPROVE) AND (NOT g_strBugID = "") ) then	
		g_strPageMode = LOG_BUG_MODE_APPROVE
		
	elseif (Request.QueryString("page_mode") = CStr(LOG_BUG_MODE_DELETE_FILE_ATTACHMENT) AND (NOT g_strBugID = "") ) then	
		g_strPageMode = LOG_BUG_MODE_DELETE_FILE_ATTACHMENT		
		
	elseif (Request.QueryString("page_mode") = CStr(ADD_COMMENT) AND (NOT g_strBugID = "") ) then	
		g_strPageMode = ADD_COMMENT		
		
	elseif (Request.QueryString("page_mode") = CStr(EDIT_COMMENT) AND (NOT g_strBugID = "") ) then	
		g_strPageMode = EDIT_COMMENT
		
	elseif (Request.QueryString("page_mode") = CStr(DELETE_COMMENT) AND (NOT g_strBugID = "") ) then	
		g_strPageMode = DELETE_COMMENT		

	elseif (Request.QueryString("page_mode") = CStr(UPDATE_COMMENT) AND (NOT g_strBugID = "") ) then	
		g_strPageMode = UPDATE_COMMENT		
		
	elseif (Request.QueryString("page_mode") = CStr(LOG_BUG_MODE_INSERT) ) then	
		g_strPageMode = LOG_BUG_MODE_INSERT	
		
	else
		'no page mode was found passed via the querystring, and no bug id was passed either. this means a new bug entry is being made.
		g_strPageMode = LOG_BUG_MODE_NEW_ENTRY
		
	end if

End Function
'--------------------------------------------------------------------------------------------------------
Function FlagBugAsViewedByUser(iInputBugID)

	Dim strSqlQuery
	Dim objRecordSet
				
	strSqlQuery = "UPDATE tbl_bugs SET has_been_looked_at = 1 WHERE id_bug = " & iInputBugID

	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function SetLogBugPageMode()

	DetermineLogBugPageMode()
	
	Select Case CInt(g_strPageMode)

		Case LOG_BUG_MODE_EDIT
			g_strLogBugPageName = "Log Bug" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">Edit Bug</span>"
			GetBugDetails(g_strBugID)
			FlagBugAsViewedByUser(g_strBugID)
		
		case LOG_BUG_MODE_UPDATE
			g_strLogBugPageName = "Log Bug" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">New Bug</span>"
			UpdateBugDetailsToDb(g_strBugID)
			g_strPageMode = LOG_BUG_MODE_EDIT
			GetBugDetails(g_strBugID)
			TriggerEmailSend(EMAIL_BUG_UPDATE)
		
		case LOG_BUG_MODE_INSERT
			g_strLogBugPageName = "Log Bug" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">New Bug</span>"
			AddNewBugToDb()
			TriggerEmailSend(EMAIL_NEW_BUG_LOGGED)
			ActionAfterLoggingBug(g_rsUserAccountDetails("action_after_logging_bug"))
		
		Case LOG_BUG_MODE_SOFT_DELETE
			g_strLogBugPageName = "Log Bug" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">New Bug</span>"
			SoftDeleteBug(g_strBugID)
			Response.Redirect "index.asp?save_operation=1" 'return back to bug listing page.

		Case LOG_BUG_MODE_APPROVE
			g_strLogBugPageName = "Log Bug" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">Edit Bug</span>"
			Call ApproveIssue(g_strBugID, g_iUserID)
			GetBugDetails(g_strBugID)
			g_strPageMode = LOG_BUG_MODE_EDIT
			
		Case LOG_BUG_MODE_DELETE_FILE_ATTACHMENT
			g_strLogBugPageName = "Log Bug" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">Edit Bug</span>"
			GetBugDetails(g_strBugID)		
			Call DeleteFileAttachment(g_strBugID)
			g_strPageMode = LOG_BUG_MODE_EDIT
			
		Case ADD_COMMENT
			g_strLogBugPageName = "Log Bug" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">Edit Bug</span>"
			GetBugDetails(g_strBugID)		
			AddNewComment()
			TriggerEmailSend(ADD_COMMENT)
			g_strPageMode = LOG_BUG_MODE_EDIT
									
		Case EDIT_COMMENT
			g_strLogBugPageName = "Log Bug" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">Edit Bug</span>"
			GetBugDetails(g_strBugID)
			GetCommentDetails()
			
		Case DELETE_COMMENT
			g_strLogBugPageName = "Log Bug" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">Edit Bug</span>"
			GetBugDetails(g_strBugID)
			DeleteComment()
												
		Case UPDATE_COMMENT
			g_strLogBugPageName = "Log Bug" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">Edit Bug</span>"
			GetBugDetails(g_strBugID)
			UpdateComment()
			
		Case Else
			g_strLogBugPageName = "Log Bug" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">New Bug</span>"
	
	End Select

End Function
'--------------------------------------------------------------------------------------------------------
Function ActionAfterLoggingBug(iInputUserSetting)

	Select Case iInputUserSetting
	
	Case AFTER_LOGGING_BUG_LOG_BUG
		g_strPageMode = LOG_BUG_MODE_NEW_ENTRY
	
	Case AFTER_LOGGING_BUG_GO_HOME
		Response.Redirect "index.asp?save_operation=1" 'return back to home page.
		
	Case Else
		response.write "<br/>" & ICON_EXCLAIM & " <b>Error:</b> could not figure out what to do after logging a bug (return to the <a href=""index.asp"">home page</a>)."	
		response.end
	
	End Select

End Function
'--------------------------------------------------------------------------------------------------------
Function UpdateComment()

	Dim strSqlQuery
	Dim objRecordSet
	Dim strQuoteComment

	'the sql query gets adjusted slightly if the user is quoting an existing comment.
	if (Request.QueryString("drp_quote_comment_id") = "") then
		strQuoteComment = "quote_bug_id = 0, "
	else
		strQuoteComment = "quote_bug_id = "	& Request.QueryString("drp_quote_comment_id") & ", "
	end if
	
	strSqlQuery = "UPDATE tbl_bug_comments SET " & _
								"comment = '" & DBSafe(Request.QueryString("txt_bug_comment")) & "', " & _
								strQuoteComment & _
								"visible_to_client = " & BoolToInt(Request.QueryString("chk_comment_visible_to_client")) & " " & _
							  "WHERE id_bug_comment = " & g_iCommentID

	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function AddNewComment()
	
	Dim strSqlQuery
	Dim objRecordSet
	Dim strQuoteCommentIDField
	Dim strQuoteCommentIDValue

	
	'the sql query gets adjusted slightly if the user is quoting an existing comment.
	if (NOT Request.QueryString("drp_quote_comment_id") = "") then
		strQuoteCommentIDField = ", quote_bug_id"
		strQuoteCommentIDValue = ", " & Request.QueryString("drp_quote_comment_id")
	end if

	strSqlQuery = "INSERT INTO tbl_bug_comments " & _
								"(comment, belongs_to_bug_id, comment_by_user_id, " & _
								"visible_to_client " & strQuoteCommentIDField & ") " & _
								"VALUES " & _
								"('" & _
								DBSafe(Request.QueryString("txt_bug_comment")) & "', " & _
								g_strBugID & ", " & _
								g_iUserID & ", " & _
								BoolToInt(Request.QueryString("chk_comment_visible_to_client")) & _
								strQuoteCommentIDValue & _
								");"
	
	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function DeleteComment()

	Dim strSqlQuery
	Dim objRecordSet
				
	strSqlQuery = "DELETE FROM tbl_bug_comments WHERE id_bug_comment = " & g_iCommentID

	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function GetCommentDetails()

	Dim strSqlQuery
	Dim objRecordSet
	
	if (g_iCommentID = "") then
		response.write "<b>Error in 'GetCommentDetails()':</b> the system tried to retreive comment data but no comment id was provided."
		response.end
	end if

	strSqlQuery = "SELECT * FROM tbl_bug_comments WHERE id_bug_comment = " & g_iCommentID
		
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (NOT objRecordSet.EOF) then
		g_strQuoteCommentID = objRecordSet("quote_bug_id")
		g_iCommentIsVisibleToClient = objRecordSet("visible_to_client")
		g_strComment = objRecordSet("comment")
	end if
	
	objRecordSet.Close
	Set objRecordSet = Nothing

End Function
'--------------------------------------------------------------------------------------------------------
Function DeleteFileAttachment(iInputBugID)

	Dim strSqlQuery
	Dim objRecordSet

	'first, update the database so it no longer holds the files name				
	strSqlQuery = "UPDATE tbl_bugs SET upload_file_name = '' WHERE id_bug = " & iInputBugID
	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)
	
	'delete the physical file off the hard disk
	Call DeleteFile(g_strUploadFileName, GetUploadDirectoryFullPath())
	
	'blank out the global variable containing the name of the file
	g_strUploadFileName = ""

End Function
'--------------------------------------------------------------------------------------------------------
Function GetUploadDirectoryFullPath()

	Dim strRtnValue
	Dim strServerVar
	Dim strImagePath
	
	strServerVar = Request.ServerVariables("PATH_TRANSLATED")
	strImagePath = Left(strServerVar, (Len(strServerVar) - Len(GetPageName())))
	
	strRtnValue = strImagePath & g_strUploadDirectory
	
	GetUploadDirectoryFullPath = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function ApproveIssue(iInputBugID, iInputApproverUsedID)

	Dim strSqlQuery
	Dim objRecordSet
				
	strSqlQuery = "UPDATE tbl_bugs SET id_approved_by_user = " & iInputApproverUsedID & " WHERE id_bug = " & iInputBugID

	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function SoftDeleteBug(iInputBugID)

	Dim strSqlQuery
	Dim objRecordSet
				
	strSqlQuery = "UPDATE tbl_bugs SET has_been_deleted = 1 WHERE id_bug = " & iInputBugID

	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function ReplaceMarkupInString(strInputValue)

	Dim strRtnValue
	
	if (GetBugEditPermission() = true) then
		strRtnValue = Replace(strInputValue, "<br/>", vbCrLf)
	else 
		strRtnValue = strInputValue
	end if

	ReplaceMarkupInString = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetBugDetails(iInputBugID)

	Dim strSqlQuery
	Dim objRecordSet
	
	strSqlQuery = "SELECT tbl_bugs.*, tbl_users.first_name+' '+tbl_users.last_name AS logged_by_user, tbl_users.initials AS logged_by_initials, tbl_users_1.first_name+' '+tbl_users_1.last_name AS approved_by_user, tbl_users_1.initials AS approved_by_initials, [tbl_users_2].[first_name]+' '+[tbl_users_2].[last_name] AS last_change_by_user " & _
								"FROM tbl_users AS tbl_users_2 RIGHT JOIN (tbl_users AS tbl_users_1 RIGHT JOIN (tbl_users INNER JOIN tbl_bugs ON tbl_users.id_user = tbl_bugs.id_logged_by_user) ON tbl_users_1.id_user = tbl_bugs.id_approved_by_user) ON tbl_users_2.id_user = tbl_bugs.id_last_change_by_user " & _
								"WHERE (((tbl_bugs.has_been_deleted)=0) AND ((tbl_bugs.id_bug)=" & iInputBugID & "));"
		
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (objRecordSet.EOF) then
		response.write "<br/>" & ICON_EXCLAIM & " <b>Error:</b> no bug could be found associated with that ID (return to the <a href=""index.asp"">home page</a>)."	
		response.end
	else
		g_strTitle = ReplaceMarkupInString(objRecordSet("title"))
		g_strDescription = ReplaceMarkupInString(objRecordSet("description"))
		g_iStatusID = objRecordSet("id_status")
		g_iPriorityID = objRecordSet("id_priority")
		g_iTypeID = objRecordSet("id_type")
		g_iProjectID = objRecordSet("id_project")
		g_iAssignedToUserID = objRecordSet("id_user_assigned_to")
		g_strUploadFileName = objRecordSet("upload_file_name")
		g_iIsVisibleToClient = objRecordSet("visible_to_client")
		g_iRequiresClientApproval = objRecordSet("requires_client_approval")
		g_strImplementationCost = objRecordSet("implementation_cost")
		g_strDateLogged = objRecordSet("date_logged")
		g_iLoggedByUsedID = objRecordSet("id_logged_by_user")
		g_strDateClosed = objRecordSet("date_closed")
		g_strLastChangeByUser = objRecordSet("last_change_by_user")
		g_strTimeEstimate =  objRecordSet("time_estimate")
		
		
		if (g_iAccessPrivShowFullNames = INT_TRUE) then
			g_strLoggedByUser = objRecordSet("logged_by_user")
			g_strApprovedByUser = objRecordSet("approved_by_user")
		else
			g_strLoggedByUser = objRecordSet("logged_by_initials")
			g_strApprovedByUser = objRecordSet("approved_by_initials")
		end if
	
		'if a bug has been approved, it can no longer be set to requiring approval or have a cost set next to it.
		if ( (IsNull(g_strApprovedByUser) = true) OR (Trim(g_strApprovedByUser) = "") ) then
			g_strApprovalDisabledStatus = ""
		else
			g_strApprovalDisabledStatus = " disabled "
		end if 
		
	end if
	
	objRecordSet.Close
	Set objRecordSet = Nothing

End Function
'--------------------------------------------------------------------------------------------------------
Function UpdateBugDetailsToDb(iInputBugID)

	Dim strSqlQuery
	Dim objRecordSet
	Dim fImplementationCost
	
	Dim strDateClosed
	Dim strUploadFile
	Dim iIsVisibleToClient
	
	'bugs should be visible to clients by default.
	if (g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_CLIENT) then
		iIsVisibleToClient = INT_TRUE
	else
		iIsVisibleToClient = CheckboxToInt(Request.QueryString("chk_visible_to_client"))		
	end if
	
	if (Request.QueryString("chk_visible_to_client") = "") then
		iIsVisibleToClient = INT_TRUE
	end if

	'the implementation cost value cant be left blank because its stored as a currency data type in the database
	if (Trim(Request.QueryString("txt_implementation_cost") = "") ) then
		fImplementationCost = 0.0
	else
		fImplementationCost = Request.QueryString("txt_implementation_cost") 
	end if
	
	'put in the close date if the bugs status has been set to 'closed'.
	if ( Request.QueryString("rdo_status") = CStr(BUG_STATUS_CLOSED_ID) ) then
		strDateClosed = DbDate(Date())
	else
		strDateClosed = "01 Jan 1900"
	end if

	strSqlQuery = "UPDATE tbl_bugs SET " & _
								"title = '" & DBSafe(Request.QueryString("txt_title")) & "', " & _
								"description = '" & DBSafe(Request.QueryString("txt_description")) & "', " & _
								"id_priority = " & Request.QueryString("rdo_priority") & ", " & _
								"id_status = " & Request.QueryString("rdo_status") & ", " & _
								"id_type = " & Request.QueryString("rdo_type") & ", " & _
								"id_project = " & Request.QueryString("drp_project") & ", " & _
								"id_user_assigned_to = " & Request.QueryString("drp_assigned_to_user") & ", " & _
								"date_closed = '" & strDateClosed & "', " & _
								"requires_client_approval = " & CheckboxToInt(Request.QueryString("chk_requires_client_approval"))  & ", " & _
								"implementation_cost = " & fImplementationCost& ", " & _
								"visible_to_client = " & iIsVisibleToClient & ", " & _
								"id_last_change_by_user = " & g_iUserID & ", " & _
								"time_estimate = '" & DBSafe(Request.QueryString("txt_time_estimate")) & "' " & _
							  "WHERE id_bug = " & iInputBugID
	
	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

	'add the bug id number to the filename to make it unique
	if (NOT Request.QueryString("upload_file") = "") then
		strUploadFile = RenameAttachedFile(Request.QueryString("upload_file"), iInputBugID)
		strSqlQuery = "UPDATE tbl_bugs SET upload_file_name = '" & strUploadFile & "' WHERE id_bug = " & iInputBugID
		Set objRecordSet = g_objDbConn.Execute(strSqlQuery)
	end if

End Function
'--------------------------------------------------------------------------------------------------------
Function RenameAttachedFile(strInputOriginalFileName, iInputBugID)

	Dim objFSO
	Dim strRtnValue
	Dim strFullPath
	
	Dim strNewFileName
	Dim strArrSplitFileName
	
	strFullPath = GetUploadDirectoryFullPath()

	'tack on the bug id to the end of the file name
	strNewFileName = Left(strInputOriginalFileName, Len(strInputOriginalFileName)-4) & "_id_" & iInputBugID & Right(strInputOriginalFileName, 4)
	
	Set objFSO = Server.CreateObject("Scripting.FileSystemObject")
	Call objFSO.MoveFile(strFullPath & strInputOriginalFileName, strFullPath & strNewFileName)
	Set objFSO = Nothing
	
	strRtnValue = strNewFileName
	
	RenameAttachedFile = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function AddNewBugToDb()

	Dim strSqlQuery
	Dim objRecordSet
	Dim strUploadFileName
	
	Dim fImplementationCost
	Dim iIsVisibleToClient
	Dim strUploadFile
		
	'bugs should be visible to clients by default.
	if (g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_CLIENT) then
		iIsVisibleToClient = INT_TRUE
	else
		iIsVisibleToClient = CheckboxToInt(Request.QueryString("chk_visible_to_client"))		
	end if
	
	if (Request.QueryString("chk_visible_to_client") = "") then
		iIsVisibleToClient = INT_TRUE
	end if
	
	'the implementation cost value cant be left blank because its stored as a currency data type in the database
	if ( Trim(Request.QueryString("txt_implementation_cost") = "") ) then
		fImplementationCost = 0.0
	else
		fImplementationCost = Request.QueryString("txt_implementation_cost") 
	end if

	strSqlQuery = "INSERT INTO tbl_bugs " & _
								"(title, description, id_logged_by_user, " & _
								"id_priority, id_status, id_type, " & _
								"id_project, id_user_assigned_to, requires_client_approval, " & _
								"implementation_cost, visible_to_client, time_estimate) " & _
								"VALUES " & _
								"('" & _
								DBSafe(Request.QueryString("txt_title")) & "', '" & _
								DBSafe(Request.QueryString("txt_description")) & "', " & _
								g_iUserID & ", " & _
								Request.QueryString("rdo_priority") & ", " & _
								Request.QueryString("rdo_status") & ", " & _
								Request.QueryString("rdo_type") & ", " & _
								Request.QueryString("drp_project") & ", " & _
				 				Request.QueryString("drp_assigned_to_user") & ", " & _
								CheckboxToInt(Request.QueryString("chk_requires_client_approval")) & ", " & _
								fImplementationCost & ", " & _
								iIsVisibleToClient & ", '" & _
								DBSafe(Request.QueryString("txt_time_estimate")) & "'" & _
								");"

								
	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

	g_iNewlyLoggedBugID = GetNewlyAddedRecordID()
		
	'add the bug id number to the filename to make it unique
	if (NOT Request.QueryString("upload_file") = "") then
		strUploadFile = RenameAttachedFile(Request.QueryString("upload_file"), g_iNewlyLoggedBugID)
		strSqlQuery = "UPDATE tbl_bugs SET upload_file_name = '" & strUploadFile & "' WHERE id_bug = " & g_iNewlyLoggedBugID
		Set objRecordSet = g_objDbConn.Execute(strSqlQuery)
	end if
	
	'this is needed for the email notification send-out
	g_iAssignedToUserID = Request.QueryString("drp_assigned_to_user")

End Function
'--------------------------------------------------------------------------------------------------------
Function UploadFile()
		
	Dim iCounter
	Dim StrUploadDirectory
	Dim attachment

	Dim attachment_file_name
	Dim attachment_type
	Dim file
	
	Dim file_name
	Dim file_object
	Dim strFileName
	
	Dim element_name
	Dim strServerVar
	Dim strImagePath
	
	'upload the file attachment if there is one.								
	if (NOT Request.Form("file") = "") then
		
		m_form_size = 0
		
		'get the name of the directory the image is to be uploaded too.	
		StrUploadDirectory = g_strUploadDirectory
		
		set file_object = Server.CreateObject("Scripting.FileSystemObject")
		
		attachment = GetBinaryFormField("file", false)
		attachment_type = GetAttachmentType("file")
		attachment_type = GetAttachmentFileType(attachment_type)
		attachment_file_name = GetAttachmentFileName(element_name)
		
		strFileName = GetFileName(attachment_file_name)
	
		strServerVar = Request.ServerVariables("PATH_TRANSLATED")
		strImagePath = Left(strServerVar, (Len(strServerVar) - Len(GetPageName())))
		
		file_name = strImagePath & StrUploadDirectory & strFileName 'adjusted
		
		set file = file_object.CreateTextFile(file_name, true) 'create a file to store the uploaded file
		
		For iCounter = 1 to LenB(attachment)
		  file.Write Chr(AscB(MidB(attachment, iCounter, 1)))
		Next
		
		file.Close
		
		set file = Nothing
		set file_object = Nothing
	
	end if

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawLogBugHeaderHTML()
	
	Dim strEmailNotificationIcon

	if (g_iEmailNotificationSent = INT_TRUE) then
		strEmailNotificationIcon = ICON_EMAIL
	elseif (g_iEmailNotificationSent = INT_FALSE) then
		strEmailNotificationIcon = ICON_EMAIL_NOT_SENT
	elseif (g_iEmailNotificationSent = HIDE_EMAIL_NOTIFICATION_ICON) then
		strEmailNotificationIcon = ""
	elseif (g_iEmailNotificationSent = EMAIL_SENDING_IS_OFF) then
		strEmailNotificationIcon = "<span class=""alert_message"">Email sending is currently switched off.</span>"
	end if 
	
  %>
	<table width="100%">
	
	<tr>
		<td colspan="4" align="left"><% DrawSaveSuccessfulHTML(g_strSaveOperation) %><%= strEmailNotificationIcon %></td>
	</tr>
	
	<tr>
		<td class="heading_bug_list" colspan="4"><%= g_strLogBugPageName %><div class="medium_spacer"</td>
	</tr>

	<% 
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawLogBugFooterHTML()

	%>
	</table>
	<%  

End Function
'--------------------------------------------------------------------------------------------------------
Function GetBugEditPermission()

	Dim bRtnValue
	
	if (CStr(g_iUserID) = CStr(g_iLoggedByUsedID)) then 
		'the current user was the person who originally logged this bug, therefore allow them to modify the bug.
		bRtnValue = true

	elseif ( (g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_CLIENT) AND (NOT g_strPageMode = LOG_BUG_MODE_NEW_ENTRY) ) then
		'the user is a client level user and the system is not in new entry mode (all controls should be enabled if a new bug is being entered)
		bRtnValue = false
		
	else
		'editing of the bug entry is allowed
		bRtnValue = true
		
	end if
	
	GetBugEditPermission = bRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawLogBugHTML()
	
	Dim strAppovalWithCostMessage
	Dim strQueryString
	Dim strArrBugAttributes
	
	Dim bAllowBugEditing
	Dim iBugDescriptionTextareaRows
	
	if (g_iTypeID = BUG_TYPE_FEATURE_REQUEST_ID) then
		strAppovalWithCostMessage = "Approve cost?"
	else
		strAppovalWithCostMessage = "Approve cost?"
	end if
	
	'if its a client account and they havent logged the bug, then the user can't edit the bug details (the acception being the approval button)
	bAllowBugEditing = GetBugEditPermission()
	
	'get some additional bug information needed if the logged bug is in 'read-only' mode.
	if (bAllowBugEditing = false) then
		strArrBugAttributes = GetBugAttributes()
	end if
	
	if (g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_CLIENT) then
		iBugDescriptionTextareaRows = 15
	else
		iBugDescriptionTextareaRows = 10
	end if
		
	%>
	<script type="text/javascript">
	
	function isNumber(s)
	{
		var n = trim(s);
		return n.length>0 && +n == n;
	}
	
	function trim(s)
	{
		return s.replace(/^\s+|\s+$/g, "");
	}
		
	function ValidateTimeEstimate(strInputTimeEstimate)	
	{
		var bIsValidNumber;
		bIsValidNumber = isNumber(strInputTimeEstimate);
		
		if (bIsValidNumber == false)
		{
			document.getElementById("time_estimate_validation_msg").innerText = 'Invalid time estimate (correct format examples: 1, 1.25, 1.5).';
			document.getElementById("time_estimate_validation_msg").style.display = "inline";
		}
			
		return bIsValidNumber;
	}
	
 	function QueryStringSafe(strInputValue)
	{
		var strRtnValue;
		
		strRtnValue = strInputValue.replace("&", "and");
		strRtnValue = strRtnValue.replace("#", "<hash>");
		strRtnValue = strRtnValue.replace(/\n/g, "<br/>");
		
		return strRtnValue;
	}
	 
	function ValidateLogBugForm()	
	{
	
		var iErrorFree;
		iErrorFree = 1;
		
		if (document.getElementById("bug_title").value == '')
		{
			document.getElementById("bug_title").style.backgroundColor = '#FFB7B7';
			document.getElementById("bug_title").style.backgroundPosition = 'left';
      document.getElementById('bug_title').style.backgroundImage = 'url(images/text_required_field_rev_05.gif)';
				
			document.getElementById("bug_title").focus();
			iErrorFree = 0;
			return false;	
		}
		
		<% if (g_rsUserAccountDetails("must_leave_time_estimate") = INT_TRUE) then  %>
		if (document.getElementById("time_estimate_textbox").value == '')
		{
			document.getElementById("time_estimate_validation_msg").innerText = 'You are required to enter a time estimate.';
			document.getElementById("time_estimate_validation_msg").style.display = "inline";
			iErrorFree = 0;
			return false;	
		}
		<% end if %>
		
		if (document.getElementById("time_estimate_textbox").value != '') //only validate time estimate if user has entered a number.
			iErrorFree = ValidateTimeEstimate(document.getElementById("time_estimate_textbox").value);
		
		if (iErrorFree == 1) //there are no more errors, submit the form.
		{
			var strActionPage;
			
			<%
			'generate the query string to submit
			if (g_strPageMode = LOG_BUG_MODE_EDIT) then
				strQueryString = "rtn_page=" & GetPageName() & "&upload_folder=" & g_strUploadDirectory & "&save_operation=1&page_mode=" & LOG_BUG_MODE_UPDATE & "&bug_id=" & g_strBugID
			else
				strQueryString = "rtn_page=" & GetPageName() & "&upload_folder=" & g_strUploadDirectory & "&save_operation=1&page_mode=" & LOG_BUG_MODE_INSERT
			end if
			
			strQueryString = strQueryString & "&txt_title=' + QueryStringSafe(document.getElementById('bug_title').value) + '" & _
																				"&txt_description=' + QueryStringSafe(document.getElementById('bug_description').value) + '" & _
																				"&rdo_status=' + document.getElementById('bug_status').value + '" & _
																				"&rdo_priority=' + document.getElementById('bug_priority').value + '" & _
																				"&rdo_type=' + document.getElementById('bug_type').value + '" & _
																				"&drp_project=' + document.getElementById('bug_project').value + '" & _
																				"&drp_assigned_to_user=' + document.getElementById('assigned_to_user').value + '"

			'there are a few additional controls for admin level users																				
			if (NOT g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_CLIENT) then																	
				strQueryString = strQueryString & "&chk_visible_to_client=' + CheckboxToInt(document.getElementById('visible_to_client').checked) + '" & _
																					"&chk_requires_client_approval=' + CheckboxToInt(document.getElementById('requires_client_approval').checked) + '" & _
																					"&txt_implementation_cost=' + document.getElementById('implementation_cost').value + '" & _
																					"&txt_time_estimate=' + document.getElementById('time_estimate_textbox').value + '"
			end if																			
			%>
			
			if(document.getElementById("upload_file").value == '')
				strActionPage = 'log_bug.asp?';
			else
				strActionPage = 'upload_file.asp?';
			
			document.getElementById('log_bug_form').action = strActionPage + '<%= strQueryString %>'; 
			document.getElementById('log_bug_form').submit();

		}	
		
	}
	
	function CheckboxToInt(bInputValue)	
	{	
		if (bInputValue == false)
			return 0
		else
			return 1
	}
	
	function ResetTextboxBackground()	
	{	
		document.getElementById("bug_title").style.backgroundColor = '#ffffff';
	}
	
	function ConfirmBugSoftDelete()	
	{
	
		var bAnswer = confirm('Delete bug?')
		
		if (bAnswer == true) 
		{
			document.getElementById("log_bug_form").action = '<%= g_strPageName %>?save_operation=1&page_mode=<%= LOG_BUG_MODE_SOFT_DELETE %>&bug_id=<%= g_strBugID %>';
			document.getElementById("log_bug_form").submit();
		}
	}
		
	function ConfirmApprovalWithCost() 
	{

		var bAnswer = confirm('<%= strAppovalWithCostMessage %>');
		
		if (bAnswer == true) 
		{
			document.getElementById("log_bug_form").action = '<%= g_strPageName %>?save_operation=1&page_mode=<%= LOG_BUG_MODE_APPROVE %>&bug_id=<%= g_strBugID %>';
			document.getElementById("log_bug_form").submit();
		}
			
	}		
	
	function ConfirmDeleteFileAttachment()
	{
	
		var bAnswer = confirm('Delete attachment?');
		
		if (bAnswer == false)
		{
			//do nothing
		}
		else
		{
			window.location = "<%= g_strPageName %>?save_operation=1&page_mode=<%= LOG_BUG_MODE_DELETE_FILE_ATTACHMENT %>&bug_id=<%= g_strBugID %>";
		}

	}
	
	</script>	
				
	<style type="text/css">
	<!--
	form.file_upload_form input { font-family: Verdana; font-size: 15px; color: #666666; 	}
	
	div.fileinputs { position: relative;  }
	
	div.fakefile { position: absolute; top: 0px; left: 0px;	z-index: 1;	 }
	
	input.file { position: relative; text-align: left; -moz-opacity: 0; filter: alpha(opacity: 0); opacity: 0; z-index: 2;	}
	
	.file_upload_form { display: inline; }
	-->
	</style>
	
	
	<form id="log_bug_form" class="file_upload_form" name="frm_upload_file" action="" method="post" enctype="multipart/form-data">
	
	<% if (NOT g_strPageMode = LOG_BUG_MODE_NEW_ENTRY) then %>
	<tr>
		<td  class="table_label"  style="padding-top: 0px;">Bug ID:</td>
		<td ><%= g_strBugID %></td>
		<td rowspan="13" class="bug_comments">
		<% DrawBugCommentsHTML() %>
		</td>
	</tr>
	<% end if %>
	
		
	<tr>
		<td class="table_label">Status:</td>
		<td class="table_radio_button">
		<% if (bAllowBugEditing = false) then %>
			<%= strArrBugAttributes(0) %>
		<% else %>
			<input name="rdo_status" onclick="document.getElementById('bug_status').value = <%= BUG_STATUS_OPEN_ID %>;" type="radio" <%= IsChecked(g_iStatusID, BUG_STATUS_OPEN_ID) %> value="<%= BUG_STATUS_OPEN_ID %>" class="ctrl_radio_button"><span class="">Open</span>
			<input name="rdo_status" onclick="document.getElementById('bug_status').value = <%= BUG_STATUS_ON_HOLD_ID %>;" type="radio" <%= IsChecked(g_iStatusID, BUG_STATUS_ON_HOLD_ID) %> value="<%= BUG_STATUS_ON_HOLD_ID %>" class="ctrl_radio_button"><span class="">On-Hold</span>
			<input name="rdo_status" onclick="document.getElementById('bug_status').value = <%= BUG_STATUS_CLOSED_ID %>;" type="radio" <%= IsChecked(g_iStatusID, BUG_STATUS_CLOSED_ID) %> value="<%= BUG_STATUS_CLOSED_ID %>" class="ctrl_radio_button"><span class="">Closed</span>
			<input id="bug_status" name="hid_status" type="hidden" value="<%= g_iStatusID %>">
		<% end if %>
		</td>
	</tr>
	
	<tr>
		<td class="table_label">Priority:</td>
		<td class="table_radio_button">
		<% if (bAllowBugEditing = false) then %>
			<%= strArrBugAttributes(1) %>
		<% else %>
			<input name="rdo_priority" onclick="document.getElementById('bug_priority').value = <%= BUG_PRIORITY_HIGH_ID %>;" type="radio" <%= IsChecked(g_iPriorityID, BUG_PRIORITY_HIGH_ID) %> value="<%= BUG_PRIORITY_HIGH_ID %>" class="ctrl_radio_button"><span style="color: red;">High</span>
			<input name="rdo_priority" onclick="document.getElementById('bug_priority').value = <%= BUG_PRIORITY_NORMAL_ID %>;" type="radio" <%= IsChecked(g_iPriorityID, BUG_PRIORITY_NORMAL_ID) %> value="<%= BUG_PRIORITY_NORMAL_ID %>" class="ctrl_radio_button" style="margin-left: 5px;"><span class="">Normal</span>
			<input name="rdo_priority" onclick="document.getElementById('bug_priority').value = <%= BUG_PRIORITY_LOW_UI_ID %>;" type="radio" <%= IsChecked(g_iPriorityID, BUG_PRIORITY_LOW_UI_ID) %> value="<%= BUG_PRIORITY_LOW_UI_ID %>" class="ctrl_radio_button" style="margin-left: 7px;"><span style="color: #f1c232;">Low</span>
			<% '= GetPopupHelpDB(7, OVERLIB_X_POS) %>
			<input id="bug_priority" name="hid_priority" type="hidden" value="<%= g_iPriorityID %>">
		<% end if %>
		</td>
	</tr>
	
	<tr>
		<td class="table_label">Type:</td>
		<td class="table_radio_button">
		<% if (bAllowBugEditing = false) then %>
			<%= strArrBugAttributes(2) %>
		<% else %>
			<input name="rdo_type" onclick="document.getElementById('bug_type').value = <%= BUG_TYPE_BUG_ID %>;" type="radio" <%= IsChecked(g_iTypeID, BUG_TYPE_BUG_ID) %>  value="<%= BUG_TYPE_BUG_ID %>" class="ctrl_radio_button"><span class="">Bug</span>
			<input name="rdo_type" onclick="document.getElementById('bug_type').value = <%= BUG_TYPE_FEATURE_REQUEST_ID %>;" type="radio" <%= IsChecked(g_iTypeID, BUG_TYPE_FEATURE_REQUEST_ID) %> value="<%= BUG_TYPE_FEATURE_REQUEST_ID %>" class="ctrl_radio_button" style="margin-left: 10px;"><span class="">Feature</span>
			<input name="rdo_type" onclick="document.getElementById('bug_type').value = <%= BUG_TYPE_GENERAL_ID %>;" type="radio" <%= IsChecked(g_iTypeID, BUG_TYPE_GENERAL_ID) %>  value="<%= BUG_TYPE_GENERAL_ID %>" class="ctrl_radio_button"  style="margin-left: 5px;"><span class="">General</span>
			<input id="bug_type" name="hid_bug_type" type="hidden" value="<%= g_iTypeID %>">
		<% end if %>
		</td>
	</tr>
	
	<tr>
		<td class="table_label">Owner:</td>
		<td>
		<%
		if (bAllowBugEditing = false) then
			%><%= GetUserFullName(g_iAssignedToUserID, true) %><% 
		else
			%><%= GetAssignedToUsersDropList() %><%
		end if 
		%>
		</td>
	</tr>
	
	
	<tr>
		<td class="table_label" style="vertical-align: top;">Bug Title:</td>
		<td>
		<% if (bAllowBugEditing = false) then %>
			<%= g_strTitle %>
		<% else %>
			<textarea id="bug_title" name="txt_title" onKeyDown="ResetTextboxBackground();" class="ctrl_textarea ctrl_textarea_small" style="overflow: auto;"><%= g_strTitle %></textarea><img src="images_icons/icon_required_field.png" class="icon_required" title="Required Field" alt="Required Field" style="padding: 0 0 20px 0;" />
			<!-- <input type="text" id="bug_title" name="txt_title" onKeyDown="ResetTextboxBackground();" value="<%= g_strTitle %>" maxlength="255" class="ctrl_textbox ctrl_textbox_medium"><%= ICON_REQUIRED_FIELD %> -->
		<% end if %>
		</td>
		<% if (g_strPageMode = LOG_BUG_MODE_NEW_ENTRY) then %>
		<td rowspan="13" class="bug_comments"></td>
		<% end if %>
	</tr>
	
	<tr>
		<td class="table_label" style="vertical-align: top;">Description:</td>
		<td>
		<% if (bAllowBugEditing = false) then %>
			<span style="display: block;" class="ctrl_textarea_large"><%= g_strDescription %></span>
		<% else %>
			<textarea id="bug_description" name="txt_description" class="ctrl_textarea ctrl_textarea_large"><%= g_strDescription %></textarea>
		<% end if %>
		</td>
	</tr>

	<% GetFileUploadHTML(bAllowBugEditing) %>
	
			
	<tr>
		<td class="table_label right_side_superscript">Project:</td>
		<td>
		<%
		'to allow a user to change the project here would mean the 'assign to' drop-list would need to refresh.
		'if (bAllowBugEditing = false) then
			 %><%= GetProjectName(g_iProjectID) %><%
		'else
		'	response.write GetLogBugProjectsDropList()
		'end if 
		%> <% '= GetPopupHelpDB(28, OVERLIB_X_POS) %>
		<input id="bug_project" name="drp_project" type="hidden" value="<%= g_iActiveProjectID %>">
		</td>
	</tr>
		
	<% if (NOT g_strPageMode = LOG_BUG_MODE_NEW_ENTRY) then %>

	<tr>
		<td class="table_label label_on_right">Logged by:</td>
		<td class="table_right_content"><%= g_strLoggedByUser %> on <%= Replace(DBDate(g_strDateLogged), " ", "/") %></td>
	</tr>
	
	<% if (g_iStatusID = BUG_STATUS_CLOSED_ID) then %>
	<tr>
		<td class="table_label label_on_right">Date closed:</td>
		<td><%= DBDate(g_strDateClosed) %></td>
	</tr>
	<% end if %>
	
	<% if (NOT	g_strApprovedByUser = "") then %>
	<tr>
		<td class="table_label label_on_right">Approved by:</td>
		<td><%= g_strApprovedByUser %></td>
	</tr>
	<% end if %>
	
	
	<% 
	'if (g_iStatusID = BUG_STATUS_CLOSED_ID OR NOT	g_strApprovedByUser = "") then
	'	strRtnValue = strRtnValue & "<tr><td colspan=""2"" style=""height: 4px;""></td></tr><tr>"
	'end if
										
	'if (g_iStatusID = BUG_STATUS_CLOSED_ID OR NOT	g_strApprovedByUser = "") then
	'	strRtnValue = strRtnValue & "</tr>"
	'end if
	%>
	
	<% end if %>
	
	
	<% 
	
	'these options are not available to client level accounts
	if (NOT g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_CLIENT) then 
	%>
	
	<tr>
		<td class="table_sub_headling" colspan="2"><br/><div class="section_divider"></div>Admin Options</td>
	</tr>		
	
	<tr>
		<td class="table_label">Time Estimate:</td>
		<td>
		<input id="time_estimate_textbox" type="text" name="txt_time_estimate" value="<%= g_strTimeEstimate %>" maxlength="16" class="ctrl_textbox ctrl_textbox_tiny"><% if (g_rsUserAccountDetails("must_leave_time_estimate") = INT_TRUE) then %><%= ICON_REQUIRED_FIELD %><% end if %>
		<span class="note">(Hours)</span>
		<div id="time_estimate_validation_msg" class="validation_msg" style="display: none; margin-top: 4px;"></div>
		</td>
	</tr>
		
	
	<tr>
		<td class="table_label">Cost $:</td>
		<td>
		  <input id="implementation_cost" type="text" <%= g_strApprovalDisabledStatus %> name="txt_implementation_cost" value="<%= g_strImplementationCost %>" maxlength="16" class="ctrl_textbox ctrl_textbox_tiny">
		</td>
	</tr>
	
	<tr>
		<td class="table_label"></td>
		<td>
		<input id="requires_client_approval" type="checkbox" <%= g_strApprovalDisabledStatus %> <%= SetCheckBox(g_iRequiresClientApproval) %> name="chk_requires_client_approval" value="1" class=""><span class="checkbox_text"">Requires approval</span>
		</td>
	</tr>	
	
	<tr>
		<td class="table_label"></td>
		<td>
		<input id="visible_to_client" type="checkbox" <%= SetCheckBox(g_iIsVisibleToClient) %> name="chk_visible_to_client" value="1" class="" ><span class="checkbox_text">Visible to client</span>
		</td>
	</tr>
	
	<% end if %>
	
	
	<% if ( (g_rsUserAccountDetails("id_user_account_type") = ACCOUNT_TYPE_ID_CLIENT) AND (NOT g_strImplementationCost = 0) ) then %>
	<tr>
		<td class="table_label">Cost $:</td>
		<td><%= FormatCurrency(g_strImplementationCost, 2) %> <span class="note_general">(requires approval)</span></td>
	</tr>
	<% end if %>


	
	<tr>
		<td></td>
		<td align="left" colspan="3" style="padding-top: 8px;"><% DrawLogBugButtonGroupHTML(bAllowBugEditing) %></td>
	</tr>
	
	</form>
	
	<%
		
End Function
'--------------------------------------------------------------------------------------------------------
Function GetFileUploadHTML(bAllowBugEditing)
 
 %>
	<script type="text/javascript">
	 
	function ValidateUploadFileType(strInputAcceptedFiles)	
	{
		
		var strUploadFileName;
		var strArrAcceptedFiles;
		var iCounter = 0;
		var bIsFileTypeValid = false; 
		
		strUploadFileName = document.getElementById("upload_file").value;
		strArrAcceptedFiles = strInputAcceptedFiles.split(",");

		if (strUploadFileName != '')
		{
			//find out if the file extension is in the accepted list.
			for (iCounter = 0; iCounter < strArrAcceptedFiles.length; iCounter++) 
			{
				if (strUploadFileName.indexOf( trim(strArrAcceptedFiles[iCounter]) ) != -1)
					bIsFileTypeValid = true;
			}
	
			//if the file extension is invalid, inform the user.
			if (bIsFileTypeValid != true)
			{
				//an invalid file type has been selected
				document.getElementById("upload_file_validation_msg").style.display = "inline";
				document.getElementById("save_button").style.display = "none";
				document.getElementById("save_button_disabled").style.display = "inline";				
				
				//document.getElementById("save_button").src = "images/btn_save_disabled.gif";
				//document.getElementById("save_button").disabled = "disabled";
				//document.getElementById("save_button").alt = "(Disabled - invalid upload file)";
				//document.getElementById("save_button").style.cursor = "default";
			}
			else
			{
				//the file to be uploaded has an approved file extension.
				document.getElementById("upload_file_validation_msg").style.display = "none";
				document.getElementById("save_button").style.display = "inline";
				document.getElementById("save_button_disabled").style.display = "none";				
				
				//document.getElementById("save_button").src = "images/btn_save.gif";
				//document.getElementById("save_button").disabled = "";
				//document.getElementById("save_button").alt = "";
				//document.getElementById("save_button").style.cursor = "hand";
			}
	
		}
		
		
	}
	
	</script>		
	<% 

	Dim strFileAttachment
	Dim strFileSize
	
	Dim bDrawFileUploadControls
	Dim bDrawAttachedFileLink
	Dim strAcceptedUploadFileTypes
	
	strAcceptedUploadFileTypes = GetSystemSetting(7)
	
	'if a file has already been uploaded, everyone is allowed to see it (but not necessarily modify it).
	if (g_strUploadFileName = "" OR IsNull(g_strUploadFileName) ) then
		bDrawFileUploadControls = true
		bDrawAttachedFileLink = false
	else
		bDrawFileUploadControls = false
		bDrawAttachedFileLink = true
	end if

	'the user may not be allowed to edit the upload file (i.e. they didnt log it), but they still need to see it if it exists
	if (bAllowBugEditing = false) then
		bDrawFileUploadControls = false
	end if

	'the users account level may not allow uploading of files.
	if (g_iAccessPrivUploadFiles = INT_FALSE) then
		bDrawFileUploadControls = false
	end if
	

	'draw a hyperlink to the attached file
	if (bDrawAttachedFileLink = true) then
		strFileSize = "<span class=""file_size"">(" & GetAttachmentFileSize(g_strUploadFileName, g_strUploadDirectory) & ")</span> "
		strFileAttachment = "<a href=""" & g_strUploadDirectory & g_strUploadFileName & """  title=""" & g_strUploadFileName & """ target=""_blank"">" & TruncateString(g_strUploadFileName, 30) & "</a> " & strFileSize
		
		'only people allowed to edit the bug can delete the file
		if (bAllowBugEditing = true) then
			strFileAttachment = strFileAttachment & "<a href=""javascript: ConfirmDeleteFileAttachment();"" class=""icon_hyperlink"" title=""Delete file attachment"">" & ICON_DELETE_SMALL & "</a> "
		end if
		%>
		<tr>
			<td class="table_label">Attached File:</td>
			<td class="table_right_content"><%= strFileAttachment %></td>
			<input id="upload_file" name="hid_upload_file" type="hidden" value=""><!-- required for validation JS to work -->
		</tr>
		<%
	end if
	
	'draw controls for uploading a new file
	if (bDrawFileUploadControls = true) then
		%>
		<tr>
			<td class="table_label" style="vertical-align: top;"><div style="padding: 6px 0 0 0;">Upload&nbsp;File:</div></td>
			<td>
			<div id="upload_file_control" class="fileinputs">
			<input onpropertychange="ValidateUploadFileType('<%= strAcceptedUploadFileTypes %>');" id="upload_file" name="file" type="file" /><%= GetPopupHelpDB(6, OVERLIB_X_POS) %>
			</div>
			<div id="upload_file_validation_msg" class="validation_msg" style="display: none;margin: 4px 0 0 0; width: 265px;">Wrong file type (allowed files: <%= strAcceptedUploadFileTypes %>).</div>
			</td>
		</tr>
		<%
	end if
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetAttachmentFileSize(strInputFileName, strInputFolderName)
	
	Dim strRtnValue
	Dim strPathTranslated
	Dim strFullPath

	strPathTranslated = Request.ServerVariables("PATH_TRANSLATED")
	strFullPath = Left(strPathTranslated, (Len(strPathTranslated) - Len( GetPageName() ))) & strInputFolderName & "\"
			
	if (DoesFileExist(strFullPath, Replace(strInputFileName, vbCrLf, "")) = 1) then
		strRtnValue = GetFileSizeGeneric(strFullPath & Replace(strInputFileName, vbCrLf, ""))
		strRtnValue = TreatFileSize(strRtnValue)
	else
		strRtnValue = "<i>(File Not Found)</i>"
	end if
				
	GetAttachmentFileSize	= strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawLogBugButtonGroupHTML(bInputAllowBugEditing)
	
	'if the user isnt allowed to edit the bug, all buttons must be disabled
	if (bInputAllowBugEditing = false) then
		%>
		<div class="ctrl_button_small_disabled ctrl_float button_spacer" title="Update (Disabled)">Update</div>
		<%= GetApprovalButton() %>
		<div class="ctrl_button_small_disabled ctrl_float button_spacer button_icon_delete button_icon_delete_disabled" title="Delete (Disabled)" style="margin-left: 5px;">Delete</div>
		<a href="<%= g_strPageName %>?save_operation=0" class="image_button cancel_link">Cancel</a>

		<% 
		exit function
	end if

	'SAVE/UPDATE BUTTON
	if (g_strPageMode = LOG_BUG_MODE_EDIT) then
		%><div class="ctrl_button_small ctrl_float button_spacer" style="margin-left: 0px;"><a href="javascript:void();" onclick="ValidateLogBugForm(); return false;">Update</a></div><% 
	elseif (g_strPageMode = EDIT_COMMENT) then
		%><div class="ctrl_button_small_disabled ctrl_float button_spacer" title="Update (Disabled)"  style="margin-right: 5px;">Update</div><% 
	else
		%><div id="save_button" class="ctrl_button_small ctrl_float button_spacer" style="margin-left: 0px;"><a href="javascript:void();" onclick="ValidateLogBugForm(); return false;">Save</a></div><% 
		%><div id="save_button_disabled" class="ctrl_button_small_disabled ctrl_float button_spacer" title="Save (Disabled)" style="display: none; margin-right: 5px;">Save</div><% 		
	end if


	'APPROVE BUTTON
	%><%= GetApprovalButton() %><%

		
	'DELETE BUTTON		
	if (g_strPageMode = LOG_BUG_MODE_EDIT) then
		%><div class="ctrl_button_small ctrl_float button_spacer button_icon_delete"><a href="javascript:void();" onclick="ConfirmBugSoftDelete();; return false;">Delete</a></div><% 
	else
		%><div class="ctrl_button_small_disabled ctrl_float button_spacer button_icon_delete_disabled" title="Delete (Disabled)" style="margin-left: 5px;">Delete</div><% 
	end if
	
	'CANCEL link
	%><a href="<%= g_strPageName %>?save_operation=0&bug_id=<%= g_strBugID %>" class="image_button cancel_link">Cancel</a><%  
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetApprovalButton()
	
	Dim strRtnValue
	
	if ( (g_iRequiresClientApproval = INT_FALSE) OR (NOT g_strApprovedByUser = "") OR (g_iAccessPrivCanApproveCosts = INT_FALSE) ) then
		'the approve button will be disabled
		strRtnValue = "<div class=""ctrl_button_small_disabled ctrl_float button_spacer"" title=""Approve (Disabled)"">Approve</div>"
	else

		'a user has to go through a javascript confirmation if there is a cost associated with the bug/feature.
		if (NOT g_strImplementationCost = 0) then
			strRtnValue = "<div class=""ctrl_button_small ctrl_float button_spacer""><a href=""javascript:void();"" onclick=""ConfirmApprovalWithCost();"">Approve</a></div>"
		else
			strRtnValue = "<div class=""ctrl_button_small ctrl_float button_spacer""><a href=""javascript:void();"" onclick=""document.getElementById('log_bug_form').action = '" & g_strPageName & "?save_operation=1&page_mode=" & LOG_BUG_MODE_APPROVE & "&bug_id=" & g_strBugID & "'; document.getElementById('log_bug_form').submit();"">Approve</a></div>"
		end if
		
	end if
	
	GetApprovalButton = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetAssignedToUsersDropList()

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	Dim strUserName
	Dim strDropListHeader
	Dim strDropListFooter

	Dim iPreSelectedUserID
	Dim strClientOnlySQL
	
	'by default, for developer and admin level users, the droplist starts with the assigned project manager pre-selected
	if (g_iAssignedToUserID = "") then
		iPreSelectedUserID = g_rsActiveProject("id_user_project_manager")
	else
		'the bug is in edit mode
		iPreSelectedUserID = g_iAssignedToUserID
	end if		

	strDropListHeader = "<select size=""1"" id=""assigned_to_user"" name=""drp_assigned_to_user"" class=""ctrl_drop_list ctrl_drop_list_medium"">" & vbCrLf
	strDropListFooter = "</select>" & vbCrLf

	'only users associated with the project can be assigned a bug from that project (makes sense right?).
	strSqlQuery = "SELECT tbl_users.id_user, tbl_users.first_name, tbl_users.last_name, tbl_users.initials, tbl_user_account_types.account_type_name, tbl_users.account_is_active, tbl_user_to_project_mapping.id_project " & _
								"FROM (tbl_users INNER JOIN tbl_user_account_types ON tbl_users.id_user_account_type = tbl_user_account_types.id_user_account_type) INNER JOIN tbl_user_to_project_mapping ON tbl_users.id_user = tbl_user_to_project_mapping.id_user " & _
								"WHERE (((tbl_users.account_is_active)=1) AND ((tbl_users.has_been_deleted)=0) AND ((tbl_user_to_project_mapping.id_project)= " & g_iActiveProjectID & ")) " & _
								"ORDER BY tbl_users.first_name;"
	
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	Do Until objRecordSet.EOF

		if (g_iAccessPrivShowFullNames = INT_TRUE) then
			strUserName = objRecordSet("first_name") & " " & objRecordSet("last_name") 
		else
			strUserName = objRecordSet("initials")
		end if
		
		strUserName = strUserName & " (" & objRecordSet("account_type_name") & ")"
		strRtnValue = strRtnValue & "<option " & IsSelected(objRecordSet("id_user"), iPreSelectedUserID) & " value=""" & objRecordSet("id_user") & """>" & strUserName & "</option>" & vbCrLf
		objRecordSet.MoveNext
	Loop
				
	objRecordSet.Close
	Set objRecordSet = Nothing
		
	GetAssignedToUsersDropList = strDropListHeader & strRtnValue & strDropListFooter

End Function
'--------------------------------------------------------------------------------------------------------
Function GetProjectName(iInputProjectID)

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	if (iInputProjectID = "") then
		iInputProjectID = g_rsActiveProject("id_project")
	end if
	
	strSqlQuery = "SELECT project_name, project_code FROM tbl_projects WHERE id_project = " & iInputProjectID
		
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (NOT objRecordSet.EOF) then
		strRtnValue = objRecordSet("project_name") & " <sup class=""superscript_subtle"">" & objRecordSet("project_code") & "</span>"
	else
		strRtnValue = "<b>Error:</b> could not determine project name."
	end if
	
	GetProjectName = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GetLogBugProjectsDropList()

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	Dim strProjectName
	Dim strInactiveMarker
	Dim iPreSelectedProjectID
	
	Dim strDropListHeader
	Dim strDropListFooter
	
	'pre-select whatever project is the currently active project
	if (g_iProjectID = "") then
		iPreSelectedProjectID = g_rsActiveProject("id_project")
	else
		'this means a bug is being edited
		iPreSelectedProjectID = g_iProjectID
	end if	
		
	strDropListHeader = "<select id=""bug_project"" size=""1"" name=""drp_project"" class=""control_drop_list_medium"">" & vbCrLf
	strDropListFooter = "</select>" & vbCrLf
	
	'the drop-list will only be filled with projects that the user has been associated with via the user page.
	strSqlQuery = "SELECT id_project, project_name, project_code, project_is_active " & _
								"FROM tbl_projects " & _
								"WHERE (has_been_deleted = 0) AND (id_project IN (" & GetAssociatedProjectIDs() & " ) )" & _
								"ORDER BY project_name;"
	
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	Do Until objRecordSet.EOF
		if (objRecordSet("project_is_active") = INT_FALSE) then
			strInactiveMarker = " *Inactive*"
		else
			strInactiveMarker = ""
		end if
		strProjectName = objRecordSet("project_name") & " (" & objRecordSet("project_code") & ")" & strInactiveMarker
		strRtnValue = strRtnValue & "<option " & IsSelected(objRecordSet("id_project"), iPreSelectedProjectID) & " value=""" & objRecordSet("id_project") & """>" & strProjectName & "</option>" & vbCrLf
		objRecordSet.MoveNext
	Loop
				
	objRecordSet.Close
	Set objRecordSet = Nothing
		
	GetLogBugProjectsDropList = strDropListHeader & strRtnValue & strDropListFooter

End Function
'--------------------------------------------------------------------------------------------------------
%>