<!-- Projects (22062008) -->
<% 
const PROJECTS_PAGE_MODE_EDIT = "1"
const PROJECTS_PAGE_MODE_READY_FOR_NEW = "2"
const PROJECTS_PAGE_MODE_SOFT_DELETE = "3"
const PROJECTS_PAGE_MODE_UPDATE = "4"
const PROJECTS_PAGE_MODE_INSERT = "5"
const PROJECTS_PAGE_MODE_EDIT_ACTIVE_PROJECT = "6"

Dim g_strSaveOperation
Dim g_strPageMode
Dim g_strEditProjectID

Dim g_iProjectID
Dim g_strProjectName
Dim g_strProjectCode

Dim g_iProjectManagerID
Dim g_strProjectDescription
Dim g_iProjectIsActive

Dim g_strDateCreated
Dim g_bIsFirstProject
 
'--------------------------------------------------------------------------------------------------------
Function ProjectsPageStartUp()

	g_strPageMode = Request.Form("hid_mode")

	'check if this is the first project being created (possibly due to a fresh install)
	if (g_strActiveProjectName = "Project Unknown") then
		g_bIsFirstProject = true
	else
		g_bIsFirstProject = false
	end if

	if (NOT Request.QueryString("mode") = "") then
		g_strPageMode = Request.QueryString("mode")
	end if	
	
	g_strSaveOperation = Request.QueryString("save_operation")
	g_strEditProjectID = Request.Form("drp_existing_project")

End Function
'--------------------------------------------------------------------------------------------------------
Function SaveNewProjectToDb()

	Dim strSqlQuery
	Dim objRecordSet
	Dim strDateCreated
	
	Dim iNewlyCreatedProjectID
	
	strDateCreated = Request.Form("drp_day") & Request.Form("drp_month") & Request.Form("drp_year")
	
	strSqlQuery = "INSERT INTO tbl_projects " & _
								"(project_name, project_code, project_description, project_is_active, id_user_project_manager, date_created) " & _
								"VALUES " & _
								"('" & MakeTextDBSafeUpdate(Request.Form("txt_project_name")) & "', '" & _
								     MakeTextDBSafeUpdate(Request.Form("txt_project_code")) & "', '" & _										 
								     MakeTextDBSafeUpdate(Request.Form("txt_project_description")) & "', " & _
								     CInt(MakeTextDBSafeUpdate(Request.Form("rdo_project_active"))) & ", " & _
								     CInt(MakeTextDBSafeUpdate(Request.Form("drp_project_manager")))& ", '" & _	 
								     strDateCreated & "' " & _										 
								");"

	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)
	
	'if this is the first project being created, then the current user needs to be associated with it ('causes login problems otherwise).
	if (g_bIsFirstProject = true) then
		iNewlyCreatedProjectID = GetNewlyAddedRecordID()
		SetFirstProjectToUserAssociation(iNewlyCreatedProjectID)
		'set the cookie for the active project
		Call CreateCookie(COOKIE_NAME, iNewlyCreatedProjectID & "|" & g_iUserID, 12)
	end if

End Function
'--------------------------------------------------------------------------------------------------------
Function SetFirstProjectToUserAssociation(iInputNewlyAddedProjectID)

	Dim strSqlQuery
	Dim objRecordSet

	strSqlQuery = "INSERT INTO tbl_user_to_project_mapping (id_user, id_project) " & _
							  "VALUES (" & g_iUserID & ", " & iInputNewlyAddedProjectID & ");"
								
	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetProjectDetails(iInputProjectID)

	Dim strSqlQuery
	Dim objRecordSet
	
	strSqlQuery = "SELECT * FROM tbl_projects WHERE id_project = " & iInputProjectID
		
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (NOT objRecordSet.EOF) then
		g_iProjectID = objRecordSet("id_project")
		g_strProjectName = objRecordSet("project_name")
		g_strProjectCode = objRecordSet("project_code")
		g_iProjectManagerID = objRecordSet("id_user_project_manager")
		g_strProjectDescription = objRecordSet("project_description")
		g_iProjectIsActive = objRecordSet("project_is_active")
		g_strDateCreated = objRecordSet("date_created")
	end if
	
	objRecordSet.Close
	Set objRecordSet = Nothing
	
End Function
'--------------------------------------------------------------------------------------------------------
Function SoftDeleteProject(strInputProjectID)

	Dim strSqlQuery
	Dim objRecordSet
				
	strSqlQuery = "UPDATE tbl_projects SET has_been_deleted = 1 WHERE id_project = " & strInputProjectID
	
	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function UpdateProjectDetailsToDb()

	Dim strSqlQuery
	Dim objRecordSet
	Dim strDateCreated
	
	strDateCreated = Request.Form("drp_day") & Request.Form("drp_month") & Request.Form("drp_year")
				
	strSqlQuery = "UPDATE tbl_projects SET " & _
								"project_name = '" & MakeTextDBSafeUpdate(Request.Form("txt_project_name")) & "', " & _
								"project_code = '" & MakeTextDBSafeUpdate(Request.Form("txt_project_code")) & "', " & _
								"project_description = '" & MakeTextDBSafeUpdate(Request.Form("txt_project_description")) & "', " & _
								"project_is_active = " & Request.Form("rdo_project_active") & ", " & _
								"date_created = '" & strDateCreated & "', " & _								
								"id_user_project_manager = " & Request.Form("drp_project_manager") & " " & _
						    "WHERE id_project = " & Request.Form("hid_project_id")
	
	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function GetProjectPageName()
	
	Dim strRtnValue
	
	Select Case g_strPageMode

		Case PROJECTS_PAGE_MODE_EDIT
			strRtnValue = "<span class=""page_sub_mode_heading"">Edit Project</span>"
			GetProjectDetails(g_strEditProjectID)	
		
		case PROJECTS_PAGE_MODE_UPDATE
			strRtnValue = "<span class=""page_sub_mode_heading"">Create Project</span>"
			UpdateProjectDetailsToDb()
		
		case PROJECTS_PAGE_MODE_INSERT
			strRtnValue = "<span class=""page_sub_mode_heading"">Create Project</span>"
			SaveNewProjectToDb()
		
		Case PROJECTS_PAGE_MODE_SOFT_DELETE
			strRtnValue = "<span class=""page_sub_mode_heading"">Create Project</span>"
			SoftDeleteProject(Request.Form("hid_project_id"))
			
		Case PROJECTS_PAGE_MODE_EDIT_ACTIVE_PROJECT
			strRtnValue = "<span class=""page_sub_mode_heading"">Edit Project</span>"
			GetProjectDetails(g_iActiveProjectID)	
		
		Case Else
			strRtnValue = "<span class=""page_sub_mode_heading"">Create Project</span>"
	
	End Select
	
	GetProjectPageName = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function FillExistingProjectsDropList()

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	Dim strProjectName
	Dim strInactiveMarker
	
	strSqlQuery = "SELECT id_project, project_name, project_code, project_is_active FROM tbl_projects " & _
								"WHERE (has_been_deleted = 0) ORDER BY project_name;"
	
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	Do Until objRecordSet.EOF
		if (objRecordSet("project_is_active") = INT_FALSE) then
			strInactiveMarker = " *Inactive*"
		else
			strInactiveMarker = ""
		end if
		strProjectName = objRecordSet("project_name") & " (" & objRecordSet("project_code") & ")" & strInactiveMarker
		strRtnValue = strRtnValue & "<option " & IsSelected(objRecordSet("id_project"), g_strEditProjectID) & " value=""" & objRecordSet("id_project") & """>" & strProjectName & "</option>" & vbCrLf
		objRecordSet.MoveNext
	Loop
				
	objRecordSet.Close
	Set objRecordSet = Nothing
		
	FillExistingProjectsDropList = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function FillProjectManagerDropList(iInputSelectedOption)

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	'return a list of all users who arent clients (i.e. developers and admin).
	strSqlQuery = "SELECT id_user, first_name + ' ' + last_name AS full_name FROM tbl_users " & _
								"WHERE (account_is_active = 1) AND (NOT (id_user_account_type) = 1) AND (has_been_deleted = 0) ORDER BY first_name, last_name;"
	
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	Do Until objRecordSet.EOF
		strRtnValue = strRtnValue & "<option " & IsSelected(iInputSelectedOption, objRecordSet("id_user")) & " value=""" & objRecordSet("id_user") & """>" & objRecordSet("full_name") & "</option>" & vbCrLf
		objRecordSet.MoveNext
	Loop
				
	objRecordSet.Close
	Set objRecordSet = Nothing
		
	FillProjectManagerDropList = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawProjectsHeaderHTML()

  %>
	<% DrawSaveSuccessfulHTML(g_strSaveOperation) %>
	<div style="clear: both;"></div>
	<table>
	<td class="heading_bug_list" colspan="2" style="padding: 10px 0 10px 0;">Projects</td>

	
	<form method="post" id="project_form" action="<%= g_strPageName %>" name="frm_edit_project" style="display:inline;">
	<tr>
		<td class="table_label">Edit project:</td>
		<td align="left">
		<select id="existing_project_drop_list" class="ctrl_drop_list ctrl_drop_list_medium ctrl_float" name="drp_existing_project" onchange="ResetDropList('existing_project_drop_list', 'existing_project_validation_msg');">
			<option value="0">(Select project)</option>
			<%= FillExistingProjectsDropList() %>
		</select>
		<div class="ctrl_button_small ctrl_float button_spacer" style="margin: 2px 0 0 5px;"><a href="javascript:void();" onclick="ValidateDropList('existing_project_drop_list', 'existing_project_validation_msg', 'project_form'); return false;">Edit</a></div>
		<div id="existing_project_validation_msg" class="validation_msg" style="display: none;">You forgot to select a project.</div>
		</td>
	</tr>
	<input type="hidden" name="hid_mode" value="<%= PROJECTS_PAGE_MODE_EDIT %>">
	</form>
	
	<tr>
		<td class="heading_bug_list" colspan="4" align="left"><div class="section_divider"></div><%= GetProjectPageName() %></td>
	</tr>
	<% 
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawProjectsHTML()

	Dim strProjectActiveRadioButtonCheckStateYes
	Dim strProjectActiveRadioButtonCheckStateNo
	
	'this is required so the radio button default is set for new projects to be active.
	if (NOT Trim(g_iProjectIsActive) = "") then
		strProjectActiveRadioButtonCheckStateYes = IsChecked(g_iProjectIsActive, 1)
		strProjectActiveRadioButtonCheckStateNo = IsChecked(g_iProjectIsActive, 0)
	else
		strProjectActiveRadioButtonCheckStateYes = " checked " 
		strProjectActiveRadioButtonCheckStateNo = ""
	end if

	%>

	<form method="post" id="edit_project_form" action="<%= g_strPageName %>?save_operation=1" name="frm_project" style="display:inline;">
	<tr>
		<td class="table_label">Project is active:</td>
		<td>
		<input type="radio" value="1" <%= strProjectActiveRadioButtonCheckStateYes %> name="rdo_project_active" class="form_control_radio_button"><span class="form_control_radio_button_text">Yes</span>
		<input type="radio" value="0" <%= strProjectActiveRadioButtonCheckStateNo %> name="rdo_project_active" class="form_control_radio_button"><span class="form_control_radio_button_text">No</span><%= GetPopupHelpDB(20, OVERLIB_X_POS) %>
			<% if (NOT Trim(g_iProjectID) = "") then %><span class="tiny_text" style="padding: 0 0 0 160px;">ID: <%= g_iProjectID %></span><% end if %>
		</td>
	</tr>	
	<tr>
		<td class="table_label">Project name:</td>
		<td><input type="text" id="project_name_textbox" name="txt_project_name" onkeydown="ResetTextboxBackground('project_name_textbox');" value="<%= g_strProjectName %>" maxlength="96" class="ctrl_textbox ctrl_textbox_medium"><%= ICON_REQUIRED_FIELD %></td>
	</tr>

	<tr>
		<td class="table_label">Project manager:</td>
		<td>
		<select size="1" id="project_manager_drop_list" onchange="ResetDropList('project_manager_drop_list', 'project_manager_validation_msg');" class="ctrl_drop_list ctrl_drop_list_medium ctrl_float" name="drp_project_manager">
			<option value="0">(Select project manager)</option>
			<%= FillProjectManagerDropList(g_iProjectManagerID) %>
		</select><%= ICON_REQUIRED_FIELD %>
		<%= GetPopupHelpDB(21, OVERLIB_X_POS) %>
		<div id="project_manager_validation_msg" class="validation_msg" style="display: none;">Please select a project manager.</div>
		</td>
	</tr>
	
		<tr>
		<td class="table_label">Project code:</td>
		<td>
		<input type="text" id="project_code_textbox" name="txt_project_code" onkeydown="ResetTextboxBackground('project_code_textbox');" value="<%= g_strProjectCode %>" size="20" maxlength="4" class="ctrl_textbox ctrl_textbox_small"><%= ICON_REQUIRED_FIELD %>
		<%= GetPopupHelpDB(2, OVERLIB_X_POS) %>
		</td>
	</tr>
	
	<tr>
		<td class="table_label">Project description:</td>
		<td><textarea rows="4" name="txt_project_description" class="ctrl_textarea ctrl_textarea_medium"><%= g_strProjectDescription %></textarea></td>
	</tr>
	<tr>
		<td class="table_label">Date created:</td>
		<td><%= GetDropListDateControl(g_strDateCreated, "") %></td>
	</tr>
	<tr>
		<td class="table_label"></td>
		<td style="height: 50px;">
		<% if (g_strPageMode = PROJECTS_PAGE_MODE_EDIT) then %>
		
			<div class="ctrl_button_small ctrl_float button_spacer" style="margin-left: 0px;"><a href="javascript:void();" onclick="ValidateProjectsForm(); return false;">Update</a></div>
			<div class="ctrl_button_small ctrl_float button_spacer_right button_icon_delete"><a href="javascript:void();" onclick="document.getElementById('hid_mode').value='<%= PROJECTS_PAGE_MODE_SOFT_DELETE %>'; document.getElementById('edit_project_form').submit();">Delete</a></div>
			<input type="hidden" value="<%= PROJECTS_PAGE_MODE_UPDATE %>" name="hid_mode" id="hid_mode">

		<% else %>
		
			<div class="ctrl_button_small ctrl_float button_spacer" style="margin-left: 0px;"><a href="javascript:void();" onclick="ValidateProjectsForm(); return false;">Save</a></div>
			<div class="ctrl_button_small_disabled ctrl_float button_spacer button_icon_delete_disabled" title="Delete (Disabled)">Delete</div>
			<input type="hidden" value="<%= PROJECTS_PAGE_MODE_INSERT %>" name="hid_mode" id="hid_mode">
			
		<% end if %>
		
		<a href="<%= g_strPageName %>?save_operation=0" class="image_button"" style="margin: 5px 0 0 7px; float: left;">Cancel</a>
		
		</td>
	</tr>
	<input type="hidden" name="hid_project_id" value="<%= g_iProjectID %>">
	</form>
	<%  

		
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawProjectsFooterHTML()
	
	%>
	</table>
	<%  

End Function
'--------------------------------------------------------------------------------------------------------
%>