<!-- Settings (08072007) -->
<% 
const SETTINGS_PAGE_MODE_SYSTEM_SETTINGS = "3"
const SETTINGS_PAGE_MODE_ACCESS_PRIVILEGES = "4"
const SETTINGS_PAGE_MODE_MAPPING_GROUPS = "5"
const SETTINGS_PAGE_MODE_MAPPING_ITEMS = "6"

Dim g_strIconBullet
Dim g_strPageMode
Dim g_strSaveOperation
 
'--------------------------------------------------------------------------------------------------------
Function SettingPageStartUp()

	g_strPageMode = Request.QueryString("mode")
	g_strIconBullet = "&bull;"
	g_strSaveOperation = Request.QueryString("save_operation")
	
	if (g_strSaveOperation = STR_TRUE) then
		SaveSettingsToDb()
	end if

End Function
'--------------------------------------------------------------------------------------------------------
Function SaveSettingsToDb()

	Dim strArrFormVariables
	Dim iArrSplitPartOne
	Dim iArrSplitPartTwo	
	
	Dim strDbFieldName
	Dim iUpdateValue
	Dim iRecordID

	Dim iCounter
	
	'get all posted form variables and split them based on the '&' delimiter
	strArrFormVariables = Split(Request.Form, "&")
	
	'need to reset (or 'zero out') all access privilege values because '0' (or unchecked) can't be posted by the form.
	ResetAllAccountPrivilegeValues()
	
	For iCounter = 0 To UBound(strArrFormVariables) 'originally this had a -2 on it (like this: 'UBound(strArrFormVariables)-2'). i'm not sure why this was here, but it was causing a save bug (i.e. the last two items werent being saved
		
		'the values sent via form varialbes need to be split apart further.
		iArrSplitPartOne = Split(strArrFormVariables(iCounter) ,".")
		iArrSplitPartTwo = Split(iArrSplitPartOne(1), "=")
	
		strDbFieldName = iArrSplitPartOne(0)
		iUpdateValue = CInt(iArrSplitPartTwo(1)) 'not used. seems to cause data-type related problems
		iRecordID = CInt(iArrSplitPartTwo(0))

		Call UpdateAccountPrivilegeValue(strDbFieldName, iRecordID)
		
	Next

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawSettingsHeaderHTML()

  %>
	<table>
	<tr>
		<td colspan="4"><% DrawSaveSuccessfulHTML(g_strSaveOperation) %></td>
	</tr>	
	<tr>
		<td class="heading_bug_list" colspan="4"><%= GetSettingsPageName() %></td>
	</tr>

	<% 
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawSettingsListHTML()

  %>
	<tr>
		<td colspan="4">&nbsp;</td>
	</tr>	
	<tr>
		<td class="hyperlink_list" colspan="4"><img src="images_icons/icon_system_config.png" class="icon_standard" alt="Icon" /> <a href="system_configuration.asp">System Configuration</a> <%= GetPopupHelpDB(25, OVERLIB_X_POS) %></td>
	</tr>
	<tr>
		<td class="hyperlink_list" colspan="4"><img src="images_icons/icon_email.png" class="icon_standard" alt="Icon" /> <a href="email_settings.asp">Email Settings</a> <%= GetPopupHelpDB(33, OVERLIB_X_POS) %></td>
	</tr>
	<tr>
		<td class="hyperlink_list" colspan="4"><img src="images_icons/icon_access.png" class="icon_standard" alt="Icon" /> <a href="settings.asp?mode=<%= SETTINGS_PAGE_MODE_ACCESS_PRIVILEGES %>">Access Privileges</a> <%= GetPopupHelpDB(5, OVERLIB_X_POS) %></td>
	</tr>
	<% 
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawSettingsFooterHTML()

	%>
	</table>
	<%  

End Function
'--------------------------------------------------------------------------------------------------------
Function UpdateAccountPrivilegeValue(strInputDbFieldName, iInputRecordID)
	
	Dim strSqlQuery
	Dim objRecordSet
				
	strSqlQuery = "UPDATE [tbl_account_access_privileges] SET " & strInputDbFieldName & " = 1 " & _
						    "WHERE [id_account_access_privilege] = " & iInputRecordID

	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function ResetAllAccountPrivilegeValues()
	
	Dim strSqlQuery
	Dim objRecordSet
	
	strSqlQuery = "SELECT [tbl_account_access_privileges].id_account_access_privilege FROM [tbl_account_access_privileges];"

	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	Do Until objRecordSet.EOF
		ResetAccountPrivilegeValue(objRecordSet("id_account_access_privilege"))
		objRecordSet.MoveNext
	Loop
				
	objRecordSet.Close
	Set objRecordSet = Nothing	

End Function
'--------------------------------------------------------------------------------------------------------
Function ResetAccountPrivilegeValue(iInputRecordID)

	Dim strSqlQuery
	Dim objRecordSet
				
	strSqlQuery = "UPDATE [tbl_account_access_privileges] SET " & _
								"enabled_for_client = 0 , enabled_for_developer	= 0, enabled_for_admin = 0 " & _
							  "WHERE [id_account_access_privilege] = " & iInputRecordID
		
	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function  GetSettingsPageName()
	
	Dim strRtnValue
	
	Select Case g_strPageMode
				
		Case SETTINGS_PAGE_MODE_ACCESS_PRIVILEGES
			strRtnValue = "Settings" & ARROW_SECTION_DIVIDER & "<span style=""color: #8e8d8d; font-weight: normal;"">Access Privileges</span>"

		Case Else
			strRtnValue = "Settings"
	
	End Select
	
	GetSettingsPageName = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function RenderPageBasedOnMode()
	
	Select Case g_strPageMode
				
		Case SETTINGS_PAGE_MODE_ACCESS_PRIVILEGES
			DrawAccountAccessPrivilegesHTML()

		Case Else
			DrawSettingsListHTML()
	
	End Select
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetAccountAccessGroupName(iInputGroupID)
	
	Dim strRtnValue
	Dim objRecordSet
	Dim strSqlQuery
		
	strSqlQuery = "SELECT tbl_one_to_one_mapping_items.item_name AS Group_Name FROM " & _
								"tbl_one_to_one_mapping_items INNER JOIN tbl_account_access_privileges ON " & _
								"tbl_one_to_one_mapping_items.id_item = tbl_account_access_privileges.id_belongs_to_group " & _
								"WHERE id_item = " & iInputGroupID

	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (objRecordSet.EOF) then
		strRtnValue = "Error: group name not found based on supplied ID."
	else
		strRtnValue = objRecordSet("Group_Name")
	end if
		
	objRecordSet.Close
	Set objRecordSet = Nothing	
	
	GetAccountAccessGroupName = strRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawAccountAccessPrivilegesHTML()
	
	Dim strRtnValue
	Dim objRecordSet
	Dim strSqlQuery
	
	Dim iSettingClient
	Dim iSettingDeveloper
	Dim iSettingAdmin
	Dim iSettingID
	
	Dim strPreviousGroupName
	Dim strCurrentGroupName

	Dim strInsertBR

	
	strSqlQuery = "SELECT [tbl_account_access_privileges].* FROM [tbl_account_access_privileges] ORDER BY id_belongs_to_group, display_order;"

	Set objRecordSet = GetRecordSet(strSqlQuery)
			
	%>
	<form method="post" action="<%= g_strPageName %>?mode=<%= SETTINGS_PAGE_MODE_ACCESS_PRIVILEGES %>&save_operation=1" name="frm_settings" id="access_privileges_form" style="display:inline;">
		<tr><td colspan="4">&nbsp;</td></tr>
	<tr>
		<td class="item_list_table" align="right">&nbsp;</td>
		<td class="item_list_table" align="center">Client</td>
		<td class="item_list_table" align="center">&nbsp;&nbsp;<span title="Developer" class="tool_tip">Dev.</span>&nbsp;&nbsp;</td>
		<td class="item_list_table" align="center">Admin.</td>
	</tr>
	<%  
		
	Do Until objRecordSet.EOF

		strCurrentGroupName = GetAccountAccessGroupName(objRecordSet("id_belongs_to_group"))

		if (NOT strPreviousGroupName = strCurrentGroupName) then
			%>
			<tr>
			<td class="table_sub_headling" colspan="2"><%= strInsertBR %><div class="section_divider"></div><%= strCurrentGroupName %></td>
			</tr>			
			<%  		
			strInsertBR = "<br/>"
		end if
		
		iSettingClient = objRecordSet("enabled_for_client")
		iSettingDeveloper = objRecordSet("enabled_for_developer")
		iSettingAdmin	= objRecordSet("enabled_for_admin")
		iSettingID = objRecordSet("id_account_access_privilege")
		%>
		<tr>
			<td class="table_label"><%= objRecordSet("privilege_name") %>:</td>
			<td align="center"><input type="checkbox" <%= SetCheckBox(iSettingClient) %> name="enabled_for_client.<%= iSettingID %>" value="<%= iSettingClient %>"></td>
			<td align="center"><input type="checkbox" <%= SetCheckBox(iSettingDeveloper) %> name="enabled_for_developer.<%= iSettingID %>" value="<%= iSettingDeveloper %>"></td>
			<td align="center"><input type="checkbox" <%= SetCheckBox(iSettingAdmin) %> name="enabled_for_admin.<%= iSettingID %>" value="<%= iSettingAdmin %>"></td>
		</tr>
		<%  
		objRecordSet.MoveNext
		strPreviousGroupName = strCurrentGroupName

	Loop
	
	%>
	<tr>
		<td></td>
		<td align="left" colspan="3" style="padding-top: 8px; padding-left: 10px;">

		<div class="ctrl_button_small ctrl_float button_spacer" style="margin-left: 0px;"><a href="javascript:void();" onclick="document.getElementById('access_privileges_form').submit();">Save</a></div>
		<a href="<%= g_strPageName %>?save_operation=0&mode=4" class="image_button"" style="margin: 5px 0 0 7px; float: left;">Cancel</a>
		
		</td>
	</tr>
	</form>
	<%  
	
	objRecordSet.Close
	Set objRecordSet = Nothing	
		
	DrawAccountAccessPrivilegesHTML = strRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------
%>