<% OPTION EXPLICIT %>
<!-- Login (17122013) -->

<!--#include file="include\global_constants.inc"-->
<!--#include file="include\global_constants_images.inc"-->
<!--#include file="include\db_connection.asp"-->
<%

Dim g_iLoginStatus
Dim g_iLoginUserID
Dim g_iIsFirstLogin

Dim g_bInvalidLoginAttempt
Dim g_bCookiesAreEnabled
Dim g_strControlInitialState

Dim g_bAccountIsInactive
Dim g_strClearCookies

Dim g_strTechSupportEmail

'-------------------------------------------------------------------------------------------------------

LoginPageStartUp()

ProcessLoginAttempt()

DrawLoginBoxHTML()

'-------------------------------------------------------------------------------------------------------
Function LoginPageStartUp()

	g_bCookiesAreEnabled = true 'AreCookiesEnabled() '<- we now assume that cookies will be enabled
	g_strClearCookies = AntiCrossSiteScriptingHack(Request.QueryString("clear_cookies"))

	g_strTechSupportEmail	= GetTechSupportEmail()
	
	if (g_strClearCookies = "1") then
		ClearSystemCookies()
	end if

End Function
'-------------------------------------------------------------------------------------------------------
Function QStr(strQueryStringName)

	Dim strRtnValue
	
	strRtnValue = Request.QueryString(strQueryStringName)
	
	'sql injection protection
	strRtnValue = Replace(strRtnValue, "tbl_", "")
	strRtnValue = Replace(strRtnValue, "id_", "")	
	
	QStr = strRtnValue

End Function
'-------------------------------------------------------------------------------------------------------
Function AntiCrossSiteScriptingHack(strInputString)

	Dim strRtnValue

	strRtnValue = Server.HtmlEncode(strInputString)

	AntiCrossSiteScriptingHack = strRtnValue

End Function
'-------------------------------------------------------------------------------------------------------
Function SanitizeData(strInputValue)

	Dim strRtnValue :	Dim regEx
		
	'Create a regular expression object
	Set regEx = New RegExp

	'The global property tells the RegExp engine to find ALL matching substrings, instead of just the first instance. We need this to be true.
	regEx.Global = true

	'Our pattern tells us what to find in the string... In this case, we find anything that isn't a numerical character, 
	'or a lowercase or uppercase alphabetic character
	regEx.Pattern = "[^0-9a-zA-Z]"

	'Use the replace function of RegExp to clean the username. The replace function takes the string to search (using the Pattern above as the 
	'search criteria), and the string to replace any found strings with. In this case, we want to replace our matches with nothing (''), 
	'as the matching characters will be the ones we don't want in our username.
	strRtnValue = regEx.Replace(strInputValue, "") 
	
	SanitizeData = strRtnValue

End Function
'------------------------------------------------------------------------------------------------------------------------
Function GetTechSupportEmail()

	Dim strRtnValue :	Dim objRecordSet : Dim strSqlQuery
	
	strRtnValue = "tech support"
			
	strSqlQuery = "SELECT setting_value FROM tbl_system_configuration WHERE id_system_configuration = 40;"
		
	Set objRecordSet = Server.CreateObject("ADODB.recordset")
	Call objRecordSet.Open(strSqlQuery, g_objDbConn)
	
	if (NOT objRecordSet.EOF) then
	
		if (trim(objRecordSet("setting_value")) <> "") then
			strRtnValue = "<a href=""mailto:" & objRecordSet("setting_value") & "?subject=BugWeb: I've lost my password"">tech support</a>"
		end if

	end if
	
	objRecordSet.Close : Set objRecordSet = Nothing	
	
	GetTechSupportEmail = strRtnValue

End Function
'------------------------------------------------------------------------------------------------------------------------
Function ClearSystemCookies()

	Response.Cookies("bugweb_active_project_id").Expires = Now()
	
End Function
'------------------------------------------------------------------------------------------------------------------------
Function GetPageName() 'get the name of the current page
	
	Dim strTempPageName

	strTempPageName = Split(Request.ServerVariables("SCRIPT_NAME"),"/")

	GetPageName = strTempPageName(UBound(strTempPageName))

End Function
'-------------------------------------------------------------------------------------------------------
Function AreCookiesEnabled()

	Dim bRtnValue :	Dim bProcessWithCookieCheck
	
	bProcessWithCookieCheck = true

	'if someone has submitted a login attempt, it must mean cookies are on since the username/passwod textboxes are enabled.
	if (AntiCrossSiteScriptingHack(Request.Querystring("login_attempt")) = "1") then
		bProcessWithCookieCheck = false
		bRtnValue = true 'cookies are on
	end if

	if (bProcessWithCookieCheck = true) then
	
		If (AntiCrossSiteScriptingHack(Request.Querystring("cookies_enabled")) = "") Then
			Session("cookietest") = "1"
			
			if (AntiCrossSiteScriptingHack(Request.QueryString("clear_cookies")) = "1") then
				Response.Redirect("login.asp?cookies_enabled=1&clear_cookies=1")
			else
				Response.Redirect("login.asp?cookies_enabled=1")
			end if
			
		Else

			If (Session("cookietest")) Then 'cookies are on
				bRtnValue = true
			Else 'cookies are off
				bRtnValue = false
				g_strControlInitialState = " disabled "
			End If

		End If	
	
	End if
		
	AreCookiesEnabled = bRtnValue

End Function
'-------------------------------------------------------------------------------------------------------
Function ProcessLoginAttempt()

	if (NOT Trim(Request.Form("login_username")) = "") then '<- only start processing if the user has provided a username

		g_iLoginStatus = VerifyUser()
	
		if g_iLoginStatus = LOGIN_GOOD then
			CreateSecurityCookie()
			SendToSecureArea()
			g_bInvalidLoginAttempt = false
		else
			g_bInvalidLoginAttempt = true
		end if

	end if

End Function
'-------------------------------------------------------------------------------------------------------
Function GetLoginErrorMessage() 

	Dim strArrRtnValue(1)
	
	if (g_bAccountIsInactive = true) then
		strArrRtnValue(0) = "There's a problem :("
		strArrRtnValue(1) = "Looks like your account is inactive or has been disabled."
	else
		strArrRtnValue(0) = "PANIC! Bad Login :("
		strArrRtnValue(1) = "The username or password you entered seem to be wrong. Try again, if it still doesn't work, contact " & g_strTechSupportEmail & "."
	end if
	
	GetLoginErrorMessage = strArrRtnValue

End Function
'-------------------------------------------------------------------------------------------------------
Function DrawInvalidLoginBoxHTML() 

	Dim strArrLoginErrorMessage
	
	strArrLoginErrorMessage = GetLoginErrorMessage()

	if (g_bInvalidLoginAttempt = true) then
 	%>
 	<br>
	<table border="0" cellpadding="0" cellspacing="0" width="350">
	<tr>
		<td><img src="images_layout/dialogue_corner_top_left.png" alt="" /></td>
		<td style="border-top: solid 1px #a7a7a7;">&nbsp;</td>
		<td><img src="images_layout/dialogue_corner_top_right.png" alt="" /></td>
	</tr>
	
	<tr>
		<td style="border-left: solid 1px #a7a7a7;">&nbsp;</td>
		<td style="padding-bottom: 10px;"><img src="images_icons/icon_alert.png" class="icon_standard" alt="Alert" /><span class="sub_heading"><%= strArrLoginErrorMessage(0) %></span></td>
		<td style="border-right: solid 1px #a7a7a7;">&nbsp;</td>
	</tr>		
	<tr>
		<td style="border-left: solid 1px #a7a7a7;">&nbsp;</td>
		<td style="text-align: left;"><%= strArrLoginErrorMessage(1) %></td>
		<td style="border-right: solid 1px #a7a7a7;">&nbsp;</td>
	</tr>		
	<tr>
		<td><img src="images_layout/dialogue_corner_bottom_left.png" alt="" /></td>
		<td style="border-bottom: solid 1px #a7a7a7;">&nbsp;</td>
		<td><img src="images_layout/dialogue_corner_bottom_right.png" alt="" /></td>
	</tr>
	</table>
	<% 
	end if

End Function
'-------------------------------------------------------------------------------------------------------
Function DrawLoginBoxHTML()

	Dim strUsernamePrefill : Dim strPasswordPrefill
	
	strUsernamePrefill = QStr("u") : strPasswordPrefill = QStr("p")	

	%>
	<!DOCTYPE html>
	<html data-env='production' lang='en' xml:lang='en'>
	
	<html>
	<head>
			
		<meta http-equiv="content-type" content="text/html;charset=utf-8" />
		
		<title>BugWeb: Login</title>
		
		<link rel="shortcut icon" href="favicon.ico" >
		<link rel="stylesheet" type="text/css" href="css/login.css">
		<script language="JavaScript" src="javascript/overlib.js"></script>
		<script language="JavaScript" src="javascript/login.js"></script>
				
	</head>
	
	<body>
		
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr>
		<td align="center">

	<% if (g_strClearCookies = "1") then %>
	<img id="clear_cookies_icon" src="images/icon_circle_tick_green.gif" width="14" height="14" alt="Cookies cleared successfully" style="vertical-align: middle; margin-right: 3px;"><span class="note">Cookies cleared.</span>
	<div style="padding-bottom: 5px;"></div>
	<% end if %>
	<form name="<%= LOGIN_FORM %>" id="login_form" action="<%= GetPageName() %>?login_attempt=1" method="post">
	<div style="background:url('images_layout/dialogue_background_330.png') center center no-repeat; padding: 10px;">
	
	<table border="0" cellpadding="0" cellspacing="0>
	
	<tr>
		<td colspan="4">&nbsp;</td>
	</tr>
	<tr>
		<td></td>
		<td colspan="2" style="padding: 0 0 0 20px;"><div class="major_heading"><img src="images_layout/bugweb_small_logo.png" alt="Logo" class="bugweb_logo_small"/>BugWeb<img src="images_layout/version_marker.png" alt="" /></div></td>
		<td></td>
	</tr>
	<tr>
		<td></div></td>
		<td align="right">Username:</td>
		<td><input type="text" value="<%= strUsernamePrefill %>" id="login_username_textbox" <%= g_strControlInitialState %> style="margin-left: 5px; width: 150px; background-repeat: no-repeat; background-position: left;" onkeydown="ResetTextboxBackground('login_username_textbox');" size="15" name="login_username" class="ctrl_textbox" maxlength="64"><%= ICON_REQUIRED_FIELD %></td>
		<td></td>
	</tr>
	<tr>
		<td></td>
		<td align="right">Password:</td>
		<td><input type="password" value="<%= strPasswordPrefill %>" id="login_password_textbox" <%= g_strControlInitialState %> style="margin-left: 5px; width: 150px; background-repeat: no-repeat; background-position: left;" onkeydown="ResetTextboxBackground('login_password_textbox');" size="15" name="login_password" class="ctrl_textbox" maxlength="64"><%= ICON_REQUIRED_FIELD %></td>
		<td></td>
	</tr>	
	<tr>
		<td></td>
		<td style="padding: 9px 0 0 20px;"><a href="javascript:void;" OnClick="javascript:ExpandElement(); return false;"><img src="images_icons/icon_help.png" alt="Icon" /></a></td>
		<td><input type="submit" id="go_button" name="btn_go" onclick="ValidateLoginForm(); return false;" value="Login" class="ctrl_button" style="margin: 10px 0 0 5px;" <%= g_strControlInitialState %>/></td>
		<td></td>
	</tr>		
	<tr>
		<td colspan="4">&nbsp;</td>
	</tr>
	
	</table>
	
	</div>
	</form>
	
	<% DrawInvalidLoginBoxHTML() %>
	
	<br>
	
	<div style="display: none;" id="expanding_element">
	<table border="0" cellpadding="0" cellspacing="0" width="370">
	<tr>
		<td><img src="images_layout/dialogue_corner_top_left.png" alt="" /></td>
		<td style="border-top: solid 1px #a7a7a7;">&nbsp;</td>
		<td><img src="images_layout/dialogue_corner_top_right.png" alt="" /></td>
	</tr>
	
	<tr>
		<td style="border-left: solid 1px #a7a7a7;">&nbsp;</td>
		<td style="padding-bottom: 12px;">
		<span class="sub_heading" style="float: left;">Lost Passwords</span>
		<span style="float: right;"><a href="" style="border: none;" OnClick="javascript:ExpandElement(); return false;"><img src="images_icons/icon_close.png" alt="Icon" /></a></span>
		</td>
		<td style="border-right: solid 1px #a7a7a7;">&nbsp;</td>
	</tr>		
	<tr>
		<td style="border-left: solid 1px #a7a7a7;">&nbsp;</td>
		<td style="text-align: left;">
		If you have lost your password, you can recover it by emailing <%= g_strTechSupportEmail %>.
		<div style="padding-bottom: 8px;"></div>
		
		In your email, be sure to provide your name.
		<div style="padding-bottom: 8px;"></div>
		
		Your password will then be sent to the email address that is associated with your account.
		<div style="padding-bottom: 4px; margin-top: 8px; border-top: 1px dotted #cccccc;"></div>
		
		<span style="font-size: 11px;">Trouble-shooting: <a href="login.asp?clear_cookies=1">clear cookies</a></span>
		<div style="padding-bottom: 3px;"></div>
		
		</td>
		<td style="border-right: solid 1px #a7a7a7;">&nbsp;</td>
	</tr>		
	<tr>
		<td><img src="images_layout/dialogue_corner_bottom_left.png" alt="" /></td>
		<td style="border-bottom: solid 1px #a7a7a7;">&nbsp;</td>
		<td><img src="images_layout/dialogue_corner_bottom_right.png" alt="" /></td>
	</tr>
	</table>
	</DIV>
		<% DrawCookiesWarningMessage() %>
		</td>
	</tr>
	
	</table>
	
	
	</body>
	</html>
	
	<%

End Function
'-------------------------------------------------------------------------------------------------------
Function DrawCookiesWarningMessage()

	if (g_bCookiesAreEnabled = INT_FALSE) then
		%>
		<img src="images/icon_exclaim.gif" style="margin-bottom: 3px;" width="16" height="16" alt="Warning" border="0" align="absmiddle"> 
		<b>Warning:</b> <a href="" onclick="return false;" onmouseover="overlib('<i>Cookies</i> are a method by which web browsers \'maintain state\' or, put more simply, remember where you are or what your settings are.', CAPTION, 'Help: Cookies');" onmouseOut="nd();">cookies</a> seem to be disabled. 
		<div style="padding-bottom: 5px;"></div>
		You will not be able to use the system properly if cookies are turned off.
		<div style="padding-bottom: 5px;"></div>
		Find out how to turn cookies on in <a href="images/enable_cookies_in_firefox.png">Firefox</a> or <a href="images/enable_cookies_in_internet_explorer_6.png">Internet Explorer 6</a>.
		<div style="padding-bottom: 5px;"></div>
		If your cookies settings are correct, you may <a href="" onclick="ForceEnableLoginBox(); return false;">force enable the login box</a>.
		<%  
	end if

End Function
'-------------------------------------------------------------------------------------------------------
Function VerifyUser()

	'check database to see if the user is allowed to login.
	Dim strSqlQuery
	Dim rsUserDetails
	Dim iUserVerified
	
	strSqlQuery = "SELECT id_user, is_first_login, account_is_active " & _
								"FROM tbl_users WHERE " & _
								"(has_been_deleted = 0) AND " & _
								"(login_username ='" & SanitizeData(Request.Form("login_username")) & "') AND " & _
								"(user_password ='" & SanitizeData(Request.Form("login_password")) & "');"

	Set rsUserDetails = Server.CreateObject("ADODB.recordset")
	Call rsUserDetails.Open(strSqlQuery, g_objDbConn)
								
	'if the recordset is not empty, it means the user was verified.
	if (NOT rsUserDetails.EOF) then
	
		if (rsUserDetails("account_is_active") = 0) then
			'the user account exists, but the account has been marked as inactive
			iUserVerified = LOGIN_BAD
			g_bAccountIsInactive = true
		else
			g_iLoginUserID = rsUserDetails("id_user")
			iUserVerified = LOGIN_GOOD
			g_iIsFirstLogin = rsUserDetails("is_first_login")
		end if
	else
		iUserVerified = LOGIN_BAD
	end if
	
	VerifyUser = iUserVerified
	
End Function
'-------------------------------------------------------------------------------------------------------
Function CreateSecurityCookie()

	Response.Cookies("user_id") = g_iLoginUserID

	'expire cookie (in two months; DateAdd("m", 2, Date), or in two hours DateAdd("h", 1, Date & " " & Time) )
	Response.Cookies("user_id").Expires = DateAdd("m", 2, Date & " " & Time)

End Function
'-------------------------------------------------------------------------------------------------------
Function SetFirstLoginFlagToFalse()

	Dim strSqlQuery
	Dim objRecordSet

	strSqlQuery = "UPDATE tbl_users SET is_first_login = 0 WHERE id_user = " & g_iLoginUserID

	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'-------------------------------------------------------------------------------------------------------
Function SendToSecureArea()

	'if (g_iIsFirstLogin = 1) then 
		'if its the users first time logging in, offer to show them the training videos first.
	'	SetFirstLoginFlagToFalse()
	'	DrawTrainingVideosHTML()
	'else
		Response.Redirect "index.asp"
	'end if

End Function
'-------------------------------------------------------------------------------------------------------
Function DrawTrainingVideosHTML()

 	%>
	<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
	
	<html>
	<head>
		<title><%= APP_NAME %>: Login</title>
		
		<style>
		td {
		  font-family: Verdana;
		  font-size: 11px;
			color: #262626;
		}
		
		.sub_heading {
		  font-family: Verdana;
		  font-size: 11px;
		  font-weight: bold;
		  color: #717168;
		}
		
		.major_heading	{
		  font-family: Verdana;
		  font-size: 14px;
		  font-weight: bold;
		  color: #61615a;
		}
		
		.control_textbox	{
		  font-family: Verdana;
		  font-size: 11px;
		}
		
		.control_button	{
		  font-family: Verdana;
		  font-size: 10px;
			font-weight: normal;
			color: #262626;
		}
		
		.note {
		  font-family: Verdana;
		  font-size: 10px;
		  color: #ADADAD;
		}
		
		a:link {
		  font-family: Verdana;
		  font-size: 11px;
		  color: #6a8fed;	
		  text-decoration: none;
		  border-bottom: 1px dotted #6a8fed;
		}
		
		a:visited {
		  font-family: Verdana;
		  font-size: 11px;
		  color: #6a8fed;
		  text-decoration: none;
		  border-bottom: 1px dotted #6a8fed;  
		}
		
		a:active {
		  font-family: Verdana;
		  font-size: 11px;
		  color: #6a8fed;	
		  text-decoration: none;
		  border-bottom: 1px dotted #6a8fed;  
		}
		
		a:hover {
		  font-family: Verdana;
		  font-size: 11px;
		  color: #0048ff;
		  text-decoration: none; 
		  border-bottom: 1px dotted #0048ff;  
		}
		
		.note_block {
			background-image: url('images/icon_note.gif');
			background-repeat: no-repeat;
			background-position: left top;
			font-family: Verdana;
		  font-size: 10px;
		  color: #ADADAD;
			padding-top: 0px;
			padding-bottom: 1px;	
			padding-left: 22px;
			padding-right: 2px;	
			display: block;
		}

		</style>
				
	</head>
	
	<body topmargin="0" leftmargin="0">

	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr>
		<td align="center">

	<table border="0" cellpadding="0" cellspacing="0" width="345">
	<tr>
		<td style="background: transparent url(images/dialogue_corner_top_left.gif) no-repeat; width: 15px; height: 15px;"></td>
		<td style="border-top: solid 1px #a7a7a7;">&nbsp;</td>
		<td style="border-top: solid 1px #a7a7a7;">&nbsp;</td>
		<td style="background: transparent url(images/dialogue_corner_top_right.gif) no-repeat; width: 15px; height: 15px;"></td>
	</tr>
	<tr>
		<td style="border-left: solid 1px #a7a7a7;">&nbsp;</td>
		<td style="padding-bottom: 10px;"><SPAN class="major_heading">Welcome to <i>BugWeb</i></SPAN></td>
		<td></td>
		<td style="border-right: solid 1px #a7a7a7;">&nbsp;</td>
	</tr>
	<tr>
		<td style="border-left: solid 1px #a7a7a7;">&nbsp;</td>
		<td colspan="2">
		If this is the first time you are logging into the system, please take some time to watch a tutorial video;
		<div style="padding-bottom: 10px;"></div>

		<% DrawTrainingVideoListHTML() %>
		<div style="padding-bottom: 20px;"></div>
		Go to <a href="index.asp">BugWeb</a>.
		<div style="padding-bottom: 15px;"></div>
		<SPAN class="note_block">You can access tutorual videos at a later stage via the 'Online Help' section.</SPAN>
		</td>
		<td style="border-right: solid 1px #a7a7a7; height: 22px;">&nbsp;</td>
	</tr>
	<tr>
		<td style="background: transparent url(images/dialogue_corner_bottom_left.gif) no-repeat; width: 15px; height: 15px;"></td>
		<td style="border-bottom: solid 1px #a7a7a7;">&nbsp;</td>
		<td style="border-bottom: solid 1px #a7a7a7;">&nbsp;</td>
		<td style="background: transparent url(images/dialogue_corner_bottom_right.gif) no-repeat; width: 15px; height: 15px;""></td>
	</tr>
	</table>

		</td>
	</tr>
	</table>
		
	</body>
	</html>
	<%

End Function
'-------------------------------------------------------------------------------------------------------
Function GetStreamingVideoURL()

	Dim strRtnValue
	Dim objRecordSet
	Dim strSqlQuery
	
	strSqlQuery = "SELECT setting_value FROM tbl_system_configuration WHERE id_system_configuration = 37;"
	Set objRecordSet = Server.CreateObject("ADODB.recordset")
	Call objRecordSet.Open(strSqlQuery, g_objDbConn)

	if (objRecordSet.EOF) then
		response.write "<b>Error:</b> the system could not determine the streaming video URL."
		response.end
	else
		strRtnValue = objRecordSet("setting_value") 
	end if
	
	GetStreamingVideoURL = strRtnValue

End Function
'-------------------------------------------------------------------------------------------------------
Function DrawTrainingVideoListHTML()
	
	Dim objRecordSet
	Dim strSqlQuery
	Dim strVideoStreamingURL
	
	strVideoStreamingURL = GetStreamingVideoURL()
	
	strSqlQuery = "SELECT * FROM tbl_tutorial_videos WHERE (offer_on_first_login = 1) ORDER BY display_order;"

	Set objRecordSet = Server.CreateObject("ADODB.recordset")
	Call objRecordSet.Open(strSqlQuery, g_objDbConn)
	
	Do Until objRecordSet.EOF
		%>
		<div style="padding-bottom: 5px;"></div>
		<a onclick="var popup1=window.open('video_streaming_player.asp?id_video=<%= objRecordSet("id_training_video") %>&streaming_url=<%= strVideoStreamingURL %>','popup1','width=2,height=2,toolbar=no,menubar=no,resizable=1,menubar=no,status=no,scrollbars=no,screenX=100,screenY=100,top=100,left=100'); popup1.focus(); return false" href="video_streaming_player.asp" title="<%= objRecordSet("video_title") %>" target="_blank"><%= objRecordSet("video_title") %></a> <span class="note">(<%= objRecordSet("video_duration") %>)</span>
		<%  
		objRecordSet.MoveNext
	Loop
	
	objRecordSet.Close
	Set objRecordSet = Nothing

End Function
'-------------------------------------------------------------------------------------------------------
%>
