<!-- Global Common Functions v1.1 (16082006) -->
<%

const STR_TRUE = "1"
const STR_FALSE = "0"

const BOOL_TRUE = 1
const BOOL_FALSE = 0

'------------------------------------------------------------------------------------------------------------------------
Function TruncateStringIcon(strInputString, iInputMaxStringLength)

	Dim strRtnTreatedString
	
	if InStr(strInputString, ".gif") = 0 then
			
		if Len(strInputString) > iInputMaxStringLength then
			strRtnTreatedString = Left(strInputString, (iInputMaxStringLength - 3)) & "&nbsp;<img border=""0"" src=""images/icon_truncated_string_three_dots.gif"" width=""18"" height=""9"" alt=""" & strInputString & """>"
		else																																								
			strRtnTreatedString = strInputString
		end if

		TruncateStringIcon = strRtnTreatedString
	else
		
		'this allows icon images to appear in the existing item list (eg. disabled icon).
		TruncateStringIcon = strInputString

	end if

End Function
'--------------------------------------------------------------------------------------------------------
Function TruncateString(strInputString, iInputMaxStringLength)

	Dim strRtnValue

	if (Len(strInputString) > iInputMaxStringLength) then
		strRtnValue = Left(strInputString, (iInputMaxStringLength - 3)) & "..."
	else																																								
		strRtnValue = strInputString
	end if

	TruncateString = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function SentenceCase(strInputString)

	Dim strRtnValue
	
	strRtnValue = UCase(Left(strInputString, 1)) & Right(LCase(strInputString), Len(strInputString)-1 )
	
	SentenceCase = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function TCase(strInputValue)
		
	Dim strRtnValue
	
	strRtnValue = ConvertToTitleCase(strInputValue)
		
	TCase = strRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------
Function ConvertToTitleCase(strInput)

	Dim iStringLength, strArrString, iCounter, strTitleCaseString

	iStringLength = Len(strInput)
	ReDim strArrString(iStringLength)
	
	For iCounter = 0 to iStringLength
	
		if iCounter = 0 then
			'convert the first letter for the string to uppercase
			strArrString(iCounter) = UCase(Mid(strInput, iCounter + 1, 1))
		elseif strArrString(iCounter - 1) = " " then
			'convert the letter to uppercase if it comes after a space
			strArrString(iCounter) = UCase(Mid(strInput, iCounter + 1, 1))
		else
			'leave the letter in lowercase
			strArrString(iCounter) = Mid(strInput, iCounter + 1, 1)
		end if

	Next

	'move the array of characters to a proper string
	For iCounter = 0 to iStringLength
		strTitleCaseString = strTitleCaseString & strArrString(iCounter)
	Next
	
	ConvertToTitleCase = strTitleCaseString

End Function
'------------------------------------------------------------------------------------------------------------------------
Function FriendlyNameToolbox(strInputFileName)

	Dim strFriendlyNameToolbox
	Dim strTemp
	
	strTemp = Replace(strInputFileName,"_", " ")
	strTemp = Replace(strInputFileName,"-", " ")
	
	strTemp = Left(strTemp, (Len(strTemp)) )
	
	strFriendlyNameToolbox = ConvertToTitleCase(strTemp)
		
	'return the friendly file name (eg.' about_us.inc' has become 'About Us')
	FriendlyNameToolbox = strFriendlyNameToolbox

End Function
'------------------------------------------------------------------------------------------------------------------------
Function CheckForHash(strInputHexColour)

	'this function makes sure the colour string is a properly formed hex number (including a hash at the start).
	Dim strRtnValue
	
	if Not Left(strInputHexColour,1) = "#" then
		strRtnValue = "#" & strInputHexColour
	else
		strRtnValue = strInputHexColour
	end if
	
	CheckForHash = strRtnValue

End Function
'------------------------------------------------------------------------------------------------------------------------
Function CreateUniqueNumber()

	Dim iRtnValue, iRandomNumber, iTimeNumber
		
	iRandomNumber = GetRandIntRange(1, 32000)
	iTimeNumber = hour(Time()) & minute(Time()) & second(Time())
	
	iRtnValue =	iRandomNumber * iTimeNumber
	CreateUniqueNumber = iRtnValue
	
End Function
'------------------------------------------------------------------------------------------------------------------------
Function CopyFile(strInputFileToCopy, strInputNewFilePathAndName)

	Dim objFileSystem, objCopyFile
	set objFileSystem = Server.CreateObject("Scripting.FileSystemObject")
	set objCopyFile = objFileSystem.GetFile(strInputFileToCopy)
	objCopyFile.Copy(strInputNewFilePathAndName)
	set objCopyFile = nothing
	set objFileSystem = nothing

End Function
'------------------------------------------------------------------------------------------------------------------------
Sub Delay(DelaySeconds)

	'SPECIAL NOTE: think carefully before using this function as it uses a lot of server processing cycles.
	
	'produces a delay
	SecCount = 0
	Sec2 = 0
	
	While SecCount < DelaySeconds + 1
		Sec1 = Second(Time())
		If Sec1 <> Sec2 Then
			Sec2 = Second(Time())
			SecCount = SecCount + 1
		End If
	Wend 
	
End Sub
'------------------------------------------------------------------------------------------------------------------------
Function DoesFileExist(strInputFilePath, strInputFileName)

	Dim iRtnValue, objFileExistCheck
	
	'first check that the file really exists (trying to delete something that isnt there causes an error).
	Set objFileExistCheck=Server.CreateObject("Scripting.FileSystemObject")

	If (objFileExistCheck.FileExists(strInputFilePath & strInputFileName)) = true Then
  	iRtnValue = 1
	Else
  	iRtnValue = 0
	End If

	Set objFileExistCheck = Nothing
	
	DoesFileExist = iRtnValue

End Function
'------------------------------------------------------------------------------------------------------------------------
Function DeleteFile(strInputFileName, strInputFilePath)

	Dim iFileExists

	'first check that the file actually exists, otherwise 'DEEEAATH!'
	iFileExists = DoesFileExist(strInputFilePath, strInputFileName)

	'delete the file only if its found to exist.
	if iFileExists = 1 then
	
		'delete the users image.
		dim objFileSystem, objFile
	
		Set objFileSystem= Server.CreateObject("Scripting.FileSystemObject")
		Set objFile = objFileSystem.GetFile(strInputFilePath & strInputFileName)

		objFile.Delete
	
		'resource clean-up
		Set objFile = Nothing
		Set objFileSystem = Nothing

	end if
	
End Function
'------------------------------------------------------------------------------------------------------------------------
Function TreatDataType(strInputValue)

	Dim strRtnValue

	if IsDate(strInputValue) = True Then
		strRtnValue = Day(strInputValue) & "-" & MonthName(Month(strInputValue), true) & "-" & Year(strInputValue)
	else
		strRtnValue = strInputValue
	end if

	TreatDataType = strRtnValue

End Function

'------------------------------------------------------------------------------------------------------------------------
Function DBSafe(strInputText)

	Dim strRtnValue
	
	'this is just a wrapper function so i can use the shorter function name DBSafe()
	strRtnValue = MakeTextDBSafeUpdate(strInputText)
	
	DBSafe = strRtnValue 

End Function
'------------------------------------------------------------------------------------------------------------------------
Function MakeTextDBSafeUpdate(strInputText)

	Dim strRtnValue, strSafeText
	Dim bIsDBString
	
	strInputText = Trim(strInputText)

	'figure out if an item is a string
	if (Left(strInputText, 1) = "'") AND (Right(strInputText, 1) = "'") then
		bIsDBString = BOOL_TRUE
	else
		bIsDBString = BOOL_FALSE
	end if
	
	'replace apostrophies with double apostrophies
	strSafeText = Replace(strInputText, "'", "''")
		
	'replace quote marks with nothing
	strSafeText = Replace(strSafeText, Chr(34), "")

	if bIsDBString = BOOL_TRUE then
		'remove the apostraphy at the start and end of the string. this indicates to the db that its a string
		strSafeText = Right(strSafeText, Len(strSafeText)-1)
		strRtnValue = Left(strSafeText, Len(strSafeText)-1)
	else
		strRtnValue = strSafeText
	end if
	
	MakeTextDBSafeUpdate = strRtnValue 

End Function
'------------------------------------------------------------------------------------------------------------------------
Function GetPageURL(strInputSectionName)

	Dim strURL
	
	if LCase(strInputSectionName) = "welcome" then
		strURL = "index.asp"
	elseif LCase(strInputSectionName) = "home" then
		strURL = "index.asp"		
	else
		strURL = Replace(LCase(strInputSectionName)," ","_") & ".asp"
	end if
	
	GetPageURL = strURL

End Function
'------------------------------------------------------------------------------------------------------------------------
Function GetPageName()

	'get the name of the current page
	Dim strTempPageName

	strTempPageName = Split(Request.ServerVariables("SCRIPT_NAME"),"/")
	
	GetPageName = strTempPageName(UBound(strTempPageName))

End Function
'------------------------------------------------------------------------------------------------------------------------
Function GetBrowserType()
	
	Dim strRtnValue
	
	'purpose: detects what kind of browser the visitor is using
	if InStr(request.servervariables("HTTP_USER_AGENT"), "MSIE") = 0 then
		strRtnValue = "NN"
	else
		strRtnValue = "IE"
	end if

	GetBrowserType = strRtnValue
	
End Function
'------------------------------------------------------------------------------------------------------------------------
Function GetRandIntRange(iInputMinRange, iInputMaxRange, bPrefixWithZero)
	
	Dim iRtnValue
	
	randomize()
	
	iRtnValue = Int((iInputMaxRange - iInputMinRange + 1) * Rnd + iInputMinRange)

	iRtnValue = CInt(iRtnValue)
	
	if (bPrefixWithZero = true) then
	
		' used to prefix the number with a zero for the sake of file names (eg. image_01.jpg vs image_1.jpg).
		if CStr(Len(iRtnValue)) = 1 then
			iRtnValue = CStr("0" & iRtnValue)
		end if
		
	end if
	
	GetRandIntRange = iRtnValue
	
End Function
'------------------------------------------------------------------------------------------------------------------------
Function GetCookie(strInputCookieName)
	
	Dim strRtnValue

	'read back the cookie
	strRtnValue = Request.Cookies(strInputCookieName)
	
	GetCookie = strRtnValue

End Function
'------------------------------------------------------------------------------------------------------------------------
Function CreateCookie(strInputCookieName, strInputCookieValue, iInputMonthsBeforeExpires)

	Response.Cookies(strInputCookieName) = strInputCookieValue

	'expire cookie in how many months.
	Response.Cookies(strInputCookieName).Expires = DateAdd("m", iInputMonthsBeforeExpires, Date)

End Function
'------------------------------------------------------------------------------------------------------------------------
Function DrawWebsiteOfflinePage(strInputOfflineReason)

	%>
	<html>
	<head>
		<title>Website Currently Offline</title>
	</head>
	<body>
	
	<table border="0" width="100%"cellspacing="0" cellpadding="0" height="100%">
	<tr>
		<td align="center">
	
	<table border="1" cellpadding="5" bordercolor="#C0C0C0" bordercolorlight="#C0C0C0" bordercolordark="#C0C0C0" bgcolor="#F3F3F3">
	<tr>
		<td>
			<b><font face="Verdana">Website Currently Offline</font></b><br>
		</td>
		</tr>
	</table>
	
		</td>
	</tr>
	</table>
	
	</body>
	</html>
	<% 

End Function
'------------------------------------------------------------------------------------------------------------------------
%>